PRINT '--'
PRINT '-- Create Script for dbscript version dbs 103'
PRINT '-- script generator by dbscript 1.03 07.09.2010 12:31:08'
PRINT '--'

PRINT 'CREATE TABLE Acknowledgement'
CREATE TABLE dbo.Acknowledgement (
    OID [int] IDENTITY (1, 1) NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   Url nvarchar(1024) COLLATE Latin1_General_CI_AS NOT NULL
,   Description nvarchar(1024) COLLATE Latin1_General_CI_AS NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Acknowledgement_Created'
ALTER TABLE [dbo].[Acknowledgement]
    ADD CONSTRAINT [DF_Acknowledgement_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE Branch'
CREATE TABLE dbo.Branch (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Proj_OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   BeginDate datetime NULL
,   Br_OID_Parent [int] NULL
,   EndDate datetime NULL
,   Br_OID_Merge [int] NULL
,   User_OID [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Branch_Created'
ALTER TABLE [dbo].[Branch]
    ADD CONSTRAINT [DF_Branch_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE CodeSnippet'
CREATE TABLE dbo.CodeSnippet (
    OID [int] IDENTITY (1, 1) NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   [Script] ntext COLLATE Latin1_General_CI_AS NOT NULL
,   User_OID [int] NOT NULL
,   DBE_OID [int] NULL
,   IsRecordset [bit] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_CodeSnippet_IsRecordset'
ALTER TABLE [dbo].[CodeSnippet]
    ADD CONSTRAINT [DF_CodeSnippet_IsRecordset] DEFAULT (1) FOR [IsRecordset]
GO
PRINT 'CREATE DEFAULT DF_CodeSnippet_Created'
ALTER TABLE [dbo].[CodeSnippet]
    ADD CONSTRAINT [DF_CodeSnippet_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE ColumnName'
CREATE TABLE dbo.ColumnName (
    OID [int] IDENTITY (1, 1) NOT NULL
,   ObjN_OID [int] NOT NULL
,   [ID] nvarchar(128) COLLATE Latin1_General_CI_AS NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_ColumnName_Created'
ALTER TABLE [dbo].[ColumnName]
    ADD CONSTRAINT [DF_ColumnName_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE Columns'
CREATE TABLE dbo.Columns (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Obj_OID [int] NOT NULL
,   ColN_OID [int] NULL
,   ColID [int] NOT NULL
,   ColOrder [int] NOT NULL
,   [ID] nvarchar(128) COLLATE Latin1_General_CI_AS NOT NULL
,   DataTypeSchema nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   DataType nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   Length [int] NULL
,   DecimalLength [int] NULL
,   Nullable [bit] NOT NULL
,   IsIdentity [bit] NULL
,   CollationName nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   IdentityStart [int] NULL
,   IdentityInc [int] NULL
,   IsRowGuidCol [bit] NULL
,   Computed ntext COLLATE Latin1_General_CI_AS NULL
,   IsPersisted [bit] NULL
,   NotForRepl [bit] NULL
,   XmlSchema nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   XmlCollection nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   IsXmlDoc [bit] NULL
,   Description ntext COLLATE Latin1_General_CI_AS NULL
,   IsOutput [bit] NULL
,   IsFileStream [bit] NULL
,   IsSparse [bit] NULL
,   B1 [bit] NULL
,   B2 [bit] NULL
,   B3 [bit] NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Columns_Nullable'
ALTER TABLE [dbo].[Columns]
    ADD CONSTRAINT [DF_Columns_Nullable] DEFAULT (0) FOR [Nullable]
GO
PRINT 'CREATE DEFAULT DF_Columns_Created'
ALTER TABLE [dbo].[Columns]
    ADD CONSTRAINT [DF_Columns_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE Comparison'
CREATE TABLE dbo.Comparison (
    OID [int] IDENTITY (1, 1) NOT NULL
,   MComp_OID [int] NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   PV_OID_Ref [int] NOT NULL
,   PV_OID_Diff [int] NOT NULL
,   OS_OID [int] NULL
,   CS_OID [int] NOT NULL
,   CalcDate datetime NULL
,   User_OID_Locked [int] NULL
,   User_OID [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Comparison_CS_OID'
ALTER TABLE [dbo].[Comparison]
    ADD CONSTRAINT [DF_Comparison_CS_OID] DEFAULT (1) FOR [CS_OID]
GO
PRINT 'CREATE DEFAULT DF_Comparison_Created'
ALTER TABLE [dbo].[Comparison]
    ADD CONSTRAINT [DF_Comparison_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE Comparison_Column'
CREATE TABLE dbo.Comparison_Column (
    OID [int] IDENTITY (1, 1) NOT NULL
,   CObj_OID [int] NOT NULL
,   Col_OID_Ref [int] NULL
,   Col_OID_Diff [int] NULL
,   IsUserAssigned [bit] NOT NULL
,   InScript [bit] NOT NULL
,   DiffMode [int] NULL
,   DiffText nvarchar(2000) COLLATE Latin1_General_CI_AS NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Comparison_Column_IsUserAssigned'
ALTER TABLE [dbo].[Comparison_Column]
    ADD CONSTRAINT [DF_Comparison_Column_IsUserAssigned] DEFAULT (0) FOR [IsUserAssigned]
GO
PRINT 'CREATE DEFAULT DF_Comparison_Column_InScript'
ALTER TABLE [dbo].[Comparison_Column]
    ADD CONSTRAINT [DF_Comparison_Column_InScript] DEFAULT (0) FOR [InScript]
GO
PRINT 'CREATE DEFAULT DF_Comparison_Column_Created'
ALTER TABLE [dbo].[Comparison_Column]
    ADD CONSTRAINT [DF_Comparison_Column_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE Comparison_Object'
CREATE TABLE dbo.Comparison_Object (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Comp_OID [int] NOT NULL
,   Obj_OID_Ref [int] NULL
,   Obj_OID_Diff [int] NULL
,   IsUserAssigned [bit] NOT NULL
,   InScript [int] NOT NULL
,   ColumnsChanged [bit] NULL
,   ChildrenChanged [bit] NULL
,   Scr_OID [int] NULL
,   DiffMode [int] NULL
,   DiffText nvarchar(2000) COLLATE Latin1_General_CI_AS NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Comparison_Object_IsUserAssigned'
ALTER TABLE [dbo].[Comparison_Object]
    ADD CONSTRAINT [DF_Comparison_Object_IsUserAssigned] DEFAULT (0) FOR [IsUserAssigned]
GO
PRINT 'CREATE DEFAULT DF_Comparison_Object_InScript'
ALTER TABLE [dbo].[Comparison_Object]
    ADD CONSTRAINT [DF_Comparison_Object_InScript] DEFAULT (0) FOR [InScript]
GO
PRINT 'CREATE DEFAULT DF_Comparison_Object_ColumnsChanged'
ALTER TABLE [dbo].[Comparison_Object]
    ADD CONSTRAINT [DF_Comparison_Object_ColumnsChanged] DEFAULT (0) FOR [ColumnsChanged]
GO
PRINT 'CREATE DEFAULT DF_Comparison_Object_ChildrenChanged'
ALTER TABLE [dbo].[Comparison_Object]
    ADD CONSTRAINT [DF_Comparison_Object_ChildrenChanged] DEFAULT (0) FOR [ChildrenChanged]
GO
PRINT 'CREATE DEFAULT DF_Comparison_Object_Created'
ALTER TABLE [dbo].[Comparison_Object]
    ADD CONSTRAINT [DF_Comparison_Object_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE ComparisonScope'
CREATE TABLE dbo.ComparisonScope (
    OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   IncludeCreate [bit] NOT NULL
,   IncludeAlter [bit] NOT NULL
,   IncludeDrop [bit] NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_ComparisonScope_IncludeCreate'
ALTER TABLE [dbo].[ComparisonScope]
    ADD CONSTRAINT [DF_ComparisonScope_IncludeCreate] DEFAULT (0) FOR [IncludeCreate]
GO
PRINT 'CREATE DEFAULT DF_ComparisonScope_IncludeAlter'
ALTER TABLE [dbo].[ComparisonScope]
    ADD CONSTRAINT [DF_ComparisonScope_IncludeAlter] DEFAULT (0) FOR [IncludeAlter]
GO
PRINT 'CREATE DEFAULT DF_ComparisonScope_IncludeDelete'
ALTER TABLE [dbo].[ComparisonScope]
    ADD CONSTRAINT [DF_ComparisonScope_IncludeDelete] DEFAULT (0) FOR [IncludeDrop]
GO
PRINT 'CREATE TABLE Configuration'
CREATE TABLE dbo.Configuration (
    OID [int] NOT NULL
,   VersionNumber nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   WikiHelpUrl [varchar](256) COLLATE Latin1_General_CI_AS NULL
,   LicenseEmail [varchar](100) COLLATE Latin1_General_CI_AS NULL
,   License [text] COLLATE Latin1_General_CI_AS NULL
,   UpdateMode [int] NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Configuration_UpdateMode'
ALTER TABLE [dbo].[Configuration]
    ADD CONSTRAINT [DF_Configuration_UpdateMode] DEFAULT (1) FOR [UpdateMode]
GO
PRINT 'CREATE TABLE Contact'
CREATE TABLE dbo.Contact (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Cust_OID [int] NOT NULL
,   Title nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   FirstName nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   LastName nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   EMail nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   Phone nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   MobilePhone nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   PrivatePhone nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   Fax nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   DateFrom datetime NULL
,   DateUntil datetime NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Contact_Created'
ALTER TABLE [dbo].[Contact]
    ADD CONSTRAINT [DF_Contact_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE Customer'
CREATE TABLE dbo.Customer (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Proj_OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   Description nvarchar(500) COLLATE Latin1_General_CI_AS NULL
,   Address1 nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   Address2 nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   City nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   ZIP nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   Country nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   Phone nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   Fax nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   EMail nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   DateFrom datetime NULL
,   DateUntil datetime NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Customer_Created'
ALTER TABLE [dbo].[Customer]
    ADD CONSTRAINT [DF_Customer_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE Databases'
CREATE TABLE dbo.Databases (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Proj_OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   Server [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   [Catalog] [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   Username nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   Password nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   User_OID [int] NOT NULL
,   ImportOptions nvarchar(1000) COLLATE Latin1_General_CI_AS NULL
,   IsEnabled [bit] NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Databases_IsActive'
ALTER TABLE [dbo].[Databases]
    ADD CONSTRAINT [DF_Databases_IsActive] DEFAULT (0) FOR [IsEnabled]
GO
PRINT 'CREATE DEFAULT DF_Databases_Created'
ALTER TABLE [dbo].[Databases]
    ADD CONSTRAINT [DF_Databases_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE DatabaseVersion'
CREATE TABLE dbo.DatabaseVersion (
    OID [int] IDENTITY (1, 1) NOT NULL
,   DB_OID [int] NOT NULL
,   SqlV_OID [int] NULL
,   Version nvarchar(256) COLLATE Latin1_General_CI_AS NULL
,   Edition nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   EngineEdition [int] NULL
,   MachineName nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   InstanceName nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   ProductVersion nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   ProductLevel nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   ServerName nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   DatabaseName nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   DefaultCollation nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_DatabaseVersion_Created'
ALTER TABLE [dbo].[DatabaseVersion]
    ADD CONSTRAINT [DF_DatabaseVersion_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE DBEngine'
CREATE TABLE dbo.DBEngine (
    OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   ProgID [varchar](50) COLLATE Latin1_General_CI_AS NOT NULL
,   CanCreate [bit] NOT NULL
,   CanConnect [bit] NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_DBEngine_CanCreate'
ALTER TABLE [dbo].[DBEngine]
    ADD CONSTRAINT [DF_DBEngine_CanCreate] DEFAULT (1) FOR [CanCreate]
GO
PRINT 'CREATE DEFAULT DF_DBEngine_CanConnect'
ALTER TABLE [dbo].[DBEngine]
    ADD CONSTRAINT [DF_DBEngine_CanConnect] DEFAULT (1) FOR [CanConnect]
GO
PRINT 'CREATE TABLE DBEngine_DiagramType'
CREATE TABLE dbo.DBEngine_DiagramType (
    OID [int] IDENTITY (1, 1) NOT NULL
,   DBE_OID [int] NOT NULL
,   DiaT_OID [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_DBEngine_DiagramType_Created'
ALTER TABLE [dbo].[DBEngine_DiagramType]
    ADD CONSTRAINT [DF_DBEngine_DiagramType_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE DBEngine_ScriptTextType'
CREATE TABLE dbo.DBEngine_ScriptTextType (
    OID [int] IDENTITY (1, 1) NOT NULL
,   DBE_OID [int] NOT NULL
,   STT_OID [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_DBEngine_ScriptTextType_Created'
ALTER TABLE [dbo].[DBEngine_ScriptTextType]
    ADD CONSTRAINT [DF_DBEngine_ScriptTextType_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE Dependency'
CREATE TABLE dbo.Dependency (
    OID [int] IDENTITY (1, 1) NOT NULL
,   DepT_OID [int] NOT NULL
,   Obj_OID [int] NOT NULL
,   Obj_OID_DependsOn [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Dependency_DepT_OID'
ALTER TABLE [dbo].[Dependency]
    ADD CONSTRAINT [DF_Dependency_DepT_OID] DEFAULT (1) FOR [DepT_OID]
GO
PRINT 'CREATE DEFAULT DF_Dependency_Created'
ALTER TABLE [dbo].[Dependency]
    ADD CONSTRAINT [DF_Dependency_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE DependencyType'
CREATE TABLE dbo.DependencyType (
    OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   ProgID [varchar](50) COLLATE Latin1_General_CI_AS NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE TABLE Diagram'
CREATE TABLE dbo.Diagram (
    OID [int] IDENTITY (1, 1) NOT NULL
,   PV_OID [int] NOT NULL
,   DiaT_OID [int] NOT NULL
,   B1 [bit] NULL
,   OS_OID [int] NULL
,   BinData image NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Diagram_Created'
ALTER TABLE [dbo].[Diagram]
    ADD CONSTRAINT [DF_Diagram_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE DiagramType'
CREATE TABLE dbo.DiagramType (
    OID [int] IDENTITY (1, 1) NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   ProgID [varchar](50) COLLATE Latin1_General_CI_AS NOT NULL
,   NameB1 nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   AllowObjSel [bit] NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_DiagramType_AllowObjSel'
ALTER TABLE [dbo].[DiagramType]
    ADD CONSTRAINT [DF_DiagramType_AllowObjSel] DEFAULT (0) FOR [AllowObjSel]
GO
PRINT 'CREATE TABLE DocGen'
CREATE TABLE dbo.DocGen (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Proj_OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   DGT_OID [int] NOT NULL
,   PV_OID [int] NOT NULL
,   ObjN_OID_View [int] NULL
,   ParamValue1 nvarchar(256) COLLATE Latin1_General_CI_AS NULL
,   ParamValue2 nvarchar(256) COLLATE Latin1_General_CI_AS NULL
,   Username nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   Password nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   User_OID [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_DocGen_Created'
ALTER TABLE [dbo].[DocGen]
    ADD CONSTRAINT [DF_DocGen_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE DocGenPart'
CREATE TABLE dbo.DocGenPart (
    OID [int] IDENTITY (1, 1) NOT NULL
,   DG_OID [int] NOT NULL
,   [Seq] [int] NULL
,   XSL_OID [int] NOT NULL
,   ObjT_OID [int] NULL
,   OS_OID [int] NULL
,   Scr_OID_Xml [int] NULL
,   DB_OID_Xml [int] NULL
,   ParamValue1 nvarchar(256) COLLATE Latin1_General_CI_AS NULL
,   ParamValue2 nvarchar(256) COLLATE Latin1_General_CI_AS NULL
,   PVXML ntext COLLATE Latin1_General_CI_AS NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_DocGenPart_Created'
ALTER TABLE [dbo].[DocGenPart]
    ADD CONSTRAINT [DF_DocGenPart_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE DocGenType'
CREATE TABLE dbo.DocGenType (
    OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   ProgID [varchar](50) COLLATE Latin1_General_CI_AS NOT NULL
,   ParamName1 nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   ParamName2 nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   HasLogin [bit] NOT NULL
,   DGPParamName1 nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   DGPParamName2 nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   Cargo nvarchar(50) COLLATE Latin1_General_CI_AS NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_DocGenType_HasLogin'
ALTER TABLE [dbo].[DocGenType]
    ADD CONSTRAINT [DF_DocGenType_HasLogin] DEFAULT (0) FOR [HasLogin]
GO
PRINT 'CREATE TABLE Installation'
CREATE TABLE dbo.Installation (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Cust_OID [int] NOT NULL
,   PV_OID [int] NOT NULL
,   Cont_OID [int] NULL
,   Description nvarchar(500) COLLATE Latin1_General_CI_AS NULL
,   DateShipped datetime NULL
,   DateInstalled datetime NULL
,   User_OID [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Installation_Created'
ALTER TABLE [dbo].[Installation]
    ADD CONSTRAINT [DF_Installation_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE MultiComparison'
CREATE TABLE dbo.MultiComparison (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Proj_OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   CalcDate datetime NULL
,   User_OID [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_MultiComparison_Created'
ALTER TABLE [dbo].[MultiComparison]
    ADD CONSTRAINT [DF_MultiComparison_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE MultiComparison_ProjectVersion'
CREATE TABLE dbo.MultiComparison_ProjectVersion (
    OID [int] IDENTITY (1, 1) NOT NULL
,   MComp_OID [int] NOT NULL
,   PV_OID [int] NOT NULL
,   User_OID [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_MultiComparison_ProjectVersion_Created'
ALTER TABLE [dbo].[MultiComparison_ProjectVersion]
    ADD CONSTRAINT [DF_MultiComparison_ProjectVersion_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE Object'
CREATE TABLE dbo.[Object] (
    OID [int] IDENTITY (1, 1) NOT NULL
,   PV_OID [int] NOT NULL
,   ObjT_OID [int] NOT NULL
,   ObjN_OID [int] NOT NULL
,   OwnerName nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   [ID] nvarchar(128) COLLATE Latin1_General_CI_AS NOT NULL
,   Description ntext COLLATE Latin1_General_CI_AS NULL
,   SysID bigint NULL
,   Obj_OID_Parent [int] NULL
,   ParentID bigint NULL
,   IndexID [int] NULL
,   FileGroupName nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   IsAnsiOn [bit] NULL
,   IsQuotedID [bit] NULL
,   IsClustered [bit] NULL
,   IsUnique [bit] NULL
,   DeleteAction [int] NULL
,   UpdateAction [int] NULL
,   InsteadOf [bit] NULL
,   ForInsert [bit] NULL
,   ForUpdate [bit] NULL
,   ForDelete [bit] NULL
,   IsXml [bit] NULL
,   IsPrimaryXml [bit] NULL
,   Xml2ndType nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   XmlPrimaryID nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   NotForRepl [bit] NULL
,   LobDataspaceName nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   SourceCode ntext COLLATE Latin1_General_CI_AS NULL
,   IgDupKey [bit] NULL
,   IdxFillFactor [int] NULL
,   IsPadded [bit] NULL
,   IsSysNamed [bit] NULL
,   BaseDatatype nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   Length [int] NULL
,   DecimalLength [int] NULL
,   Nullable [bit] NULL
,   ObjectOwner nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   HasOids [bit] NULL
,   MinValue bigint NULL
,   MaxValue bigint NULL
,   StartValue bigint NULL
,   IncrementBy bigint NULL
,   CacheValue bigint NULL
,   IsCycle [bit] NULL
,   IsBefore [bit] NULL
,   IsRowLevel [bit] NULL
,   WithSchemaBinding [bit] NULL
,   TextImageOn nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   FileStreamOn nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   S1 nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   S2 nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   S3 nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   S4 nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   S5 nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   S6 nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   CalcColumns nvarchar(1024) COLLATE Latin1_General_CI_AS NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Object_Created'
ALTER TABLE [dbo].[Object]
    ADD CONSTRAINT [DF_Object_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE Object_Column'
CREATE TABLE dbo.Object_Column (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Obj_OID [int] NOT NULL
,   Col_OID [int] NOT NULL
,   [Seq] [int] NOT NULL
,   Obj_OID_Rel [int] NULL
,   Obj_OID_Ref [int] NULL
,   Col_OID_Ref [int] NULL
,   IsDesc [bit] NULL
,   IsIncluded [bit] NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Object_Column_Created'
ALTER TABLE [dbo].[Object_Column]
    ADD CONSTRAINT [DF_Object_Column_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE ObjectName'
CREATE TABLE dbo.ObjectName (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Proj_OID [int] NOT NULL
,   ObjT_OID [int] NOT NULL
,   OwnerName nvarchar(128) COLLATE Latin1_General_CI_AS NULL
,   [ID] nvarchar(128) COLLATE Latin1_General_CI_AS NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_ObjectName_Created'
ALTER TABLE [dbo].[ObjectName]
    ADD CONSTRAINT [DF_ObjectName_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE ObjectSelection'
CREATE TABLE dbo.ObjectSelection (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Proj_OID [int] NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   User_OID [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_ObjectSelection_Created'
ALTER TABLE [dbo].[ObjectSelection]
    ADD CONSTRAINT [DF_ObjectSelection_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE ObjectSelection_Object'
CREATE TABLE dbo.ObjectSelection_Object (
    OID [int] IDENTITY (1, 1) NOT NULL
,   OSOT_OID [int] NOT NULL
,   ObjN_OID [int] NULL
,   Obj_OID [int] NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_ObjectSelection_Object_Created'
ALTER TABLE [dbo].[ObjectSelection_Object]
    ADD CONSTRAINT [DF_ObjectSelection_Object_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE ObjectSelection_ObjectType'
CREATE TABLE dbo.ObjectSelection_ObjectType (
    OID [int] IDENTITY (1, 1) NOT NULL
,   OS_OID [int] NOT NULL
,   ObjT_OID [int] NOT NULL
,   Include [bit] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_ObjectSelection_ObjectType_Include'
ALTER TABLE [dbo].[ObjectSelection_ObjectType]
    ADD CONSTRAINT [DF_ObjectSelection_ObjectType_Include] DEFAULT (1) FOR [Include]
GO
PRINT 'CREATE DEFAULT DF_ObjectSelection_ObjectType_Created'
ALTER TABLE [dbo].[ObjectSelection_ObjectType]
    ADD CONSTRAINT [DF_ObjectSelection_ObjectType_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE ObjectType'
CREATE TABLE dbo.ObjectType (
    OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   ProgID [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   OTT_OID [int] NOT NULL
,   SysobjectType [varchar](2) COLLATE Latin1_General_CI_AS NULL
,   WikiTitleFormat nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   DocGenDescription nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   NameS1 [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   NameS2 [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   NameS3 [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   NameS4 [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   NameS5 [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   NameS6 [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   ColNameB1 [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   ColNameB2 [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   ColNameB3 [varchar](50) COLLATE Latin1_General_CI_AS NULL
) ON [PRIMARY]
GO

PRINT 'CREATE TABLE ObjectTypeType'
CREATE TABLE dbo.ObjectTypeType (
    OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   ProgID [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   IsBaseType [bit] NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_ObjectTypeType_IsBaseType'
ALTER TABLE [dbo].[ObjectTypeType]
    ADD CONSTRAINT [DF_ObjectTypeType_IsBaseType] DEFAULT (0) FOR [IsBaseType]
GO
PRINT 'CREATE TABLE Project'
CREATE TABLE dbo.Project (
    OID [int] IDENTITY (1, 1) NOT NULL
,   User_OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   DBE_OID [int] NOT NULL
,   UpdateID nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   TrackingSite nvarchar(100) COLLATE Latin1_General_CI_AS NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Project_DBE_OID'
ALTER TABLE [dbo].[Project]
    ADD CONSTRAINT [DF_Project_DBE_OID] DEFAULT (1) FOR [DBE_OID]
GO
PRINT 'CREATE DEFAULT DF_Project_Created'
ALTER TABLE [dbo].[Project]
    ADD CONSTRAINT [DF_Project_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE Project_Role'
CREATE TABLE dbo.Project_Role (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Proj_OID [int] NOT NULL
,   Role_OID [int] NOT NULL
,   IsAdmin [bit] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Project_Role_IsAdmin'
ALTER TABLE [dbo].[Project_Role]
    ADD CONSTRAINT [DF_Project_Role_IsAdmin] DEFAULT (0) FOR [IsAdmin]
GO
PRINT 'CREATE DEFAULT DF_Project_Role_Created'
ALTER TABLE [dbo].[Project_Role]
    ADD CONSTRAINT [DF_Project_Role_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE ProjectVersion'
CREATE TABLE dbo.ProjectVersion (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Proj_OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   DB_OID_Source [int] NULL
,   DBV_OID_Source [int] NULL
,   SqlV_OID [int] NULL
,   PVT_OID [int] NULL
,   Br_OID [int] NULL
,   VersionDate datetime NULL
,   ScheduledDate datetime NULL
,   User_OID_Locked [int] NULL
,   LockedDate datetime NULL
,   TrackerIDs nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   UpdateID nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   UpdateMessage nvarchar(1000) COLLATE Latin1_General_CI_AS NULL
,   DataDiagramPng image NULL
,   User_OID [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_ProjectVersion_Created'
ALTER TABLE [dbo].[ProjectVersion]
    ADD CONSTRAINT [DF_ProjectVersion_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE ProjectVersionType'
CREATE TABLE dbo.ProjectVersionType (
    OID [int] IDENTITY (1, 1) NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   DispSeq [int] NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE TABLE Property'
CREATE TABLE dbo.Property (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Obj_OID [int] NULL
,   Col_OID [int] NULL
,   PropT_OID [int] NOT NULL
,   [ID] nvarchar(128) COLLATE Latin1_General_CI_AS NOT NULL
,   [Value] ntext COLLATE Latin1_General_CI_AS NULL
,   IntValue [int] NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Property_Created'
ALTER TABLE [dbo].[Property]
    ADD CONSTRAINT [DF_Property_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE PropertyType'
CREATE TABLE dbo.PropertyType (
    OID [int] IDENTITY (1, 1) NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   ProgID [varchar](50) COLLATE Latin1_General_CI_AS NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE TABLE Role'
CREATE TABLE dbo.[Role] (
    OID [int] IDENTITY (1, 1) NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   Description nvarchar(500) COLLATE Latin1_General_CI_AS NULL
,   IsAdmin [bit] NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Role_IsAdmin'
ALTER TABLE [dbo].[Role]
    ADD CONSTRAINT [DF_Role_IsAdmin] DEFAULT (0) FOR [IsAdmin]
GO
PRINT 'CREATE DEFAULT DF_Role_Created'
ALTER TABLE [dbo].[Role]
    ADD CONSTRAINT [DF_Role_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE Script'
CREATE TABLE dbo.[Script] (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Proj_OID [int] NOT NULL
,   ST_OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   Name1 [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   User_OID [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Script_Created'
ALTER TABLE [dbo].[Script]
    ADD CONSTRAINT [DF_Script_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE Script_Column'
CREATE TABLE dbo.Script_Column (
    OID [int] IDENTITY (1, 1) NOT NULL
,   STbl_OID [int] NOT NULL
,   ColN_OID [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Script_Column_Created'
ALTER TABLE [dbo].[Script_Column]
    ADD CONSTRAINT [DF_Script_Column_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE Script_Table'
CREATE TABLE dbo.Script_Table (
    OID [int] IDENTITY (1, 1) NOT NULL
,   Scr_OID [int] NOT NULL
,   ObjN_OID [int] NOT NULL
,   [Seq] [int] NULL
,   STM_OID [int] NULL
,   Condition nvarchar(1000) COLLATE Latin1_General_CI_AS NULL
,   Name1 [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   ColN_OID_Seq1 [int] NULL
,   ColN_OID_Seq2 [int] NULL
,   ColN_OID_Seq3 [int] NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Script_Table_Created'
ALTER TABLE [dbo].[Script_Table]
    ADD CONSTRAINT [DF_Script_Table_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE ScriptTableMode'
CREATE TABLE dbo.ScriptTableMode (
    OID [int] NOT NULL
,   ST_OID [int] NOT NULL
,   [Seq] [int] NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   ProgID [varchar](50) COLLATE Latin1_General_CI_AS NULL
) ON [PRIMARY]
GO

PRINT 'CREATE TABLE ScriptText'
CREATE TABLE dbo.ScriptText (
    OID [int] IDENTITY (1, 1) NOT NULL
,   STT_OID [int] NOT NULL
,   Proj_OID [int] NOT NULL
,   PV_OID [int] NULL
,   Scr_OID [int] NULL
,   DB_OID [int] NULL
,   SqlV_OID [int] NULL
,   Comp_OID [int] NULL
,   TheScript ntext COLLATE Latin1_General_CI_AS NULL
,   User_OID [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_ScriptText_Created'
ALTER TABLE [dbo].[ScriptText]
    ADD CONSTRAINT [DF_ScriptText_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE ScriptTextType'
CREATE TABLE dbo.ScriptTextType (
    OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   ProgID [varchar](50) COLLATE Latin1_General_CI_AS NOT NULL
,   PVSeq [int] NULL
,   ObjSeq [int] NULL
,   IsXml [bit] NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_ScriptTextType_IsXml'
ALTER TABLE [dbo].[ScriptTextType]
    ADD CONSTRAINT [DF_ScriptTextType_IsXml] DEFAULT (0) FOR [IsXml]
GO
PRINT 'CREATE TABLE ScriptType'
CREATE TABLE dbo.ScriptType (
    OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   ProgID [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   ParamName1 nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   TableName1 nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   ColumnNameSeq1 nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   ColumnNameSeq2 nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   ColumnNameSeq3 nvarchar(50) COLLATE Latin1_General_CI_AS NULL
,   HasSCols [bit] NOT NULL
,   CanChangeScript [bit] NOT NULL
,   FileExtension [varchar](50) COLLATE Latin1_General_CI_AS NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_ScriptType_HasSCols'
ALTER TABLE [dbo].[ScriptType]
    ADD CONSTRAINT [DF_ScriptType_HasSCols] DEFAULT (0) FOR [HasSCols]
GO
PRINT 'CREATE DEFAULT DF_ScriptType_CanChangeScript'
ALTER TABLE [dbo].[ScriptType]
    ADD CONSTRAINT [DF_ScriptType_CanChangeScript] DEFAULT (0) FOR [CanChangeScript]
GO
PRINT 'CREATE TABLE SqlVersion'
CREATE TABLE dbo.SqlVersion (
    OID [int] NOT NULL
,   DBE_OID [int] NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   ProgID [varchar](50) COLLATE Latin1_General_CI_AS NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_SqlVersion_DBE_OID'
ALTER TABLE [dbo].[SqlVersion]
    ADD CONSTRAINT [DF_SqlVersion_DBE_OID] DEFAULT (1) FOR [DBE_OID]
GO
PRINT 'CREATE TABLE SqlVersion_ObjectType'
CREATE TABLE dbo.SqlVersion_ObjectType (
    OID [int] IDENTITY (1, 1) NOT NULL
,   SqlV_OID [int] NOT NULL
,   ObjT_OID [int] NOT NULL
,   CreateSeq [int] NULL
,   DropSeq [int] NULL
,   CompSeq [int] NULL
,   CompDropSeq [int] NULL
) ON [PRIMARY]
GO

PRINT 'CREATE TABLE User_Role'
CREATE TABLE dbo.User_Role (
    OID [int] IDENTITY (1, 1) NOT NULL
,   User_OID [int] NOT NULL
,   Role_OID [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_User_Role_Created'
ALTER TABLE [dbo].[User_Role]
    ADD CONSTRAINT [DF_User_Role_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE Users'
CREATE TABLE dbo.Users (
    OID [int] IDENTITY (1, 1) NOT NULL
,   [GUID] uniqueidentifier NOT NULL
,   [ID] [varchar](50) COLLATE Latin1_General_CI_AS NOT NULL
,   EMail [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   Password [varchar](50) COLLATE Latin1_General_CI_AS NULL
,   ValidFrom datetime NULL
,   ValidUntil datetime NULL
,   LastOnline datetime NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_Users_GUID'
ALTER TABLE [dbo].[Users]
    ADD CONSTRAINT [DF_Users_GUID] DEFAULT (newid()) FOR [GUID]
GO
PRINT 'CREATE DEFAULT DF_Users_Created'
ALTER TABLE [dbo].[Users]
    ADD CONSTRAINT [DF_Users_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE XSL'
CREATE TABLE dbo.XSL (
    OID [int] IDENTITY (1, 1) NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   DBE_OID [int] NOT NULL
,   DGT_OID [int] NULL
,   XslT_OID [int] NOT NULL
,   IsDGPDefault [bit] NOT NULL
,   TheScript ntext COLLATE Latin1_General_CI_AS NOT NULL
,   User_OID [int] NOT NULL
,   Created datetime NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE DEFAULT DF_XSL_DBE_OID'
ALTER TABLE [dbo].[XSL]
    ADD CONSTRAINT [DF_XSL_DBE_OID] DEFAULT (1) FOR [DBE_OID]
GO
PRINT 'CREATE DEFAULT DF_XSL_IsDGPDefault'
ALTER TABLE [dbo].[XSL]
    ADD CONSTRAINT [DF_XSL_IsDGPDefault] DEFAULT (0) FOR [IsDGPDefault]
GO
PRINT 'CREATE DEFAULT DF_XSL_Created'
ALTER TABLE [dbo].[XSL]
    ADD CONSTRAINT [DF_XSL_Created] DEFAULT (getdate()) FOR [Created]
GO
PRINT 'CREATE TABLE XslType'
CREATE TABLE dbo.XslType (
    OID [int] IDENTITY (1, 1) NOT NULL
,   [ID] nvarchar(50) COLLATE Latin1_General_CI_AS NOT NULL
,   ProgID [varchar](50) COLLATE Latin1_General_CI_AS NOT NULL
) ON [PRIMARY]
GO

PRINT 'CREATE PRIMARY KEY PK_Acknowledgement'
ALTER TABLE [dbo].[Acknowledgement]
    ADD CONSTRAINT [PK_Acknowledgement] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Branch'
ALTER TABLE [dbo].[Branch]
    ADD CONSTRAINT [PK_Branch] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_CodeSnippet'
ALTER TABLE [dbo].[CodeSnippet]
    ADD CONSTRAINT [PK_CodeSnippet] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_ColumnName'
ALTER TABLE [dbo].[ColumnName]
    ADD CONSTRAINT [PK_ColumnName] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Columns'
ALTER TABLE [dbo].[Columns]
    ADD CONSTRAINT [PK_Columns] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Comparison'
ALTER TABLE [dbo].[Comparison]
    ADD CONSTRAINT [PK_Comparison] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Comparison_Column'
ALTER TABLE [dbo].[Comparison_Column]
    ADD CONSTRAINT [PK_Comparison_Column] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Comparison_Object'
ALTER TABLE [dbo].[Comparison_Object]
    ADD CONSTRAINT [PK_Comparison_Object] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_ComparisonScope'
ALTER TABLE [dbo].[ComparisonScope]
    ADD CONSTRAINT [PK_ComparisonScope] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Configuration'
ALTER TABLE [dbo].[Configuration]
    ADD CONSTRAINT [PK_Configuration] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Contact'
ALTER TABLE [dbo].[Contact]
    ADD CONSTRAINT [PK_Contact] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Customer'
ALTER TABLE [dbo].[Customer]
    ADD CONSTRAINT [PK_Customer] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Databases'
ALTER TABLE [dbo].[Databases]
    ADD CONSTRAINT [PK_Databases] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_DatabaseVersion'
ALTER TABLE [dbo].[DatabaseVersion]
    ADD CONSTRAINT [PK_DatabaseVersion] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_DBEngine'
ALTER TABLE [dbo].[DBEngine]
    ADD CONSTRAINT [PK_DBEngine] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_DBEngine_DiagramType'
ALTER TABLE [dbo].[DBEngine_DiagramType]
    ADD CONSTRAINT [PK_DBEngine_DiagramType] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_DBEngine_ScriptTextType'
ALTER TABLE [dbo].[DBEngine_ScriptTextType]
    ADD CONSTRAINT [PK_DBEngine_ScriptTextType] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Dependency'
ALTER TABLE [dbo].[Dependency]
    ADD CONSTRAINT [PK_Dependency] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_DependencyType'
ALTER TABLE [dbo].[DependencyType]
    ADD CONSTRAINT [PK_DependencyType] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Diagram'
ALTER TABLE [dbo].[Diagram]
    ADD CONSTRAINT [PK_Diagram] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_DiagramType'
ALTER TABLE [dbo].[DiagramType]
    ADD CONSTRAINT [PK_DiagramType] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_DocGen'
ALTER TABLE [dbo].[DocGen]
    ADD CONSTRAINT [PK_DocGen] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_DocGenPart'
ALTER TABLE [dbo].[DocGenPart]
    ADD CONSTRAINT [PK_DocGenPart] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_DocGenType'
ALTER TABLE [dbo].[DocGenType]
    ADD CONSTRAINT [PK_DocGenType] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Installation'
ALTER TABLE [dbo].[Installation]
    ADD CONSTRAINT [PK_Installation] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_MultiComparison'
ALTER TABLE [dbo].[MultiComparison]
    ADD CONSTRAINT [PK_MultiComparison] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_MultiComparison_ProjectVersion'
ALTER TABLE [dbo].[MultiComparison_ProjectVersion]
    ADD CONSTRAINT [PK_MultiComparison_ProjectVersion] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Object'
ALTER TABLE [dbo].[Object]
    ADD CONSTRAINT [PK_Object] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Object_Column'
ALTER TABLE [dbo].[Object_Column]
    ADD CONSTRAINT [PK_Object_Column] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_ObjectName'
ALTER TABLE [dbo].[ObjectName]
    ADD CONSTRAINT [PK_ObjectName] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_ObjectSelection'
ALTER TABLE [dbo].[ObjectSelection]
    ADD CONSTRAINT [PK_ObjectSelection] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_ObjectSelection_Object'
ALTER TABLE [dbo].[ObjectSelection_Object]
    ADD CONSTRAINT [PK_ObjectSelection_Object] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_ObjectSelection_ObjectType'
ALTER TABLE [dbo].[ObjectSelection_ObjectType]
    ADD CONSTRAINT [PK_ObjectSelection_ObjectType] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_ObjectType'
ALTER TABLE [dbo].[ObjectType]
    ADD CONSTRAINT [PK_ObjectType] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_ObjectTypeType'
ALTER TABLE [dbo].[ObjectTypeType]
    ADD CONSTRAINT [PK_ObjectTypeType] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Project'
ALTER TABLE [dbo].[Project]
    ADD CONSTRAINT [PK_Project] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Project_Role'
ALTER TABLE [dbo].[Project_Role]
    ADD CONSTRAINT [PK_Project_Role] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_ProjectVersion'
ALTER TABLE [dbo].[ProjectVersion]
    ADD CONSTRAINT [PK_ProjectVersion] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_ProjectVersionType'
ALTER TABLE [dbo].[ProjectVersionType]
    ADD CONSTRAINT [PK_ProjectVersionType] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Property'
ALTER TABLE [dbo].[Property]
    ADD CONSTRAINT [PK_Property] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_PropertyType'
ALTER TABLE [dbo].[PropertyType]
    ADD CONSTRAINT [PK_PropertyType] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Role'
ALTER TABLE [dbo].[Role]
    ADD CONSTRAINT [PK_Role] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Script'
ALTER TABLE [dbo].[Script]
    ADD CONSTRAINT [PK_Script] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Script_Column'
ALTER TABLE [dbo].[Script_Column]
    ADD CONSTRAINT [PK_Script_Column] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Script_Table'
ALTER TABLE [dbo].[Script_Table]
    ADD CONSTRAINT [PK_Script_Table] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_ScriptTableMode'
ALTER TABLE [dbo].[ScriptTableMode]
    ADD CONSTRAINT [PK_ScriptTableMode] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_ScriptText'
ALTER TABLE [dbo].[ScriptText]
    ADD CONSTRAINT [PK_ScriptText] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_ScriptTextType'
ALTER TABLE [dbo].[ScriptTextType]
    ADD CONSTRAINT [PK_ScriptTextType] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_ScriptType'
ALTER TABLE [dbo].[ScriptType]
    ADD CONSTRAINT [PK_ScriptType] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_SqlVersion'
ALTER TABLE [dbo].[SqlVersion]
    ADD CONSTRAINT [PK_SqlVersion] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_SqlVersion_ObjectType'
ALTER TABLE [dbo].[SqlVersion_ObjectType]
    ADD CONSTRAINT [PK_SqlVersion_ObjectType] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_User_Role'
ALTER TABLE [dbo].[User_Role]
    ADD CONSTRAINT [PK_User_Role] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_Users'
ALTER TABLE [dbo].[Users]
    ADD CONSTRAINT [PK_Users] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_XSL'
ALTER TABLE [dbo].[XSL]
    ADD CONSTRAINT [PK_XSL] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE PRIMARY KEY PK_XslType'
ALTER TABLE [dbo].[XslType]
    ADD CONSTRAINT [PK_XslType] PRIMARY KEY CLUSTERED
    (
        [OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Branch_Project'
CREATE INDEX [IX_Branch_Project]
    ON [dbo].[Branch] (
        [Proj_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Branch_Parent'
CREATE INDEX [IX_Branch_Parent]
    ON [dbo].[Branch] (
        [Br_OID_Parent]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Branch_Merge'
CREATE INDEX [IX_Branch_Merge]
    ON [dbo].[Branch] (
        [Br_OID_Merge]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Branch_User'
CREATE INDEX [IX_Branch_User]
    ON [dbo].[Branch] (
        [User_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_CodeSnippet_User'
CREATE INDEX [IX_CodeSnippet_User]
    ON [dbo].[CodeSnippet] (
        [User_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_ColumnName_ObjN'
CREATE INDEX [IX_ColumnName_ObjN]
    ON [dbo].[ColumnName] (
        [ObjN_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Columns_Obj'
CREATE INDEX [IX_Columns_Obj]
    ON [dbo].[Columns] (
        [Obj_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Columns_ColN'
CREATE INDEX [IX_Columns_ColN]
    ON [dbo].[Columns] (
        [ColN_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Comparison_PV_Ref'
CREATE INDEX [IX_Comparison_PV_Ref]
    ON [dbo].[Comparison] (
        [PV_OID_Ref]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Comparison_PV_Diff'
CREATE INDEX [IX_Comparison_PV_Diff]
    ON [dbo].[Comparison] (
        [PV_OID_Diff]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Comparison_MComp'
CREATE INDEX [IX_Comparison_MComp]
    ON [dbo].[Comparison] (
        [MComp_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Comparison_User'
CREATE INDEX [IX_Comparison_User]
    ON [dbo].[Comparison] (
        [User_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Comparison_Column_CObj'
CREATE INDEX [IX_Comparison_Column_CObj]
    ON [dbo].[Comparison_Column] (
        [CObj_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Comparison_Column_Col_Ref'
CREATE INDEX [IX_Comparison_Column_Col_Ref]
    ON [dbo].[Comparison_Column] (
        [Col_OID_Ref]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Comparison_Column_Col_Diff'
CREATE INDEX [IX_Comparison_Column_Col_Diff]
    ON [dbo].[Comparison_Column] (
        [Col_OID_Diff]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Comparison_Object_Comp'
CREATE INDEX [IX_Comparison_Object_Comp]
    ON [dbo].[Comparison_Object] (
        [Comp_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Comparison_Object_Obj_Ref'
CREATE INDEX [IX_Comparison_Object_Obj_Ref]
    ON [dbo].[Comparison_Object] (
        [Obj_OID_Ref]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Comparison_Object_Obj_Diff'
CREATE INDEX [IX_Comparison_Object_Obj_Diff]
    ON [dbo].[Comparison_Object] (
        [Obj_OID_Diff]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX UK_Customer'
CREATE UNIQUE INDEX [UK_Customer]
    ON [dbo].[Customer] (
        [Proj_OID]
,       [ID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Databases_Proj'
CREATE INDEX [IX_Databases_Proj]
    ON [dbo].[Databases] (
        [Proj_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_DatabaseVersion_DB'
CREATE INDEX [IX_DatabaseVersion_DB]
    ON [dbo].[DatabaseVersion] (
        [DB_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Dependency_Obj'
CREATE INDEX [IX_Dependency_Obj]
    ON [dbo].[Dependency] (
        [Obj_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Dependency_Obj_Dep'
CREATE INDEX [IX_Dependency_Obj_Dep]
    ON [dbo].[Dependency] (
        [Obj_OID_DependsOn]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_DocGen_Proj'
CREATE INDEX [IX_DocGen_Proj]
    ON [dbo].[DocGen] (
        [Proj_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_DocGen_PV'
CREATE INDEX [IX_DocGen_PV]
    ON [dbo].[DocGen] (
        [PV_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_DocGenPart_DocGen'
CREATE INDEX [IX_DocGenPart_DocGen]
    ON [dbo].[DocGenPart] (
        [DG_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_DocGenPart_XSL'
CREATE INDEX [IX_DocGenPart_XSL]
    ON [dbo].[DocGenPart] (
        [XSL_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_DocGenPart_OS'
CREATE INDEX [IX_DocGenPart_OS]
    ON [dbo].[DocGenPart] (
        [OS_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_DocGenPart_Scr'
CREATE INDEX [IX_DocGenPart_Scr]
    ON [dbo].[DocGenPart] (
        [Scr_OID_Xml]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_DocGenPart_DB'
CREATE INDEX [IX_DocGenPart_DB]
    ON [dbo].[DocGenPart] (
        [DB_OID_Xml]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Installation_Customer'
CREATE INDEX [IX_Installation_Customer]
    ON [dbo].[Installation] (
        [Cust_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Installation_PV'
CREATE INDEX [IX_Installation_PV]
    ON [dbo].[Installation] (
        [PV_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Installation_Contact'
CREATE INDEX [IX_Installation_Contact]
    ON [dbo].[Installation] (
        [Cont_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_MultiComparison_Project'
CREATE INDEX [IX_MultiComparison_Project]
    ON [dbo].[MultiComparison] (
        [Proj_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_MultiComparison_ProjectVersion_MComp'
CREATE INDEX [IX_MultiComparison_ProjectVersion_MComp]
    ON [dbo].[MultiComparison_ProjectVersion] (
        [MComp_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_MultiComparison_ProjectVersion_PV'
CREATE INDEX [IX_MultiComparison_ProjectVersion_PV]
    ON [dbo].[MultiComparison_ProjectVersion] (
        [PV_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Object_PV'
CREATE INDEX [IX_Object_PV]
    ON [dbo].[Object] (
        [PV_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Object_ObjT'
CREATE INDEX [IX_Object_ObjT]
    ON [dbo].[Object] (
        [ObjT_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Object_ObjN'
CREATE INDEX [IX_Object_ObjN]
    ON [dbo].[Object] (
        [ObjN_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Object_Obj_Parent'
CREATE INDEX [IX_Object_Obj_Parent]
    ON [dbo].[Object] (
        [Obj_OID_Parent]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Object_Column_Obj'
CREATE INDEX [IX_Object_Column_Obj]
    ON [dbo].[Object_Column] (
        [Obj_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Object_Column_Col'
CREATE INDEX [IX_Object_Column_Col]
    ON [dbo].[Object_Column] (
        [Col_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Object_Column_Obj_Rel'
CREATE INDEX [IX_Object_Column_Obj_Rel]
    ON [dbo].[Object_Column] (
        [Obj_OID_Rel]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Object_Column_Obj_Ref'
CREATE INDEX [IX_Object_Column_Obj_Ref]
    ON [dbo].[Object_Column] (
        [Obj_OID_Ref]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Object_Column_Col_Ref'
CREATE INDEX [IX_Object_Column_Col_Ref]
    ON [dbo].[Object_Column] (
        [Col_OID_Ref]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_ObjectName_Proj'
CREATE INDEX [IX_ObjectName_Proj]
    ON [dbo].[ObjectName] (
        [Proj_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_ObjectName_ObjT'
CREATE INDEX [IX_ObjectName_ObjT]
    ON [dbo].[ObjectName] (
        [ObjT_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_ObjectSelection_Proj'
CREATE INDEX [IX_ObjectSelection_Proj]
    ON [dbo].[ObjectSelection] (
        [Proj_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_ObjectSelection_ObjectType_OS'
CREATE INDEX [IX_ObjectSelection_ObjectType_OS]
    ON [dbo].[ObjectSelection_ObjectType] (
        [OS_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_ProjectVersion_Proj'
CREATE INDEX [IX_ProjectVersion_Proj]
    ON [dbo].[ProjectVersion] (
        [Proj_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_ProjectVersion_DB'
CREATE INDEX [IX_ProjectVersion_DB]
    ON [dbo].[ProjectVersion] (
        [DB_OID_Source]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_ProjectVersion_DBV'
CREATE INDEX [IX_ProjectVersion_DBV]
    ON [dbo].[ProjectVersion] (
        [DBV_OID_Source]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX FK_Property_Object'
CREATE INDEX [FK_Property_Object]
    ON [dbo].[Property] (
        [Obj_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX FK_Property_Columns'
CREATE INDEX [FK_Property_Columns]
    ON [dbo].[Property] (
        [Col_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Script_Proj'
CREATE INDEX [IX_Script_Proj]
    ON [dbo].[Script] (
        [Proj_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Script_Column_STbl'
CREATE INDEX [IX_Script_Column_STbl]
    ON [dbo].[Script_Column] (
        [STbl_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Script_Column_ColN'
CREATE INDEX [IX_Script_Column_ColN]
    ON [dbo].[Script_Column] (
        [ColN_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Script_Table_ObjN'
CREATE INDEX [IX_Script_Table_ObjN]
    ON [dbo].[Script_Table] (
        [ObjN_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_Script_Table_Scr'
CREATE INDEX [IX_Script_Table_Scr]
    ON [dbo].[Script_Table] (
        [Scr_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_ScriptText_Proj'
CREATE INDEX [IX_ScriptText_Proj]
    ON [dbo].[ScriptText] (
        [Proj_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE INDEX IX_ScriptText_PV'
CREATE INDEX [IX_ScriptText_PV]
    ON [dbo].[ScriptText] (
        [PV_OID]
    ) ON [PRIMARY]
GO
PRINT 'CREATE FOREIGN KEY FK_Branch_Branch'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Branch]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Branch]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Branch]
    ADD CONSTRAINT [FK_Branch_Branch] FOREIGN KEY 
    (
        [Br_OID_Parent]
    ) REFERENCES [dbo].[Branch] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Branch_Branch1'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Branch]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Branch]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Branch]
    ADD CONSTRAINT [FK_Branch_Branch1] FOREIGN KEY 
    (
        [Br_OID_Merge]
    ) REFERENCES [dbo].[Branch] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Branch_Project'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Branch]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Project]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Branch]
    ADD CONSTRAINT [FK_Branch_Project] FOREIGN KEY 
    (
        [Proj_OID]
    ) REFERENCES [dbo].[Project] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Branch_Users'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Branch]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Branch]
    ADD CONSTRAINT [FK_Branch_Users] FOREIGN KEY 
    (
        [User_OID]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_CodeSnippet_DBEngine'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[CodeSnippet]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DBEngine]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[CodeSnippet]
    ADD CONSTRAINT [FK_CodeSnippet_DBEngine] FOREIGN KEY 
    (
        [DBE_OID]
    ) REFERENCES [dbo].[DBEngine] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_CodeSnippet_Users'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[CodeSnippet]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[CodeSnippet]
    ADD CONSTRAINT [FK_CodeSnippet_Users] FOREIGN KEY 
    (
        [User_OID]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ColumnName_ObjectName'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ColumnName]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectName]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ColumnName]
    ADD CONSTRAINT [FK_ColumnName_ObjectName] FOREIGN KEY 
    (
        [ObjN_OID]
    ) REFERENCES [dbo].[ObjectName] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Columns_Object'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Columns]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Columns]
    ADD CONSTRAINT [FK_Columns_Object] FOREIGN KEY 
    (
        [Obj_OID]
    ) REFERENCES [dbo].[Object] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Comparison_ComparisonScope'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ComparisonScope]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Comparison]
    ADD CONSTRAINT [FK_Comparison_ComparisonScope] FOREIGN KEY 
    (
        [CS_OID]
    ) REFERENCES [dbo].[ComparisonScope] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Comparison_MultiComparison'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[MultiComparison]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Comparison]
    ADD CONSTRAINT [FK_Comparison_MultiComparison] FOREIGN KEY 
    (
        [MComp_OID]
    ) REFERENCES [dbo].[MultiComparison] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Comparison_ObjectSelection'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectSelection]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Comparison]
    ADD CONSTRAINT [FK_Comparison_ObjectSelection] FOREIGN KEY 
    (
        [OS_OID]
    ) REFERENCES [dbo].[ObjectSelection] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Comparison_ProjectVersion'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Comparison]
    ADD CONSTRAINT [FK_Comparison_ProjectVersion] FOREIGN KEY 
    (
        [PV_OID_Ref]
    ) REFERENCES [dbo].[ProjectVersion] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Comparison_ProjectVersion1'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Comparison]
    ADD CONSTRAINT [FK_Comparison_ProjectVersion1] FOREIGN KEY 
    (
        [PV_OID_Diff]
    ) REFERENCES [dbo].[ProjectVersion] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Comparison_Users1'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Comparison]
    ADD CONSTRAINT [FK_Comparison_Users1] FOREIGN KEY 
    (
        [User_OID_Locked]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Comparison_Users2'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Comparison]
    ADD CONSTRAINT [FK_Comparison_Users2] FOREIGN KEY 
    (
        [User_OID]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Comparison_Column_Columns'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison_Column]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Columns]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Comparison_Column]
    ADD CONSTRAINT [FK_Comparison_Column_Columns] FOREIGN KEY 
    (
        [Col_OID_Ref]
    ) REFERENCES [dbo].[Columns] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Comparison_Column_Columns1'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison_Column]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Columns]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Comparison_Column]
    ADD CONSTRAINT [FK_Comparison_Column_Columns1] FOREIGN KEY 
    (
        [Col_OID_Diff]
    ) REFERENCES [dbo].[Columns] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Comparison_Column_Comparison_Object'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison_Column]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison_Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Comparison_Column]
    ADD CONSTRAINT [FK_Comparison_Column_Comparison_Object] FOREIGN KEY 
    (
        [CObj_OID]
    ) REFERENCES [dbo].[Comparison_Object] (
        [OID]
    )
    ON DELETE CASCADE
GO
PRINT 'CREATE FOREIGN KEY FK_Comparison_Object_Comparison'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison_Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Comparison_Object]
    ADD CONSTRAINT [FK_Comparison_Object_Comparison] FOREIGN KEY 
    (
        [Comp_OID]
    ) REFERENCES [dbo].[Comparison] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Comparison_Object_Object'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison_Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Comparison_Object]
    ADD CONSTRAINT [FK_Comparison_Object_Object] FOREIGN KEY 
    (
        [Obj_OID_Ref]
    ) REFERENCES [dbo].[Object] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Comparison_Object_Object1'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison_Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Comparison_Object]
    ADD CONSTRAINT [FK_Comparison_Object_Object1] FOREIGN KEY 
    (
        [Obj_OID_Diff]
    ) REFERENCES [dbo].[Object] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Comparison_Object_Script'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison_Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Comparison_Object]
    ADD CONSTRAINT [FK_Comparison_Object_Script] FOREIGN KEY 
    (
        [Scr_OID]
    ) REFERENCES [dbo].[Script] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Contact_Customer'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Contact]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Customer]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Contact]
    ADD CONSTRAINT [FK_Contact_Customer] FOREIGN KEY 
    (
        [Cust_OID]
    ) REFERENCES [dbo].[Customer] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Customer_Project'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Customer]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Project]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Customer]
    ADD CONSTRAINT [FK_Customer_Project] FOREIGN KEY 
    (
        [Proj_OID]
    ) REFERENCES [dbo].[Project] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Databases_Project'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Databases]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Project]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Databases]
    ADD CONSTRAINT [FK_Databases_Project] FOREIGN KEY 
    (
        [Proj_OID]
    ) REFERENCES [dbo].[Project] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Databases_Users'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Databases]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Databases]
    ADD CONSTRAINT [FK_Databases_Users] FOREIGN KEY 
    (
        [User_OID]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_DatabaseVersion_Databases'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DatabaseVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Databases]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DatabaseVersion]
    ADD CONSTRAINT [FK_DatabaseVersion_Databases] FOREIGN KEY 
    (
        [DB_OID]
    ) REFERENCES [dbo].[Databases] (
        [OID]
    )
    ON DELETE CASCADE
GO
PRINT 'CREATE FOREIGN KEY FK_DatabaseVersion_SqlVersion'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DatabaseVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[SqlVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DatabaseVersion]
    ADD CONSTRAINT [FK_DatabaseVersion_SqlVersion] FOREIGN KEY 
    (
        [SqlV_OID]
    ) REFERENCES [dbo].[SqlVersion] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_DBEngine_DiagramType_DBEngine'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DBEngine_DiagramType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DBEngine]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DBEngine_DiagramType]
    ADD CONSTRAINT [FK_DBEngine_DiagramType_DBEngine] FOREIGN KEY 
    (
        [DBE_OID]
    ) REFERENCES [dbo].[DBEngine] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_DBEngine_DiagramType_DiagramType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DBEngine_DiagramType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DiagramType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DBEngine_DiagramType]
    ADD CONSTRAINT [FK_DBEngine_DiagramType_DiagramType] FOREIGN KEY 
    (
        [DiaT_OID]
    ) REFERENCES [dbo].[DiagramType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_DBEngine_ScriptTextType_DBEngine'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DBEngine_ScriptTextType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DBEngine]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DBEngine_ScriptTextType]
    ADD CONSTRAINT [FK_DBEngine_ScriptTextType_DBEngine] FOREIGN KEY 
    (
        [DBE_OID]
    ) REFERENCES [dbo].[DBEngine] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_DBEngine_ScriptTextType_ScriptTextType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DBEngine_ScriptTextType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ScriptTextType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DBEngine_ScriptTextType]
    ADD CONSTRAINT [FK_DBEngine_ScriptTextType_ScriptTextType] FOREIGN KEY 
    (
        [STT_OID]
    ) REFERENCES [dbo].[ScriptTextType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Dependency_DependencyType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Dependency]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DependencyType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Dependency]
    ADD CONSTRAINT [FK_Dependency_DependencyType] FOREIGN KEY 
    (
        [DepT_OID]
    ) REFERENCES [dbo].[DependencyType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Dependency_Object'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Dependency]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Dependency]
    ADD CONSTRAINT [FK_Dependency_Object] FOREIGN KEY 
    (
        [Obj_OID]
    ) REFERENCES [dbo].[Object] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Dependency_Object1'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Dependency]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Dependency]
    ADD CONSTRAINT [FK_Dependency_Object1] FOREIGN KEY 
    (
        [Obj_OID_DependsOn]
    ) REFERENCES [dbo].[Object] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Diagram_DiagramType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Diagram]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DiagramType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Diagram]
    ADD CONSTRAINT [FK_Diagram_DiagramType] FOREIGN KEY 
    (
        [DiaT_OID]
    ) REFERENCES [dbo].[DiagramType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Diagram_ObjectSelection'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Diagram]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectSelection]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Diagram]
    ADD CONSTRAINT [FK_Diagram_ObjectSelection] FOREIGN KEY 
    (
        [OS_OID]
    ) REFERENCES [dbo].[ObjectSelection] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Diagram_ProjectVersion'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Diagram]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Diagram]
    ADD CONSTRAINT [FK_Diagram_ProjectVersion] FOREIGN KEY 
    (
        [PV_OID]
    ) REFERENCES [dbo].[ProjectVersion] (
        [OID]
    )
    ON DELETE CASCADE
GO
PRINT 'CREATE FOREIGN KEY FK_DocGen_DocGenType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DocGen]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DocGenType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DocGen]
    ADD CONSTRAINT [FK_DocGen_DocGenType] FOREIGN KEY 
    (
        [DGT_OID]
    ) REFERENCES [dbo].[DocGenType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_DocGen_ObjectName'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DocGen]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectName]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DocGen]
    ADD CONSTRAINT [FK_DocGen_ObjectName] FOREIGN KEY 
    (
        [ObjN_OID_View]
    ) REFERENCES [dbo].[ObjectName] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_DocGen_Project'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DocGen]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Project]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DocGen]
    ADD CONSTRAINT [FK_DocGen_Project] FOREIGN KEY 
    (
        [Proj_OID]
    ) REFERENCES [dbo].[Project] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_DocGen_ProjectVersion'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DocGen]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DocGen]
    ADD CONSTRAINT [FK_DocGen_ProjectVersion] FOREIGN KEY 
    (
        [PV_OID]
    ) REFERENCES [dbo].[ProjectVersion] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_DocGen_Users'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DocGen]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DocGen]
    ADD CONSTRAINT [FK_DocGen_Users] FOREIGN KEY 
    (
        [User_OID]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_DocGenPart_Databases'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DocGenPart]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Databases]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DocGenPart]
    ADD CONSTRAINT [FK_DocGenPart_Databases] FOREIGN KEY 
    (
        [DB_OID_Xml]
    ) REFERENCES [dbo].[Databases] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_DocGenPart_DocGen'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DocGenPart]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DocGen]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DocGenPart]
    ADD CONSTRAINT [FK_DocGenPart_DocGen] FOREIGN KEY 
    (
        [DG_OID]
    ) REFERENCES [dbo].[DocGen] (
        [OID]
    )
    ON DELETE CASCADE
GO
PRINT 'CREATE FOREIGN KEY FK_DocGenPart_ObjectSelection'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DocGenPart]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectSelection]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DocGenPart]
    ADD CONSTRAINT [FK_DocGenPart_ObjectSelection] FOREIGN KEY 
    (
        [OS_OID]
    ) REFERENCES [dbo].[ObjectSelection] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_DocGenPart_ObjectType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DocGenPart]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DocGenPart]
    ADD CONSTRAINT [FK_DocGenPart_ObjectType] FOREIGN KEY 
    (
        [ObjT_OID]
    ) REFERENCES [dbo].[ObjectType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_DocGenPart_Script'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DocGenPart]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DocGenPart]
    ADD CONSTRAINT [FK_DocGenPart_Script] FOREIGN KEY 
    (
        [Scr_OID_Xml]
    ) REFERENCES [dbo].[Script] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_DocGenPart_XSL'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DocGenPart]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[XSL]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[DocGenPart]
    ADD CONSTRAINT [FK_DocGenPart_XSL] FOREIGN KEY 
    (
        [XSL_OID]
    ) REFERENCES [dbo].[XSL] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Installation_Contact'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Installation]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Contact]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Installation]
    ADD CONSTRAINT [FK_Installation_Contact] FOREIGN KEY 
    (
        [Cont_OID]
    ) REFERENCES [dbo].[Contact] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Installation_Customer'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Installation]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Customer]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Installation]
    ADD CONSTRAINT [FK_Installation_Customer] FOREIGN KEY 
    (
        [Cust_OID]
    ) REFERENCES [dbo].[Customer] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Installation_ProjectVersion'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Installation]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Installation]
    ADD CONSTRAINT [FK_Installation_ProjectVersion] FOREIGN KEY 
    (
        [PV_OID]
    ) REFERENCES [dbo].[ProjectVersion] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_MultiComparison_Project'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[MultiComparison]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Project]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[MultiComparison]
    ADD CONSTRAINT [FK_MultiComparison_Project] FOREIGN KEY 
    (
        [Proj_OID]
    ) REFERENCES [dbo].[Project] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_MultiComparison_Users'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[MultiComparison]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[MultiComparison]
    ADD CONSTRAINT [FK_MultiComparison_Users] FOREIGN KEY 
    (
        [User_OID]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_MultiComparison_ProjectVersion_MultiComparison'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[MultiComparison_ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[MultiComparison]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[MultiComparison_ProjectVersion]
    ADD CONSTRAINT [FK_MultiComparison_ProjectVersion_MultiComparison] FOREIGN KEY 
    (
        [MComp_OID]
    ) REFERENCES [dbo].[MultiComparison] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_MultiComparison_ProjectVersion_ProjectVersion'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[MultiComparison_ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[MultiComparison_ProjectVersion]
    ADD CONSTRAINT [FK_MultiComparison_ProjectVersion_ProjectVersion] FOREIGN KEY 
    (
        [PV_OID]
    ) REFERENCES [dbo].[ProjectVersion] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_MultiComparison_ProjectVersion_Users'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[MultiComparison_ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[MultiComparison_ProjectVersion]
    ADD CONSTRAINT [FK_MultiComparison_ProjectVersion_Users] FOREIGN KEY 
    (
        [User_OID]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Object_Object'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Object]
    ADD CONSTRAINT [FK_Object_Object] FOREIGN KEY 
    (
        [Obj_OID_Parent]
    ) REFERENCES [dbo].[Object] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Object_ObjectName'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectName]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Object]
    ADD CONSTRAINT [FK_Object_ObjectName] FOREIGN KEY 
    (
        [ObjN_OID]
    ) REFERENCES [dbo].[ObjectName] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Object_ObjectType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Object]
    ADD CONSTRAINT [FK_Object_ObjectType] FOREIGN KEY 
    (
        [ObjT_OID]
    ) REFERENCES [dbo].[ObjectType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Object_ProjectVersion'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Object]
    ADD CONSTRAINT [FK_Object_ProjectVersion] FOREIGN KEY 
    (
        [PV_OID]
    ) REFERENCES [dbo].[ProjectVersion] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Object_Column_Columns'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object_Column]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Columns]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Object_Column]
    ADD CONSTRAINT [FK_Object_Column_Columns] FOREIGN KEY 
    (
        [Col_OID]
    ) REFERENCES [dbo].[Columns] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Object_Column_Columns1'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object_Column]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Columns]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Object_Column]
    ADD CONSTRAINT [FK_Object_Column_Columns1] FOREIGN KEY 
    (
        [Col_OID_Ref]
    ) REFERENCES [dbo].[Columns] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Object_Column_Object'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object_Column]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Object_Column]
    ADD CONSTRAINT [FK_Object_Column_Object] FOREIGN KEY 
    (
        [Obj_OID]
    ) REFERENCES [dbo].[Object] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Object_Column_Object1'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object_Column]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Object_Column]
    ADD CONSTRAINT [FK_Object_Column_Object1] FOREIGN KEY 
    (
        [Obj_OID_Ref]
    ) REFERENCES [dbo].[Object] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Object_Column_Object2'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object_Column]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Object_Column]
    ADD CONSTRAINT [FK_Object_Column_Object2] FOREIGN KEY 
    (
        [Obj_OID_Rel]
    ) REFERENCES [dbo].[Object] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ObjectName_ObjectType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectName]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ObjectName]
    ADD CONSTRAINT [FK_ObjectName_ObjectType] FOREIGN KEY 
    (
        [ObjT_OID]
    ) REFERENCES [dbo].[ObjectType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ObjectName_Project'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectName]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Project]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ObjectName]
    ADD CONSTRAINT [FK_ObjectName_Project] FOREIGN KEY 
    (
        [Proj_OID]
    ) REFERENCES [dbo].[Project] (
        [OID]
    )
    ON DELETE CASCADE
GO
PRINT 'CREATE FOREIGN KEY FK_ObjectSelection_Project'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectSelection]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Project]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ObjectSelection]
    ADD CONSTRAINT [FK_ObjectSelection_Project] FOREIGN KEY 
    (
        [Proj_OID]
    ) REFERENCES [dbo].[Project] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ObjectSelection_Users'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectSelection]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ObjectSelection]
    ADD CONSTRAINT [FK_ObjectSelection_Users] FOREIGN KEY 
    (
        [User_OID]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ObjectSelection_Object_Object'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectSelection_Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ObjectSelection_Object]
    ADD CONSTRAINT [FK_ObjectSelection_Object_Object] FOREIGN KEY 
    (
        [Obj_OID]
    ) REFERENCES [dbo].[Object] (
        [OID]
    )
    ON DELETE CASCADE
GO
PRINT 'CREATE FOREIGN KEY FK_ObjectSelection_Object_ObjectName'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectSelection_Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectName]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ObjectSelection_Object]
    ADD CONSTRAINT [FK_ObjectSelection_Object_ObjectName] FOREIGN KEY 
    (
        [ObjN_OID]
    ) REFERENCES [dbo].[ObjectName] (
        [OID]
    )
    ON DELETE CASCADE
GO
PRINT 'CREATE FOREIGN KEY FK_ObjectSelection_Object_ObjectSelection_ObjectType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectSelection_Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectSelection_ObjectType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ObjectSelection_Object]
    ADD CONSTRAINT [FK_ObjectSelection_Object_ObjectSelection_ObjectType] FOREIGN KEY 
    (
        [OSOT_OID]
    ) REFERENCES [dbo].[ObjectSelection_ObjectType] (
        [OID]
    )
    ON DELETE CASCADE
GO
PRINT 'CREATE FOREIGN KEY FK_ObjectSelection_ObjectType_ObjectSelection'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectSelection_ObjectType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectSelection]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ObjectSelection_ObjectType]
    ADD CONSTRAINT [FK_ObjectSelection_ObjectType_ObjectSelection] FOREIGN KEY 
    (
        [OS_OID]
    ) REFERENCES [dbo].[ObjectSelection] (
        [OID]
    )
    ON DELETE CASCADE
GO
PRINT 'CREATE FOREIGN KEY FK_ObjectSelection_ObjectType_ObjectType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectSelection_ObjectType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ObjectSelection_ObjectType]
    ADD CONSTRAINT [FK_ObjectSelection_ObjectType_ObjectType] FOREIGN KEY 
    (
        [ObjT_OID]
    ) REFERENCES [dbo].[ObjectType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ObjectType_ObjectTypeType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectTypeType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ObjectType]
    ADD CONSTRAINT [FK_ObjectType_ObjectTypeType] FOREIGN KEY 
    (
        [OTT_OID]
    ) REFERENCES [dbo].[ObjectTypeType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Project_DBEngine'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Project]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DBEngine]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Project]
    ADD CONSTRAINT [FK_Project_DBEngine] FOREIGN KEY 
    (
        [DBE_OID]
    ) REFERENCES [dbo].[DBEngine] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Project_Users'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Project]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Project]
    ADD CONSTRAINT [FK_Project_Users] FOREIGN KEY 
    (
        [User_OID]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Project_Role_Project'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Project_Role]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Project]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Project_Role]
    ADD CONSTRAINT [FK_Project_Role_Project] FOREIGN KEY 
    (
        [Proj_OID]
    ) REFERENCES [dbo].[Project] (
        [OID]
    )
    ON DELETE CASCADE
GO
PRINT 'CREATE FOREIGN KEY FK_Project_Role_Role'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Project_Role]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Role]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Project_Role]
    ADD CONSTRAINT [FK_Project_Role_Role] FOREIGN KEY 
    (
        [Role_OID]
    ) REFERENCES [dbo].[Role] (
        [OID]
    )
    ON DELETE CASCADE
GO
PRINT 'CREATE FOREIGN KEY FK_ProjectVersion_Branch'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Branch]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ProjectVersion]
    ADD CONSTRAINT [FK_ProjectVersion_Branch] FOREIGN KEY 
    (
        [Br_OID]
    ) REFERENCES [dbo].[Branch] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ProjectVersion_Databases'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Databases]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ProjectVersion]
    ADD CONSTRAINT [FK_ProjectVersion_Databases] FOREIGN KEY 
    (
        [DB_OID_Source]
    ) REFERENCES [dbo].[Databases] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ProjectVersion_DatabaseVersion'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DatabaseVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ProjectVersion]
    ADD CONSTRAINT [FK_ProjectVersion_DatabaseVersion] FOREIGN KEY 
    (
        [DBV_OID_Source]
    ) REFERENCES [dbo].[DatabaseVersion] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ProjectVersion_Project'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Project]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ProjectVersion]
    ADD CONSTRAINT [FK_ProjectVersion_Project] FOREIGN KEY 
    (
        [Proj_OID]
    ) REFERENCES [dbo].[Project] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ProjectVersion_ProjectVersionType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersionType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ProjectVersion]
    ADD CONSTRAINT [FK_ProjectVersion_ProjectVersionType] FOREIGN KEY 
    (
        [PVT_OID]
    ) REFERENCES [dbo].[ProjectVersionType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ProjectVersion_SqlVersion'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[SqlVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ProjectVersion]
    ADD CONSTRAINT [FK_ProjectVersion_SqlVersion] FOREIGN KEY 
    (
        [SqlV_OID]
    ) REFERENCES [dbo].[SqlVersion] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ProjectVersion_Users'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ProjectVersion]
    ADD CONSTRAINT [FK_ProjectVersion_Users] FOREIGN KEY 
    (
        [User_OID]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ProjectVersion_Users1'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ProjectVersion]
    ADD CONSTRAINT [FK_ProjectVersion_Users1] FOREIGN KEY 
    (
        [User_OID_Locked]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Property_Columns'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Property]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Columns]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Property]
    ADD CONSTRAINT [FK_Property_Columns] FOREIGN KEY 
    (
        [Col_OID]
    ) REFERENCES [dbo].[Columns] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Property_Object'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Property]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Object]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Property]
    ADD CONSTRAINT [FK_Property_Object] FOREIGN KEY 
    (
        [Obj_OID]
    ) REFERENCES [dbo].[Object] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Property_PropertyType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Property]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[PropertyType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Property]
    ADD CONSTRAINT [FK_Property_PropertyType] FOREIGN KEY 
    (
        [PropT_OID]
    ) REFERENCES [dbo].[PropertyType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Script_Project'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Project]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Script]
    ADD CONSTRAINT [FK_Script_Project] FOREIGN KEY 
    (
        [Proj_OID]
    ) REFERENCES [dbo].[Project] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Script_ScriptType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ScriptType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Script]
    ADD CONSTRAINT [FK_Script_ScriptType] FOREIGN KEY 
    (
        [ST_OID]
    ) REFERENCES [dbo].[ScriptType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Script_Users'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Script]
    ADD CONSTRAINT [FK_Script_Users] FOREIGN KEY 
    (
        [User_OID]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Script_Column_ColumnName'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script_Column]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ColumnName]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Script_Column]
    ADD CONSTRAINT [FK_Script_Column_ColumnName] FOREIGN KEY 
    (
        [ColN_OID]
    ) REFERENCES [dbo].[ColumnName] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Script_Column_Script_Table'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script_Column]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script_Table]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Script_Column]
    ADD CONSTRAINT [FK_Script_Column_Script_Table] FOREIGN KEY 
    (
        [STbl_OID]
    ) REFERENCES [dbo].[Script_Table] (
        [OID]
    )
    ON DELETE CASCADE
GO
PRINT 'CREATE FOREIGN KEY FK_Script_Table_ColumnName'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script_Table]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ColumnName]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Script_Table]
    ADD CONSTRAINT [FK_Script_Table_ColumnName] FOREIGN KEY 
    (
        [ColN_OID_Seq1]
    ) REFERENCES [dbo].[ColumnName] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Script_Table_ColumnName1'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script_Table]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ColumnName]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Script_Table]
    ADD CONSTRAINT [FK_Script_Table_ColumnName1] FOREIGN KEY 
    (
        [ColN_OID_Seq2]
    ) REFERENCES [dbo].[ColumnName] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Script_Table_ColumnName2'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script_Table]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ColumnName]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Script_Table]
    ADD CONSTRAINT [FK_Script_Table_ColumnName2] FOREIGN KEY 
    (
        [ColN_OID_Seq3]
    ) REFERENCES [dbo].[ColumnName] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Script_Table_ObjectName'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script_Table]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectName]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Script_Table]
    ADD CONSTRAINT [FK_Script_Table_ObjectName] FOREIGN KEY 
    (
        [ObjN_OID]
    ) REFERENCES [dbo].[ObjectName] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_Script_Table_Script'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script_Table]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Script_Table]
    ADD CONSTRAINT [FK_Script_Table_Script] FOREIGN KEY 
    (
        [Scr_OID]
    ) REFERENCES [dbo].[Script] (
        [OID]
    )
    ON DELETE CASCADE
GO
PRINT 'CREATE FOREIGN KEY FK_Script_Table_ScriptTableMode'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script_Table]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ScriptTableMode]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[Script_Table]
    ADD CONSTRAINT [FK_Script_Table_ScriptTableMode] FOREIGN KEY 
    (
        [STM_OID]
    ) REFERENCES [dbo].[ScriptTableMode] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ScriptTableMode_ScriptType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ScriptTableMode]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ScriptType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ScriptTableMode]
    ADD CONSTRAINT [FK_ScriptTableMode_ScriptType] FOREIGN KEY 
    (
        [ST_OID]
    ) REFERENCES [dbo].[ScriptType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ScriptText_Comparison'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ScriptText]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Comparison]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ScriptText]
    ADD CONSTRAINT [FK_ScriptText_Comparison] FOREIGN KEY 
    (
        [Comp_OID]
    ) REFERENCES [dbo].[Comparison] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ScriptText_Project'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ScriptText]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Project]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ScriptText]
    ADD CONSTRAINT [FK_ScriptText_Project] FOREIGN KEY 
    (
        [Proj_OID]
    ) REFERENCES [dbo].[Project] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ScriptText_ProjectVersion'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ScriptText]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ProjectVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ScriptText]
    ADD CONSTRAINT [FK_ScriptText_ProjectVersion] FOREIGN KEY 
    (
        [PV_OID]
    ) REFERENCES [dbo].[ProjectVersion] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ScriptText_Script'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ScriptText]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Script]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ScriptText]
    ADD CONSTRAINT [FK_ScriptText_Script] FOREIGN KEY 
    (
        [Scr_OID]
    ) REFERENCES [dbo].[Script] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ScriptText_ScriptTextType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ScriptText]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ScriptTextType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ScriptText]
    ADD CONSTRAINT [FK_ScriptText_ScriptTextType] FOREIGN KEY 
    (
        [STT_OID]
    ) REFERENCES [dbo].[ScriptTextType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ScriptText_SqlVersion'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ScriptText]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[SqlVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ScriptText]
    ADD CONSTRAINT [FK_ScriptText_SqlVersion] FOREIGN KEY 
    (
        [SqlV_OID]
    ) REFERENCES [dbo].[SqlVersion] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_ScriptText_Users'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ScriptText]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[ScriptText]
    ADD CONSTRAINT [FK_ScriptText_Users] FOREIGN KEY 
    (
        [User_OID]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_SqlVersion_DBEngine'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[SqlVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DBEngine]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[SqlVersion]
    ADD CONSTRAINT [FK_SqlVersion_DBEngine] FOREIGN KEY 
    (
        [DBE_OID]
    ) REFERENCES [dbo].[DBEngine] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_SqlVersion_ObjectType_ObjectType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[SqlVersion_ObjectType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[ObjectType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[SqlVersion_ObjectType]
    ADD CONSTRAINT [FK_SqlVersion_ObjectType_ObjectType] FOREIGN KEY 
    (
        [ObjT_OID]
    ) REFERENCES [dbo].[ObjectType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_SqlVersion_ObjectType_SqlVersion'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[SqlVersion_ObjectType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[SqlVersion]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[SqlVersion_ObjectType]
    ADD CONSTRAINT [FK_SqlVersion_ObjectType_SqlVersion] FOREIGN KEY 
    (
        [SqlV_OID]
    ) REFERENCES [dbo].[SqlVersion] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_User_Role_Role'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[User_Role]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Role]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[User_Role]
    ADD CONSTRAINT [FK_User_Role_Role] FOREIGN KEY 
    (
        [Role_OID]
    ) REFERENCES [dbo].[Role] (
        [OID]
    )
    ON DELETE CASCADE
GO
PRINT 'CREATE FOREIGN KEY FK_User_Role_Users'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[User_Role]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[User_Role]
    ADD CONSTRAINT [FK_User_Role_Users] FOREIGN KEY 
    (
        [User_OID]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
    ON DELETE CASCADE
GO
PRINT 'CREATE FOREIGN KEY FK_XSL_DBEngine'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[XSL]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DBEngine]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[XSL]
    ADD CONSTRAINT [FK_XSL_DBEngine] FOREIGN KEY 
    (
        [DBE_OID]
    ) REFERENCES [dbo].[DBEngine] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_XSL_DocGenType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[XSL]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[DocGenType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[XSL]
    ADD CONSTRAINT [FK_XSL_DocGenType] FOREIGN KEY 
    (
        [DGT_OID]
    ) REFERENCES [dbo].[DocGenType] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_XSL_Users'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[XSL]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[Users]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[XSL]
    ADD CONSTRAINT [FK_XSL_Users] FOREIGN KEY 
    (
        [User_OID]
    ) REFERENCES [dbo].[Users] (
        [OID]
    )
GO
PRINT 'CREATE FOREIGN KEY FK_XSL_XslType'
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[XSL]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
if exists (select * from dbo.sysobjects where id = object_id('[dbo].[XslType]') and OBJECTPROPERTY(id, 'IsUserTable') = 1 and OBJECTPROPERTY(id, 'IsMSShipped') = 0)
ALTER TABLE [dbo].[XSL]
    ADD CONSTRAINT [FK_XSL_XslType] FOREIGN KEY 
    (
        [XslT_OID]
    ) REFERENCES [dbo].[XslType] (
        [OID]
    )
GO
PRINT 'CREATE FUNCTION dbo.Date_Between'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE  FUNCTION [dbo].[Date_Between] (@Date AS DATETIME, @From AS DATETIME, @Until AS DATETIME)
RETURNS INT AS  
BEGIN 

	IF @Date IS NULL
		RETURN 1
	ELSE IF @From IS NULL AND @Until IS NULL
		RETURN 1
	ELSE IF @From IS NULL AND @Date < @Until
		RETURN 1
	ELSE IF @Until IS NULL AND @Date >= @From
		RETURN 1
	ELSE IF @Date >= @From AND @Date < @Until
		RETURN 1

	RETURN 0	
END
GO
PRINT 'CREATE FUNCTION dbo.Get_Object_Columns'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE   FUNCTION dbo.Get_Object_Columns(
	@OID	INT
) 
RETURNS NVARCHAR(4000)
AS
BEGIN
	DECLARE @ObjT_OID INT, @s NVARCHAR(4000)
	SELECT	@ObjT_OID = ObjT_OID FROM Object WHERE OID = @OID
	SET @s = ''

	DECLARE @ID NVARCHAR(128), @IsDesc BIT, @ID2 NVARCHAR(128)

	IF @ObjT_OID = 13 BEGIN	-- index
		DECLARE c CURSOR FOR
		SELECT	Columns.ID, Object_Column.IsDesc
		FROM	Object_Column 
		INNER JOIN Columns ON Object_Column.Col_OID = Columns.OID
		WHERE	Object_Column.Obj_OID = @OID
		ORDER BY Object_Column.Seq

		OPEN c
		FETCH c INTO @ID, @IsDesc

		WHILE @@FETCH_STATUS = 0 BEGIN
			IF @s <> '' SET @s = @s + ', '
			SET @s = @s + @ID

			IF @IsDesc = 1 SET @s = @s + ' DESC'

			FETCH c INTO @ID, @IsDesc
		END		

		CLOSE c
		DEALLOCATE c
	END

	IF @ObjT_OID = 10 BEGIN	-- foreign key
		DECLARE c CURSOR FOR
		SELECT	Columns.ID, Columns_1.ID AS ID2
		FROM	Object_Column        
		INNER JOIN Columns ON Columns.OID = Object_Column.Col_OID 
		INNER JOIN Columns Columns_1 ON Object_Column.Col_OID_Ref = Columns_1.OID
		WHERE	Object_Column.Obj_OID_Rel = @OID
		ORDER BY dbo.Object_Column.Seq

		OPEN c
		FETCH c INTO @ID, @ID2

		WHILE @@FETCH_STATUS = 0 BEGIN
			IF @s <> '' SET @s = @s + ', '
			SET @s = @s + @ID + '=' + @ID2

			FETCH c INTO @ID, @ID2
		END		

		CLOSE c
		DEALLOCATE c
	END

	RETURN @s
END
GO
PRINT 'CREATE FUNCTION dbo.Get_ScriptTable_ExcludedColumns'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE  FUNCTION [dbo].[Get_ScriptTable_ExcludedColumns](@STbl_OID INT, @PV_OID INT)
RETURNS VARCHAR(4000) AS
BEGIN
	DECLARE @s VARCHAR(4000), @sT VARCHAR(50)
	SET @s = ''

	IF @PV_OID IS NULL 
		DECLARE c CURSOR FOR
		SELECT	ColumnName.ID
		FROM	ColumnName 
		INNER JOIN Script_Table ON Script_Table.ObjN_OID = ColumnName.ObjN_OID
		LEFT OUTER JOIN Script_Column ON Script_Column.ColN_OID = ColumnName.OID
			AND Script_Column.STbl_OID = Script_Table.OID
		WHERE	Script_Table.OID = @STbl_OID
		AND	Script_Column.OID IS NULL
		ORDER BY ColumnName.OID

	ELSE
		DECLARE c CURSOR FOR
		SELECT	Columns.ID
		FROM	Columns 
		INNER JOIN ColumnName ON Columns.ColN_OID = ColumnName.OID
		INNER JOIN Script_Table ON Script_Table.ObjN_OID = ColumnName.ObjN_OID
		INNER JOIN Object ON Columns.Obj_OID = Object.OID
		LEFT OUTER JOIN Script_Column ON Script_Column.ColN_OID = ColumnName.OID
			AND Script_Column.STbl_OID = Script_Table.OID
		WHERE	Script_Table.OID = @STbl_OID
		AND	Object.PV_OID = @PV_OID
		AND	Script_Column.OID IS NULL
		ORDER BY Columns.ColOrder

	OPEN c
	FETCH c INTO @sT

	WHILE @@FETCH_STATUS = 0 BEGIN

		SET @s = @s + ', ' + @sT

		FETCH c INTO @sT
	END

	CLOSE c
	DEALLOCATE c

	IF @s = ''
		RETURN NULL

	RETURN SUBSTRING(@s, 3, LEN(@s)-2)
END
GO
PRINT 'CREATE FUNCTION dbo.Get_ScriptTable_IncludedColumns'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE  FUNCTION [dbo].[Get_ScriptTable_IncludedColumns](@STbl_OID INT, @PV_OID INT)
RETURNS VARCHAR(4000) AS
BEGIN
	DECLARE @s VARCHAR(4000), @sT VARCHAR(50)
	SET @s = ''

	IF @PV_OID IS NULL 
		DECLARE c CURSOR FOR
		SELECT	ColumnName.ID
		FROM	Script_Column
		INNER JOIN ColumnName ON Script_Column.ColN_OID = ColumnName.OID
		WHERE	Script_Column.STbl_OID = @STbl_OID
		ORDER BY ColumnName.OID

	ELSE
		DECLARE c CURSOR FOR
		SELECT	Columns.ID
		FROM	Script_Column
		INNER JOIN Columns ON Script_Column.ColN_OID = Columns.ColN_OID
		INNER JOIN Object ON Columns.Obj_OID = Object.OID
		WHERE	Script_Column.STbl_OID = @STbl_OID
		AND	Object.PV_OID = @PV_OID
		ORDER BY Columns.ColOrder

	OPEN c
	FETCH c INTO @sT

	WHILE @@FETCH_STATUS = 0 BEGIN

		SET @s = @s + ', ' + @sT

		FETCH c INTO @sT
	END

	CLOSE c
	DEALLOCATE c

	IF @s = ''
		RETURN NULL

	RETURN SUBSTRING(@s, 3, LEN(@s)-2)
END
GO
PRINT 'CREATE FUNCTION dbo.Get_TextBlock'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE FUNCTION [dbo].[Get_TextBlock] (
	@TBl_ID		VARCHAR(50)
) 
RETURNS NVARCHAR(500) AS
BEGIN 
	DECLARE @s NVARCHAR(500)

	SELECT	@s = TextBlock.TheText
	FROM	TextBlock
	WHERE	TextBlock.ID = @TBl_ID

	RETURN 	ISNULL(@s, @Tbl_ID)
END
GO
PRINT 'CREATE FUNCTION dbo.NTexts_Equal'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date, ,>
-- Description:	<Description, ,>
-- =============================================
CREATE FUNCTION [dbo].[NTexts_Equal](
	@a	NTEXT,
	@b	NTEXT
)
RETURNS INT AS
BEGIN
	IF @a IS NULL AND @b IS NULL RETURN 1

	IF @a IS NULL OR @b IS NULL RETURN 0

	IF DATALENGTH(@a)<>DATALENGTH(@b) RETURN 0

	DECLARE @i INT, @l INT, @ll INT
	SET @i = 1
	SET @l = DATALENGTH(@a)

	WHILE @i < @l BEGIN

		IF SUBSTRING(@a, @i, 1000)<>SUBSTRING(@b, @i, 1000) RETURN 0
		SET @i = @i + 1000
	END

	RETURN 1
END
GO
PRINT 'CREATE VIEW dbo.V_Compare_Result'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Compare_Result
AS
SELECT     dbo.Comparison_Object.Comp_OID, ISNULL(dbo.Object.ObjT_OID, Object_1.ObjT_OID) AS ObjT_OID, ISNULL(dbo.ObjectType.ID, ObjectType_1.ID) 
                      AS ObjT_ID, ISNULL(dbo.Object.OID, Object_1.OID) AS Obj_OID, ISNULL(dbo.Object.OwnerName, Object_1.OwnerName) AS OwnerName, 
                      ISNULL(dbo.Object.ID, Object_1.ID) AS ID, dbo.Comparison_Object.DiffText, dbo.Comparison_Object.DiffMode, dbo.Comparison_Object.InScript, 
                      dbo.Comparison_Object.OID AS CObj_OID, dbo.Comparison_Object.ColumnsChanged, dbo.Comparison_Object.ChildrenChanged
FROM         dbo.Comparison_Object LEFT OUTER JOIN
                      dbo.Object Object_1 INNER JOIN
                      dbo.ObjectType ObjectType_1 ON Object_1.ObjT_OID = ObjectType_1.OID ON dbo.Comparison_Object.Obj_OID_Diff = Object_1.OID LEFT OUTER JOIN
                      dbo.Object INNER JOIN
                      dbo.ObjectType ON dbo.Object.ObjT_OID = dbo.ObjectType.OID ON dbo.Comparison_Object.Obj_OID_Ref = dbo.Object.OID
GO
PRINT 'CREATE VIEW dbo.V_CompCol_Result'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_CompCol_Result
AS
SELECT     dbo.Comparison.OID AS Comp_OID, ISNULL(dbo.Object.ObjT_OID, Object_1.ObjT_OID) AS ObjT_OID, ISNULL(dbo.ObjectType.ID, ObjectType_1.ID) 
                      AS ObjT_ID, ISNULL(dbo.Comparison_Object.Obj_OID_Ref, dbo.Comparison_Object.Obj_OID_Diff) AS Obj_OID, ISNULL(dbo.Object.OwnerName, 
                      Object_1.OwnerName) AS OwnerName, ISNULL(dbo.Object.ID, Object_1.ID) AS Obj_ID, ISNULL(dbo.Columns.OID, Columns_1.OID) AS Col_OID, 
                      ISNULL(dbo.Columns.ID, Columns_1.ID) AS Col_ID, dbo.Comparison_Column.DiffMode, dbo.Comparison_Column.DiffText, 
                      dbo.Comparison_Column.OID AS CCol_OID, dbo.Comparison_Column.CObj_OID, dbo.Comparison_Column.InScript
FROM         dbo.Comparison_Column INNER JOIN
                      dbo.Comparison_Object INNER JOIN
                      dbo.Comparison ON dbo.Comparison_Object.Comp_OID = dbo.Comparison.OID ON 
                      dbo.Comparison_Column.CObj_OID = dbo.Comparison_Object.OID LEFT OUTER JOIN
                      dbo.Columns INNER JOIN
                      dbo.Object INNER JOIN
                      dbo.ObjectType ON dbo.Object.ObjT_OID = dbo.ObjectType.OID ON dbo.Columns.Obj_OID = dbo.Object.OID ON 
                      dbo.Comparison_Column.Col_OID_Ref = dbo.Columns.OID LEFT OUTER JOIN
                      dbo.Columns Columns_1 INNER JOIN
                      dbo.Object Object_1 INNER JOIN
                      dbo.ObjectType ObjectType_1 ON Object_1.ObjT_OID = ObjectType_1.OID ON Columns_1.Obj_OID = Object_1.OID ON 
                      dbo.Comparison_Column.Col_OID_Diff = Columns_1.OID
GO
PRINT 'CREATE VIEW dbo.V_Contact'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Contact
AS
SELECT     *, RTRIM(LTRIM(LastName + ' ' + ISNULL(FirstName, ''))) AS NameLF, RTRIM(LTRIM(ISNULL(FirstName, '') + ' ' + LastName)) AS NameFL, 
                      LastName + (CASE WHEN FirstName IS NULL THEN '' ELSE ', ' + FirstName END) AS Name
FROM         dbo.Contact
GO
PRINT 'CREATE VIEW dbo.V_Count_Comp_by_MComp'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Count_Comp_by_MComp
AS
SELECT     MComp_OID, COUNT(OID) AS Count_Comp
FROM         dbo.Comparison
GROUP BY MComp_OID
GO
PRINT 'CREATE VIEW dbo.V_Count_CompObj_by_Comp'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Count_CompObj_by_Comp
AS
SELECT     Comp_OID, COUNT(OID) AS Count_CompObj
FROM         dbo.Comparison_Object
WHERE     (DiffMode IS NOT NULL)
GROUP BY Comp_OID
GO
PRINT 'CREATE VIEW dbo.V_Count_Installation_by_Cust'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Count_Installation_by_Cust
AS
SELECT     Cust_OID, COUNT(OID) AS Count_Inst, MIN(COALESCE (DateInstalled, DateShipped)) AS DateFirst, MAX(COALESCE (DateInstalled, DateShipped)) 
                      AS DateLast
FROM         dbo.Installation
GROUP BY Cust_OID
GO
PRINT 'CREATE VIEW dbo.V_Count_MCPV_by_MComp'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Count_MCPV_by_MComp
AS
SELECT     MComp_OID, COUNT(OID) AS Count_MCPV
FROM         dbo.MultiComparison_ProjectVersion
GROUP BY MComp_OID
GO
PRINT 'CREATE VIEW dbo.V_Count_Object_by_PV'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW [dbo].[V_Count_Object_by_PV]
AS
SELECT     PV_OID, COUNT(OID) AS Count_Obj
FROM         dbo.Object
GROUP BY PV_OID
GO
PRINT 'CREATE VIEW dbo.V_Count_PV_by_Branch'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Count_PV_by_Branch
AS
SELECT     Br_OID, COUNT(OID) AS Count_PV
FROM         dbo.ProjectVersion
GROUP BY Br_OID
GO
PRINT 'CREATE VIEW dbo.V_Databases_Remote'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Databases_Remote
AS
SELECT     dbo.Databases.OID, dbo.Databases.ID, dbo.Databases.Proj_OID, dbo.Project.DBE_OID
FROM         dbo.Databases INNER JOIN
                      dbo.Project ON dbo.Databases.Proj_OID = dbo.Project.OID
WHERE     (dbo.Databases.Server IS NOT NULL) AND (dbo.Databases.Username IS NOT NULL) AND (dbo.Databases.Password IS NOT NULL) AND 
                      (dbo.Databases.IsEnabled = 1)
GO
PRINT 'CREATE VIEW dbo.V_DatabaseVersion'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_DatabaseVersion
AS
SELECT     OID, DB_OID, ISNULL(MachineName, '') + CASE WHEN InstanceName IS NULL THEN '' ELSE '.' + InstanceName END + '.' + ISNULL(DatabaseName, '') 
                      + ' ' + ISNULL(ProductVersion, '') + ' ' + ISNULL(ProductLevel, '') AS ID
FROM         dbo.DatabaseVersion
GO
PRINT 'CREATE VIEW dbo.V_Dependency'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Dependency
AS
SELECT     TOP 100 PERCENT dbo.Object.PV_OID, dbo.Object.OID, dbo.Object.ObjT_OID, dbo.ObjectType.ProgID AS ObjT_ProgID, dbo.ObjectType.WikiTitleFormat,
                       dbo.ObjectType.ID AS ObjT_ID, dbo.Object.OwnerName, dbo.Object.ID, dbo.Dependency.DepT_OID, dbo.DependencyType.ProgID AS DepT_ProgID, 
                      dbo.DependencyType.ID AS DepT_ID, Object_1.OID AS Dep_Obj_OID, Object_1.OwnerName AS Dep_OwnerName, Object_1.ID AS Dep_ID, 
                      Object_1.ObjT_OID AS Dep_ObjT_OID, ObjectType_1.ProgID AS Dep_ObjT_ProgID, ObjectType_1.ID AS Dep_ObjT_ID, 
                      ObjectType_1.WikiTitleFormat AS Dep_WikiTitleFormat
FROM         dbo.Object INNER JOIN
                      dbo.Dependency ON dbo.Object.OID = dbo.Dependency.Obj_OID INNER JOIN
                      dbo.DependencyType ON dbo.Dependency.DepT_OID = dbo.DependencyType.OID INNER JOIN
                      dbo.Object Object_1 ON dbo.Dependency.Obj_OID_DependsOn = Object_1.OID INNER JOIN
                      dbo.ObjectType ON dbo.Object.ObjT_OID = dbo.ObjectType.OID INNER JOIN
                      dbo.ObjectType ObjectType_1 ON Object_1.ObjT_OID = ObjectType_1.OID
WHERE     (dbo.Object.Obj_OID_Parent IS NULL)
GO
PRINT 'CREATE VIEW dbo.V_Dependency_Child'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Dependency_Child
AS
SELECT     TOP 100 PERCENT Object_2.PV_OID, Object_2.OID, Object_2.ObjT_OID, ObjectType_2.ProgID AS ObjT_ProgID, ObjectType_2.WikiTitleFormat, 
                      ObjectType_2.ID AS ObjT_ID, Object_2.OwnerName, Object_2.ID, dbo.Object.ObjT_OID AS Child_ObjT_OID, dbo.ObjectType.ID AS Child_ObjT_ID, 
                      dbo.ObjectType.ProgID AS Child_ObjT_ProgID, dbo.Object.OwnerName AS Child_OwnerName, dbo.Object.ID AS Child_ID, dbo.Dependency.DepT_OID, 
                      dbo.DependencyType.ID AS DepT_ID, dbo.DependencyType.ProgID AS DepT_ProgID, Object_1.OID AS Dep_Obj_OID, 
                      Object_1.OwnerName AS Dep_OwnerName, Object_1.ID AS Dep_ID, Object_1.ObjT_OID AS Dep_ObjT_OID, ObjectType_1.ID AS Dep_ObjT_ID, 
                      ObjectType_1.ProgID AS Dep_ObjT_ProgID, ObjectType_1.WikiTitleFormat AS Dep_WikiTitleFormat
FROM         dbo.Object INNER JOIN
                      dbo.Dependency ON dbo.Object.OID = dbo.Dependency.Obj_OID INNER JOIN
                      dbo.DependencyType ON dbo.Dependency.DepT_OID = dbo.DependencyType.OID INNER JOIN
                      dbo.Object Object_1 ON dbo.Dependency.Obj_OID_DependsOn = Object_1.OID INNER JOIN
                      dbo.Object Object_2 ON dbo.Object.Obj_OID_Parent = Object_2.OID INNER JOIN
                      dbo.ObjectType ON dbo.Object.ObjT_OID = dbo.ObjectType.OID INNER JOIN
                      dbo.ObjectType ObjectType_1 ON Object_1.ObjT_OID = ObjectType_1.OID INNER JOIN
                      dbo.ObjectType ObjectType_2 ON Object_2.ObjT_OID = ObjectType_2.OID
GO
PRINT 'CREATE VIEW dbo.V_Installation'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Installation
AS
SELECT     dbo.Installation.OID, dbo.Installation.Cust_OID, dbo.Installation.PV_OID, dbo.ProjectVersion.ID + ' ' + CONVERT(NVARCHAR(50), 
                      COALESCE (dbo.Installation.DateInstalled, dbo.Installation.DateShipped, dbo.Installation.Created), 102) AS ID, dbo.ProjectVersion.ID AS PV_ID, 
                      dbo.ProjectVersion.Proj_OID
FROM         dbo.Installation INNER JOIN
                      dbo.ProjectVersion ON dbo.Installation.PV_OID = dbo.ProjectVersion.OID
GO
PRINT 'CREATE VIEW dbo.V_Last_PV_by_Cust'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Last_PV_by_Cust
AS
SELECT     dbo.Installation.Cust_OID, dbo.Installation.PV_OID, dbo.ProjectVersion.ID AS PV_ID
FROM         dbo.Installation INNER JOIN
                      dbo.ProjectVersion ON dbo.Installation.PV_OID = dbo.ProjectVersion.OID
WHERE     (dbo.ProjectVersion.VersionDate =
                          (SELECT     MAX(versiondate)
                            FROM          ProjectVersion PV INNER JOIN
                                                   installation inst ON inst.pv_oid = pv.oid
                            WHERE      inst.cust_oid = installation.cust_oid))
GROUP BY dbo.Installation.Cust_OID, dbo.Installation.PV_OID, dbo.ProjectVersion.ID
GO
PRINT 'CREATE VIEW dbo.V_Object'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Object
AS
SELECT     OID, PV_OID, ObjT_OID, ObjN_OID, ID + CASE WHEN OwnerName IS NOT NULL THEN ' (' + OwnerName + ')' ELSE '' END AS ID, Obj_OID_Parent
FROM         dbo.Object
GO
PRINT 'CREATE VIEW dbo.V_ObjectName'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_ObjectName
AS
SELECT     OID, Proj_OID, ObjT_OID, ID + CASE WHEN OwnerName IS NOT NULL THEN ' (' + OwnerName + ')' ELSE '' END AS ID
FROM         dbo.ObjectName
GO
PRINT 'CREATE VIEW dbo.V_ObjectSelection'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW [dbo].[V_ObjectSelection]
AS
SELECT     Proj_OID, OID AS OS_OID
FROM         dbo.ObjectSelection
UNION
SELECT     OID, 0
FROM         Project
GO
PRINT 'CREATE VIEW dbo.V_ObjectType_BaseType'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_ObjectType_BaseType
AS
SELECT     dbo.ObjectType.OID, dbo.ObjectType.ID, dbo.ObjectType.ProgID, dbo.ObjectType.OTT_OID, dbo.ObjectType.SysobjectType
FROM         dbo.ObjectType INNER JOIN
                      dbo.ObjectTypeType ON dbo.ObjectType.OTT_OID = dbo.ObjectTypeType.OID
WHERE     (dbo.ObjectTypeType.IsBaseType = 1)
GO
PRINT 'CREATE VIEW dbo.V_ObjectType_Project'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_ObjectType_Project
AS
SELECT DISTINCT 
                      dbo.ObjectType.OID, dbo.ObjectName.Proj_OID, dbo.ObjectType.ID, dbo.ObjectType.ProgID, dbo.ObjectType.OTT_OID, 
                      dbo.ObjectTypeType.IsBaseType
FROM         dbo.ObjectName INNER JOIN
                      dbo.ObjectType ON dbo.ObjectName.ObjT_OID = dbo.ObjectType.OID INNER JOIN
                      dbo.ObjectTypeType ON dbo.ObjectType.OTT_OID = dbo.ObjectTypeType.OID
GO
PRINT 'CREATE VIEW dbo.V_Project_User'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Project_User
AS
SELECT     dbo.Project_Role.Proj_OID, dbo.User_Role.User_OID AS User_OID_Filter, CONVERT(bit, MAX(CONVERT(int, Project_Role.IsAdmin))) 
                      AS IsProjAdmin
FROM         dbo.Project_Role INNER JOIN
                      dbo.User_Role ON dbo.Project_Role.Role_OID = dbo.User_Role.Role_OID LEFT OUTER JOIN
                      Project ON Project_Role.Proj_OID = Project.OID AND User_Role.User_OID = Project.User_OID
WHERE     Project.OID IS NULL
GROUP BY dbo.Project_Role.Proj_OID, dbo.User_Role.User_OID
UNION
SELECT     Project.OID, User_OID, 1
FROM         Project
GO
PRINT 'CREATE VIEW dbo.V_Script_XML'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Script_XML
AS
SELECT     OID, Proj_OID, ID
FROM         dbo.Script
WHERE     (ST_OID = 3)
GO
PRINT 'CREATE VIEW dbo.V_SqlVersion_ObjectType'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_SqlVersion_ObjectType
AS
SELECT     dbo.SqlVersion_ObjectType.OID, dbo.SqlVersion_ObjectType.SqlV_OID, dbo.SqlVersion.ID, dbo.SqlVersion_ObjectType.ObjT_OID, 
                      dbo.ObjectType.ID AS ObjT_ID, dbo.SqlVersion_ObjectType.CreateSeq, dbo.SqlVersion_ObjectType.DropSeq, dbo.SqlVersion_ObjectType.CompSeq, 
                      dbo.SqlVersion_ObjectType.CompDropSeq, dbo.ObjectTypeType.IsBaseType
FROM         dbo.SqlVersion_ObjectType INNER JOIN
                      dbo.SqlVersion ON dbo.SqlVersion_ObjectType.SqlV_OID = dbo.SqlVersion.OID INNER JOIN
                      dbo.ObjectType ON dbo.SqlVersion_ObjectType.ObjT_OID = dbo.ObjectType.OID INNER JOIN
                      dbo.ObjectTypeType ON dbo.ObjectType.OTT_OID = dbo.ObjectTypeType.OID
GO
PRINT 'CREATE VIEW dbo.V_XSL_Script'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_XSL_Script
AS
SELECT     OID, ID
FROM         dbo.XSL
WHERE     (XslT_OID = 3)
GO
PRINT 'CREATE VIEW dbo.V_Comparison_User'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Comparison_User
AS
SELECT     dbo.Comparison.OID, dbo.Comparison.ID, dbo.Comparison.PV_OID_Ref, dbo.Comparison.PV_OID_Diff, dbo.Comparison.OS_OID, 
                      dbo.Comparison.CalcDate, dbo.V_Project_User.Proj_OID, dbo.V_Project_User.User_OID_Filter, dbo.V_Project_User.IsProjAdmin, 
                      dbo.Comparison.Created
FROM         dbo.V_Project_User INNER JOIN
                      dbo.ProjectVersion PV_Ref ON dbo.V_Project_User.Proj_OID = PV_Ref.Proj_OID INNER JOIN
                      dbo.Comparison ON PV_Ref.OID = dbo.Comparison.PV_OID_Ref INNER JOIN
                      dbo.ProjectVersion PV_Diff ON dbo.Comparison.PV_OID_Diff = PV_Diff.OID AND dbo.V_Project_User.Proj_OID = PV_Diff.Proj_OID
WHERE     (PV_Ref.User_OID = dbo.V_Project_User.User_OID_Filter) AND (PV_Diff.User_OID = dbo.V_Project_User.User_OID_Filter) OR
                      (PV_Ref.User_OID = dbo.V_Project_User.User_OID_Filter) AND (PV_Diff.PVT_OID IS NOT NULL) OR
                      (PV_Diff.User_OID = dbo.V_Project_User.User_OID_Filter) AND (PV_Ref.PVT_OID IS NOT NULL) OR
                      (PV_Diff.PVT_OID IS NOT NULL) AND (PV_Ref.PVT_OID IS NOT NULL)
GO
PRINT 'CREATE VIEW dbo.V_Comparison_User_Standard'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_Comparison_User_Standard
AS
SELECT     dbo.Comparison.OID, dbo.Comparison.ID, dbo.Comparison.PV_OID_Ref, dbo.Comparison.PV_OID_Diff, dbo.Comparison.OS_OID, 
                      dbo.Comparison.CalcDate, dbo.V_Project_User.Proj_OID, dbo.V_Project_User.User_OID_Filter, dbo.V_Project_User.IsProjAdmin, 
                      dbo.Comparison.Created
FROM         dbo.V_Project_User INNER JOIN
                      dbo.ProjectVersion PV_Ref ON dbo.V_Project_User.Proj_OID = PV_Ref.Proj_OID INNER JOIN
                      dbo.Comparison ON PV_Ref.OID = dbo.Comparison.PV_OID_Ref INNER JOIN
                      dbo.ProjectVersion PV_Diff ON dbo.Comparison.PV_OID_Diff = PV_Diff.OID AND dbo.V_Project_User.Proj_OID = PV_Diff.Proj_OID
WHERE     (PV_Ref.User_OID = dbo.V_Project_User.User_OID_Filter) AND (PV_Diff.User_OID = dbo.V_Project_User.User_OID_Filter) AND 
                      (dbo.Comparison.MComp_OID IS NULL) OR
                      (PV_Ref.User_OID = dbo.V_Project_User.User_OID_Filter) AND (dbo.Comparison.MComp_OID IS NULL) AND (PV_Diff.PVT_OID IS NOT NULL) OR
                      (PV_Diff.User_OID = dbo.V_Project_User.User_OID_Filter) AND (dbo.Comparison.MComp_OID IS NULL) AND (PV_Ref.PVT_OID IS NOT NULL) OR
                      (dbo.Comparison.MComp_OID IS NULL) AND (PV_Diff.PVT_OID IS NOT NULL) AND (PV_Ref.PVT_OID IS NOT NULL)
GO
PRINT 'CREATE VIEW dbo.V_ProjectVersion'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_ProjectVersion
AS
SELECT     dbo.ProjectVersion.OID, dbo.ProjectVersion.Proj_OID, dbo.ProjectVersion.ID + CASE WHEN databases.oid IS NULL 
                      THEN '' ELSE ' / ' + databases.id END + CASE WHEN v_databaseversion.oid IS NULL THEN '' ELSE ' (' + v_databaseversion.id + ')' END AS ID, 
                      dbo.ProjectVersion.DB_OID_Source, dbo.ProjectVersion.DBV_OID_Source, COALESCE (dbo.ProjectVersion.VersionDate, 
                      dbo.ProjectVersion.ScheduledDate, dbo.ProjectVersion.Created) AS SortDate, dbo.ProjectVersion.Br_OID, 
                      dbo.ProjectVersion.ID + CASE WHEN databases.oid IS NULL THEN '' ELSE ' / ' + databases.id END AS PV_ID, dbo.ProjectVersion.UpdateID
FROM         dbo.ProjectVersion LEFT OUTER JOIN
                      dbo.Databases ON dbo.ProjectVersion.DB_OID_Source = dbo.Databases.OID LEFT OUTER JOIN
                      dbo.V_DatabaseVersion ON dbo.ProjectVersion.DBV_OID_Source = dbo.V_DatabaseVersion.OID
GO
PRINT 'CREATE VIEW dbo.V_ProjectVersion_User'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_ProjectVersion_User
AS
SELECT     dbo.ProjectVersion.OID, dbo.V_Project_User.Proj_OID, dbo.V_Project_User.User_OID_Filter, dbo.ProjectVersion.ID, dbo.V_Project_User.IsProjAdmin, 
                      dbo.ProjectVersion.DB_OID_Source, dbo.ProjectVersion.DBV_OID_Source, dbo.ProjectVersion.SqlV_OID, dbo.ProjectVersion.PVT_OID, 
                      dbo.ProjectVersion.VersionDate, dbo.ProjectVersion.ScheduledDate, dbo.ProjectVersion.User_OID_Locked, dbo.ProjectVersion.LockedDate, 
                      dbo.ProjectVersion.TrackerIDs, dbo.ProjectVersion.User_OID, dbo.ProjectVersion.DataDiagramPng, dbo.ProjectVersion.Created, 
                      COALESCE (dbo.ProjectVersion.VersionDate, dbo.ProjectVersion.ScheduledDate, dbo.ProjectVersion.Created) AS SortDate, 
                      dbo.ProjectVersion.Br_OID
FROM         dbo.V_Project_User INNER JOIN
                      dbo.ProjectVersion ON dbo.V_Project_User.Proj_OID = dbo.ProjectVersion.Proj_OID
WHERE     (dbo.V_Project_User.User_OID_Filter = dbo.ProjectVersion.User_OID) OR
                      (dbo.ProjectVersion.PVT_OID IS NOT NULL)
GO
PRINT 'CREATE VIEW dbo.V_PV_OS_Obj'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_PV_OS_Obj
AS
SELECT     TOP 100 PERCENT dbo.ProjectVersion.Proj_OID, dbo.ProjectVersion.OID AS PV_OID, dbo.V_ObjectSelection.OS_OID, dbo.Object.OID AS Obj_OID, 
                      dbo.Object.ObjN_OID, dbo.Object.ObjT_OID, dbo.ProjectVersion.SqlV_OID
FROM         dbo.ProjectVersion INNER JOIN
                      dbo.V_ObjectSelection ON dbo.ProjectVersion.Proj_OID = dbo.V_ObjectSelection.Proj_OID INNER JOIN
                      dbo.Object ON dbo.ProjectVersion.OID = dbo.Object.PV_OID INNER JOIN
                      dbo.ObjectName ON dbo.Object.ObjN_OID = dbo.ObjectName.OID LEFT OUTER JOIN
                      dbo.ObjectSelection_ObjectType ON dbo.V_ObjectSelection.OS_OID = dbo.ObjectSelection_ObjectType.OS_OID AND 
                      dbo.ObjectSelection_ObjectType.ObjT_OID = dbo.Object.ObjT_OID LEFT OUTER JOIN
                      dbo.ObjectSelection_Object ON dbo.ObjectSelection_ObjectType.OID = dbo.ObjectSelection_Object.OSOT_OID AND 
                      (dbo.Object.OID = dbo.ObjectSelection_Object.Obj_OID OR
                      dbo.ObjectName.OID = dbo.ObjectSelection_Object.ObjN_OID)
WHERE     (dbo.V_ObjectSelection.OS_OID = 0) OR
                      (dbo.ObjectSelection_ObjectType.OID IS NOT NULL) AND (dbo.ObjectSelection_ObjectType.Include = 0) AND 
                      (dbo.ObjectSelection_Object.OID IS NULL) OR
                      (dbo.ObjectSelection_ObjectType.OID IS NOT NULL) AND (dbo.ObjectSelection_ObjectType.Include = 1) AND 
                      (dbo.ObjectSelection_Object.OID IS NOT NULL)
GO
PRINT 'CREATE VIEW dbo.V_DocGen_User'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE VIEW dbo.V_DocGen_User
AS
SELECT     dbo.DocGen.OID, dbo.DocGen.Proj_OID, dbo.DocGen.ID, dbo.DocGen.DGT_OID, dbo.DocGen.PV_OID, dbo.DocGen.ObjN_OID_View, 
                      dbo.DocGen.ParamValue1, dbo.DocGen.ParamValue2, dbo.DocGen.Username, dbo.DocGen.Password, dbo.DocGen.User_OID, dbo.DocGen.Created, 
                      dbo.V_ProjectVersion_User.User_OID_Filter
FROM         dbo.DocGen INNER JOIN
                      dbo.V_ProjectVersion_User ON dbo.DocGen.PV_OID = dbo.V_ProjectVersion_User.OID
GO
PRINT 'CREATE PROCEDURE dbo.Assign_CCol'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE   PROCEDURE dbo.Assign_CCol(
	@CCol_Ref	INT,
	@CCol_Diff	INT
) AS

	DECLARE @Col_OID INT, @Comp_OID INT

	SELECT	@Col_OID = Comparison_Column.Col_OID_Diff,
		@Comp_OID = Comparison_Object.Comp_OID
	FROM	Comparison_Column
	INNER JOIN Comparison_Object ON Comparison_Column.CObj_OID = Comparison_Object.OID
	WHERE	Comparison_Column.OID = @CCol_Diff

	/*UPDATE 	Comparison_Object
	SET	IsUserAssigned = 1,
		ColumnsChanged = 1,		// todo ??
		Obj_OID_Diff = @Obj_OID
	WHERE	OID = @CObj_Ref*/

	UPDATE	Comparison_Column
	SET	IsUserAssigned = 1,
		Col_OID_Diff = @Col_OID
	WHERE	OID = @CCol_Ref

	DELETE	Comparison_Column
	WHERE	OID = @CCol_Diff

	UPDATE	Comparison_Object
	SET	ColumnsChanged = 1
	FROM	Comparison_Object
	INNER JOIN Comparison_Column ON Comparison_Object.OID = Comparison_Column.CObj_OID
	WHERE	Comparison_Column.OID = @CCol_Ref

	EXEC Calc_Comparison_DiffText @Comp_OID
GO
PRINT 'CREATE PROCEDURE dbo.Assign_CObj'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE     PROCEDURE dbo.Assign_CObj(
	@CObj_Ref	INT,
	@CObj_Diff	INT
) AS

	DECLARE @Obj_OID INT, @Comp_OID INT

	SELECT	@Obj_OID = Obj_OID_Diff, @Comp_OID = Comp_OID
	FROM	Comparison_Object
	WHERE	OID = @CObj_Diff

	UPDATE 	Comparison_Object
	SET	IsUserAssigned = 1,
		ColumnsChanged = 1,
		Obj_OID_Diff = @Obj_OID
	WHERE	OID = @CObj_Ref

	UPDATE	Comparison_Column
	SET	IsUserAssigned = 1,
		Col_OID_Diff = ColDiff.OID
	FROM	Comparison_Column
	INNER JOIN Columns ON Comparison_Column.Col_OID_Ref = Columns.OID
	INNER JOIN ColumnName ON Columns.ColN_OID = ColumnName.OID
	CROSS JOIN Comparison_Column CColDiff
	INNER JOIN Columns ColDiff ON CColDiff.Col_OID_Diff = ColDiff.OID
	INNER JOIN ColumnName ColNDiff ON ColDiff.ColN_OID = ColNDiff.OID
	WHERE	Comparison_Column.CObj_OID = @CObj_Ref
	AND	CColDiff.CObj_OID = @CObj_Diff
	AND	ColumnName.ID = ColNDiff.ID

	DELETE 	CColDiff
	FROM	Comparison_Column
	INNER JOIN Columns ON Comparison_Column.Col_OID_Ref = Columns.OID
	INNER JOIN ColumnName ON Columns.ColN_OID = ColumnName.OID
	CROSS JOIN Comparison_Column CColDiff
	INNER JOIN Columns ColDiff ON CColDiff.Col_OID_Diff = ColDiff.OID
	INNER JOIN ColumnName ColNDiff ON ColDiff.ColN_OID = ColNDiff.OID
	WHERE	Comparison_Column.CObj_OID = @CObj_Ref
	AND	CColDiff.CObj_OID = @CObj_Diff
	AND	ColumnName.ID = ColNDiff.ID

	UPDATE	Comparison_Column
	SET	--IsUserAssigned = 1,
		CObj_OID = @CObj_Ref
	WHERE	CObj_OID = @CObj_Diff

	DELETE	Comparison_Object
	WHERE	OID = @CObj_Diff

	EXEC Calc_Comparison_DiffText @Comp_OID
GO
PRINT 'CREATE PROCEDURE dbo.Calc_Comparison'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE        PROCEDURE [dbo].[Calc_Comparison](
	@OID	INT
) AS
BEGIN
	SET NOCOUNT ON;

	DELETE	Comparison_Column
	FROM	Comparison_Object
	INNER JOIN Comparison_Column ON Comparison_Object.OID = Comparison_Column.CObj_OID
	WHERE	Comparison_Object.Comp_OID = @OID

	DELETE FROM Comparison_Object
	WHERE	Comp_OID = @OID

	INSERT INTO Comparison_Object (Comp_OID, Obj_OID_Ref, Obj_OID_Diff)
	SELECT	Comparison.OID, Object.OID, Object_Diff.OID
	FROM	Comparison 
	INNER JOIN ProjectVersion ON ProjectVersion.OID = Comparison.PV_OID_Ref 
	INNER JOIN ProjectVersion AS ProjectVersion_Diff ON Comparison.PV_OID_Diff = ProjectVersion_Diff.OID 
	INNER JOIN Object ON ProjectVersion.OID = Object.PV_OID 
	INNER JOIN Object AS Object_Diff 
		ON ProjectVersion_Diff.OID = Object_Diff.PV_OID 
		AND Object.ObjT_OID = Object_Diff.ObjT_OID 
		AND ISNULL(Object.OwnerName, '') = ISNULL(Object_Diff.OwnerName, '')
		AND Object.ID = Object_Diff.ID 
	WHERE	Comparison.OID = @OID

	INSERT INTO Comparison_Object (Comp_OID, Obj_OID_Ref)
	SELECT	Comparison.OID, Object.OID
	FROM	Comparison 
	INNER JOIN ProjectVersion ON ProjectVersion.OID = Comparison.PV_OID_Ref 
	INNER JOIN Object ON ProjectVersion.OID = Object.PV_OID 
	LEFT OUTER JOIN Comparison_Object Ex ON Ex.Comp_OID = @OID AND Ex.Obj_OID_Ref = Object.OID
	WHERE	Comparison.OID = @OID
	AND		Ex.OID IS NULL

	INSERT INTO Comparison_Object (Comp_OID, Obj_OID_Diff)
	SELECT	Comparison.OID, Object.OID
	FROM	Comparison 
	INNER JOIN ProjectVersion ON ProjectVersion.OID = Comparison.PV_OID_Diff
	INNER JOIN Object ON ProjectVersion.OID = Object.PV_OID 
	LEFT OUTER JOIN Comparison_Object Ex ON Ex.Comp_OID = @OID AND Ex.Obj_OID_Diff = Object.OID
	WHERE	Comparison.OID = @OID
	AND		Ex.OID IS NULL

	INSERT INTO Comparison_Column (CObj_OID, Col_OID_Ref, Col_OID_Diff)
	SELECT	Comparison_Object.OID, Columns.OID, Columns_Diff.OID
	FROM	Comparison_Object 
	INNER JOIN	Object ON Comparison_Object.Obj_OID_Ref = Object.OID 
	INNER JOIN	Object AS Object_Diff ON Comparison_Object.Obj_OID_Diff = Object_Diff.OID 
	INNER JOIN	Columns ON Object.OID = Columns.Obj_OID 
	INNER JOIN	Columns AS Columns_Diff 
		ON	Object_Diff.OID = Columns_Diff.Obj_OID 
		AND Columns.ID = Columns_Diff.ID
	WHERE	Comparison_Object.Comp_OID = @OID

	INSERT INTO Comparison_Column (CObj_OID, Col_OID_Ref)
	SELECT	Comparison_Object.OID, Columns.OID
	FROM	Comparison_Object 
	INNER JOIN	Object ON Comparison_Object.Obj_OID_Ref = Object.OID 
	INNER JOIN	Columns ON Object.OID = Columns.Obj_OID
	LEFT OUTER JOIN Comparison_Column Ex ON Ex.CObj_OID = Comparison_Object.OID 
			AND Ex.Col_OID_Ref = Columns.OID
	WHERE	Comparison_Object.Comp_OID = @OID
		AND	Ex.OID IS NULL

	INSERT INTO Comparison_Column (CObj_OID, Col_OID_Diff)
	SELECT	Comparison_Object.OID, Columns.OID
	FROM	Comparison_Object 
	INNER JOIN	Object ON Comparison_Object.Obj_OID_Diff = Object.OID 
	INNER JOIN	Columns ON Object.OID = Columns.Obj_OID 
	LEFT OUTER JOIN Comparison_Column Ex ON Ex.CObj_OID = Comparison_Object.OID AND Ex.Col_OID_Diff = Columns.OID
	WHERE	Comparison_Object.Comp_OID = @OID
		AND	Ex.OID IS NULL

	EXEC Calc_Comparison_DiffText @OID		-- 081010 moved here to calc V_CompCol views

	UPDATE	Comparison
	SET	CalcDate = GETDATE()	
	WHERE	OID = @OID

	DELETE	Comparison_Object			-- 091001 delete unchanged objects
	WHERE	Comp_OID = @OID
	AND	DiffMode IS NULL

	-- 091001 delete objects outside selected scope

	DECLARE @Create BIT, @Alter BIT, @Drop BIT
	SELECT	@Create = ComparisonScope.IncludeCreate,
		@Alter = ComparisonScope.IncludeAlter,
		@Drop = ComparisonScope.IncludeDrop
	FROM Comparison 
	INNER JOIN ComparisonScope ON Comparison.CS_OID = ComparisonScope.OID
	WHERE 	Comparison.OID = @OID

	IF @Alter = 0
		DELETE	Comparison_Object
		WHERE	Comp_OID = @OID
		AND	DiffMode = 0
	IF @Create = 0
		DELETE	Comparison_Object
		WHERE	Comp_OID = @OID
		AND	DiffMode = 1
	IF @Drop = 0
		DELETE	Comparison_Object
		WHERE	Comp_OID = @OID
		AND	DiffMode = 2
END
GO
PRINT 'CREATE PROCEDURE dbo.Calc_Comparison_DiffText'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE             PROCEDURE [dbo].[Calc_Comparison_DiffText](
	@OID INT
) AS
	-- 081008 

	UPDATE 	Comparison_Object
	SET	DiffMode = NULL, DiffText = NULL,
		ColumnsChanged = 0, ChildrenChanged = 0
	WHERE	Comp_OID = @OID

	UPDATE	Comparison_Column
	SET	DiffMode = NULL, DiffText = NULL
	FROM	Comparison_Column
	INNER JOIN Comparison_Object ON Comparison_Object.OID = Comparison_Column.CObj_OID
	WHERE	Comparison_Object.Comp_OID = @OID

	UPDATE	Comparison_Object
	SET	DiffText = ':' 
		+ CASE WHEN Object.ID <> Object_1.ID THEN 'Identifier:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.OwnerName, '') <> ISNULL(Object_1.OwnerName, '') THEN 'Schema:' ELSE '' END 
		+ CASE WHEN ISNULL(Object_P.ID, '') <> ISNULL(Object_1P.ID, '') THEN 'Parent:' ELSE '' END
		+ CASE WHEN ISNULL(Object.FileGroupName, '') <> ISNULL(Object_1.FileGroupName, '') THEN 'FileGroupName:' ELSE '' END 
		+ CASE WHEN dbo.NTexts_Equal(Object.SourceCode, Object_1.SourceCode) = 0 THEN 
			CASE Object.ObjT_OID 
				WHEN 31 THEN 'Constraint:'
				WHEN 51 THEN 'Authorization:'
				ELSE 'SourceCode:' 
			END ELSE '' END 
		+ CASE WHEN ISNULL(Object.IsAnsiOn, 1) <> ISNULL(Object_1.IsAnsiOn, 1) THEN 'AnsiOn:' ELSE '' END -- 100531 legacy for tables
		+ CASE WHEN ISNULL(Object.IsQuotedID, 0) <> ISNULL(Object_1.IsQuotedID, 0) THEN 
			CASE 	WHEN Object.ObjT_OID = 52 THEN '' -- xml schema
				ELSE 'QuotedIdentifier:' END
			ELSE '' END 
		+ CASE WHEN ISNULL(Object.IsClustered, 0) <> ISNULL(Object_1.IsClustered, 0) THEN 'Clustered:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.IsUnique, 0) <> ISNULL(Object_1.IsUnique, 0) THEN 'Unique:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.DeleteAction, 0) <> ISNULL(Object_1.DeleteAction, 0) THEN 'OnDelete:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.UpdateAction, 0) <> ISNULL(Object_1.UpdateAction, 0) THEN 'OnUpdate:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.ForInsert, 0) <> ISNULL(Object_1.ForInsert, 0) THEN 'ForInsert:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.ForUpdate, 0) <> ISNULL(Object_1.ForUpdate, 0) THEN 'ForUpdate:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.ForDelete, 0) <> ISNULL(Object_1.ForDelete, 0) THEN 'ForDelete:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.IsXml, 0) <> ISNULL(Object_1.IsXml, 0) THEN 'XmlIndex:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.IsPrimaryXml, 0) <> ISNULL(Object_1.IsPrimaryXml, 0) THEN 'PrimaryXmlIndex:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.Xml2ndType, '') <> ISNULL(Object_1.Xml2ndType, '') THEN 'XmlIndexType:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.XmlPrimaryID, '') <> ISNULL(Object_1.XmlPrimaryID, '') THEN 'PrimaryIndexName:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.NotForRepl, 0) <> ISNULL(Object_1.NotForRepl, 0) THEN 'NotForReplication:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.BaseDatatype, '') <> ISNULL(Object_1.BaseDatatype, '') THEN 'BaseType:' ELSE '' END
		+ CASE WHEN ISNULL(Object.Length, 0) <> ISNULL(Object_1.Length, 0) THEN 'Length:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.DecimalLength, 0) <> ISNULL(Object_1.DecimalLength, 0) THEN 'DecimalLength:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.Nullable, 0) <> ISNULL(Object_1.Nullable, 0) THEN 'Nullable:' ELSE '' END 
		+ CASE WHEN ISNULL(Object.CalcColumns, '') <> ISNULL(Object_1.CalcColumns, '') THEN 'Columns:' ELSE '' END 
	FROM	Comparison_Object 
	INNER JOIN Object Object_1 ON Comparison_Object.Obj_OID_Diff = Object_1.OID 
	INNER JOIN Object ON dbo.Comparison_Object.Obj_OID_Ref = dbo.Object.OID	
	LEFT OUTER JOIN Object Object_P ON Object.Obj_OID_Parent = Object_P.OID
	LEFT OUTER JOIN Object Object_1P ON Object_1.Obj_OID_Parent = Object_1P.OID
	WHERE	Comparison_Object.Comp_OID = @OID

	UPDATE	Comparison_Object
	SET	DiffMode = 0
	WHERE	Comparison_Object.Comp_OID = @OID
	AND	((DiffText <> ':') OR (ColumnsChanged = 1) OR (ChildrenChanged = 1))
	
	UPDATE	Comparison_Object
	SET	DiffMode = 1
	WHERE	Comparison_Object.Comp_OID = @OID
	AND	Comparison_Object.Obj_OID_Diff IS NULL

	UPDATE	Comparison_Object
	SET	DiffMode = 2
	WHERE	Comparison_Object.Comp_OID = @OID
	AND	Comparison_Object.Obj_OID_Ref IS NULL

	UPDATE	Comparison_Column
	SET	DiffText = ':' 
		+ CASE WHEN Columns.ID <> Columns_1.ID THEN 'Identifier:' ELSE '' END 
		--+ CASE WHEN Columns.ColOrder <> Columns_1.ColOrder THEN 'Order:' ELSE '' END
		+ CASE WHEN ISNULL(Columns.DataTypeSchema, '') <> ISNULL(Columns_1.DataTypeSchema, '') THEN 'DataTypeSchema:' ELSE '' END
		+ CASE WHEN Columns.DataType <> Columns_1.DataType THEN 'DataType:' ELSE '' END 
		+ CASE WHEN ISNULL(Columns.Length, 0) <> ISNULL(Columns_1.Length, 0) THEN 'Length:' ELSE '' END 
		+ CASE WHEN ISNULL(Columns.DecimalLength, 0) <> ISNULL(Columns_1.DecimalLength, 0) THEN 'Decimal:' ELSE '' END 
		+ CASE WHEN Columns.Nullable <> Columns_1.Nullable THEN 'Nullable:' ELSE '' END 
		+ CASE WHEN Columns.IsIdentity <> Columns_1.IsIdentity THEN 'IsIdentity:' ELSE '' END 
		+ CASE WHEN ISNULL(Columns.IdentityStart, 0) <> ISNULL(Columns_1.IdentityStart, 0) THEN 'IdentityStart:' ELSE '' END 
		+ CASE WHEN ISNULL(Columns.IdentityInc, 0) <> ISNULL(Columns_1.IdentityInc, 0) THEN 'IdentityInc:' ELSE '' END 
		+ CASE WHEN ISNULL(Columns.CollationName, '') <> ISNULL(Columns_1.CollationName, '') THEN 'ColationName:' ELSE '' END 
		+ CASE WHEN dbo.NTexts_Equal(Columns.Description, Columns_1.Description) = 0 THEN 'Description:' ELSE '' END 
		+ CASE WHEN Columns.IsRowGuidCol <> Columns_1.IsRowGuidCol THEN 'RowGuidCol:' ELSE '' END 
		+ CASE WHEN dbo.NTexts_Equal(Columns.Computed, Columns_1.Computed) = 0 THEN 'Computed:' ELSE '' END 
		+ CASE WHEN Columns.IsPersisted <> Columns_1.IsPersisted THEN 'Persisted:' ELSE '' END 
		+ CASE WHEN Columns.NotForRepl <> Columns_1.NotForRepl THEN 'NotForReplication:' ELSE '' END 
		+ CASE WHEN ISNULL(Columns.XmlSchema, '') <> ISNULL(Columns_1.XmlSchema, '') THEN 'XmlSchemaCollectionSchema:' ELSE '' END
		+ CASE WHEN ISNULL(Columns.XmlCollection, '') <> ISNULL(Columns_1.XmlCollection, '') THEN 'XmlSchemaCollection:' ELSE '' END
		+ CASE WHEN Columns.IsXmlDoc <> Columns_1.IsXmlDoc THEN 'XmlContent:' ELSE '' END
	FROM	Comparison_Column
	INNER JOIN Comparison_Object ON Comparison_Column.CObj_OID = dbo.Comparison_Object.OID 
	INNER JOIN Columns ON Comparison_Column.Col_OID_Ref = Columns.OID 
	INNER JOIN Object ON Columns.Obj_OID = Object.OID 
	INNER JOIN ObjectType ON Object.ObjT_OID = ObjectType.OID 
	INNER JOIN Columns Columns_1 ON Comparison_Column.Col_OID_Diff = Columns_1.OID 
	INNER JOIN .Object Object_1 ON Columns_1.Obj_OID = Object_1.OID
	WHERE	Comparison_Object.Comp_OID = @OID


	UPDATE	Comparison_Column
	SET	DiffMode = 0
	FROM	Comparison_Column
	INNER JOIN Comparison_Object ON Comparison_Object.OID = Comparison_Column.CObj_OID
	WHERE	Comparison_Object.Comp_OID = @OID
	AND	Comparison_Column.DiffText <> ':'

	UPDATE	Comparison_Column
	SET	DiffMode = 1
	FROM	Comparison_Column
	INNER JOIN Comparison_Object ON Comparison_Object.OID = Comparison_Column.CObj_OID
	WHERE	Comparison_Object.Comp_OID = @OID
	AND	Comparison_Column.Col_OID_Diff IS NULL

	UPDATE	Comparison_Column
	SET	DiffMode = 2
	FROM	Comparison_Column
	INNER JOIN Comparison_Object ON Comparison_Object.OID = Comparison_Column.CObj_OID
	WHERE	Comparison_Object.Comp_OID = @OID
	AND	Comparison_Column.Col_OID_Ref IS NULL

	UPDATE	Comparison_Object
	SET	ColumnsChanged = 1, DiffMode = ISNULL(Comparison_Object.DiffMode, 0)
	FROM	Comparison_Object
	INNER JOIN V_CompCol_Result ON Comparison_Object.OID = V_CompCol_Result.CObj_OID
	WHERE	Comparison_Object.Comp_OID = @OID
	AND 	(ISNULL(V_CompCol_Result.DiffText, '') <> ':')

	UPDATE	Comparison_Object
	SET	ChildrenChanged = 1, DiffMode = ISNULL(Comparison_Object.DiffMode, 0)
	FROM	V_Compare_Result 
	INNER JOIN Object ON V_Compare_Result.Comp_OID = @OID AND V_Compare_Result.Obj_OID = Object.OID
	INNER JOIN Object Object_Parent ON Object.Obj_OID_Parent = Object_Parent.OID
	INNER JOIN Comparison_Object ON Comparison_Object.Comp_OID = @OID 
		AND Object_Parent.OID = Comparison_Object.Obj_OID_Ref
	WHERE	ISNULL(dbo.V_Compare_Result.DiffText, '') <> ':'
GO
PRINT 'CREATE PROCEDURE dbo.Calc_Dependencies'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE  PROCEDURE dbo.Calc_Dependencies(
	@PV_OID	INT
) AS

	INSERT INTO Dependency(DepT_OID, Obj_OID, Obj_OID_DependsOn)
	SELECT     9, Object_1.OID, dbo.Object.OID	-- Schema
	FROM	Object 
	INNER JOIN Object Object_1 ON Object.PV_OID = Object_1.PV_OID AND Object.ID = Object_1.OwnerName 
	INNER JOIN ObjectType ON Object_1.ObjT_OID = ObjectType.OID 
	INNER JOIN ObjectTypeType ON ObjectType.OTT_OID = ObjectTypeType.OID
	WHERE	Object.PV_OID = @PV_OID
	AND	Object.ObjT_OID = 51
	AND 	ObjectTypeType.IsBaseType = 1
GO
PRINT 'CREATE PROCEDURE dbo.Calc_MultiComparison'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE   PROCEDURE dbo.Calc_MultiComparison(
	@OID	INT,
	@User_OID INT
) AS
	SET NOCOUNT ON

	DELETE FROM Comparison WHERE MComp_OID = @OID

	DECLARE @PV_OID_Ref INT, @PV_OID_Diff INT, @Comp_OID INT
	DECLARE @PV_ID_Ref NVARCHAR(50), @PV_ID_Diff NVARCHAR(50)

	DECLARE c CURSOR FOR
	SELECT R.PV_OID, D.PV_OID, RPV.PV_ID, DPV.PV_ID
	FROM	MultiComparison_ProjectVersion R
		INNER JOIN V_ProjectVersion RPV ON R.PV_OID = RPV.OID
	CROSS JOIN MultiComparison_ProjectVersion D --ON R.
		INNER JOIN V_ProjectVersion DPV ON D.PV_OID = DPV.OID
	WHERE	R.MComp_OID = @OID
	AND	D.MComp_OID = @OID
	AND	R.PV_OID <> D.PV_OID
	ORDER BY RPV.SortDate DESC, DPV.SortDate DESC

	OPEN c
	FETCH c INTO @PV_OID_Ref, @PV_OID_Diff, @PV_ID_Ref, @PV_ID_Diff

	WHILE @@FETCH_STATUS = 0 BEGIN
		INSERT INTO Comparison (MComp_OID, ID, PV_OID_Ref, PV_OID_Diff, User_OID)
		VALUES (@OID, RTRIM(SUBSTRING(@PV_ID_Ref, 1, 22)) + ' from ' +
				RTRIM(SUBSTRING(@PV_ID_Diff, 1, 22)),
			@PV_OID_Ref, @PV_OID_Diff, @User_OID)

		SELECT @Comp_OID = SCOPE_IDENTITY()

		EXEC Calc_Comparison @Comp_OID

		FETCH c INTO @PV_OID_Ref, @PV_OID_Diff, @PV_ID_Ref, @PV_ID_Diff
	END

	CLOSE c
	DEALLOCATE c

	UPDATE 	MultiComparison
	SET	CalcDate = GETDATE()
	WHERE	OID = @OID
GO
PRINT 'CREATE PROCEDURE dbo.Calc_Object_Columns'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE PROCEDURE dbo.Calc_Object_Columns(
	@PV_OID	INT
) AS

	UPDATE 	Object
	SET 	CalcColumns = NULL
	WHERE	PV_OID = @PV_OID

	DECLARE @Obj_OID INT, @CalcColumns NVARCHAR(1024)
	DECLARE @Obj_ID_Owner NVARCHAR(128), @Obj_ID_Ref NVARCHAR(128), @Col_ID_Ref NVARCHAR(128), @Col_ID NVARCHAR(128)

	DECLARE c CURSOR FOR
	SELECT	OID
	FROM	Object
	WHERE	PV_OID = @PV_OID
	AND	ObjT_OID = 10		-- fk
	FOR UPDATE OF CalcColumns

	OPEN c
	FETCH c INTO @Obj_OID

	WHILE @@FETCH_STATUS = 0 BEGIN

		SET @CalcColumns = NULL

		DECLARE cFK CURSOR FOR
		SELECT	Object_1.OwnerName, Object_1.ID, Columns_1.ID, Columns.ID
		FROM	Object_Column 
		INNER JOIN Columns ON Object_Column.Col_OID = Columns.OID 
		INNER JOIN Columns Columns_1 ON Object_Column.Col_OID_Ref = Columns_1.OID 
		INNER JOIN Object Object_1 ON Object_Column.Obj_OID_Ref = Object_1.OID
		WHERE	Object_Column.Obj_OID_Rel = @Obj_OID
		ORDER BY Object_Column.Seq

		OPEN cFK
		FETCH cFK INTO @Obj_ID_Owner, @Obj_ID_Ref, @Col_ID_Ref, @Col_ID

		WHILE @@FETCH_STATUS = 0 BEGIN
			IF @CalcColumns IS NULL
				SET @CalcColumns = ISNULL(@Obj_ID_Owner, '') + '.' + @Obj_ID_Ref

			SET @CalcColumns = @CalcColumns + ' ' +	@Col_ID + ':' + @Col_ID_Ref

			FETCH cFK INTO @Obj_ID_Owner, @Obj_ID_Ref, @Col_ID_Ref, @Col_ID
		END

		CLOSE cFK
		DEALLOCATE cFK

		UPDATE 	Object
		SET	CalcColumns = @CalcColumns
		WHERE	OID = @Obj_OID

		FETCH c INTO @Obj_OID
	END

	CLOSE c
	DEALLOCATE c	

	DECLARE @IsDesc BIT, @IsIncluded BIT

	DECLARE c CURSOR FOR
	SELECT	OID
	FROM	Object
	WHERE	PV_OID = @PV_OID
	AND	ObjT_OID IN (13, 14, 19, 30)	-- index, pk, uk, default
	FOR UPDATE OF CalcColumns

	OPEN c
	FETCH c INTO @Obj_OID

	WHILE @@FETCH_STATUS = 0 BEGIN

		SET @CalcColumns = NULL

		DECLARE cCol CURSOR FOR
		SELECT	Columns.ID, Object_Column.IsDesc, Object_Column.IsIncluded
		FROM	Object_Column 
		INNER JOIN Columns ON Object_Column.Col_OID = Columns.OID
		WHERE	Object_Column.Obj_OID = @Obj_OID
		ORDER BY Object_Column.Seq

		OPEN cCol
		FETCH cCol INTO @Col_ID, @IsDesc, @IsIncluded

		WHILE @@FETCH_STATUS = 0 BEGIN

			SET @CalcColumns = ISNULL(@CalcColumns, '') + ', ' +
				@Col_ID + 
				CASE WHEN @IsDesc = 1 THEN ' DESC' ELSE '' END +
				CASE WHEN @IsIncluded = 1 THEN ' INCLUDE' ELSE '' END

			FETCH cCol INTO @Col_ID, @IsDesc, @IsIncluded
		END

		CLOSE cCol
		DEALLOCATE cCol

		IF @CalcColumns IS NOT NULL
			UPDATE 	Object
			SET	CalcColumns = SUBSTRING(@CalcColumns, 3, LEN(@CalcColumns)-2)
			WHERE	OID = @Obj_OID

		FETCH c INTO @Obj_OID
	END

	CLOSE c
	DEALLOCATE c
GO
PRINT 'CREATE PROCEDURE dbo.Create_DocGen'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE PROCEDURE dbo.Create_DocGen(
	@ID	NVARCHAR(50),
	@Proj_OID	INT,
	@User_OID	INT,
	@DGT_OID	INT,
	@PV_OID	INT,
	@OID	INT OUTPUT
) AS

	INSERT INTO DocGen (ID, Proj_OID, User_OID, DGT_OID, PV_OID) 
	VALUES (@ID, @Proj_OID, @User_OID, @DGT_OID, @PV_OID)

	SELECT @OID = OID FROM DocGen WHERE OID = SCOPE_IDENTITY()

	INSERT INTO DocGenPart (DG_OID, XSL_OID, Seq)
	SELECT 	@OID, XSL.OID,
		CASE dbo.XSL.XslT_OID WHEN 1 THEN 200 WHEN 2 THEN 100 END
	FROM	Project 
	INNER JOIN XSL ON Project.DBE_OID = XSL.DBE_OID
	WHERE	Project.OID = @Proj_OID
	AND	XSL.DGT_OID = @DGT_OID
	AND	XSL.IsDGPDefault = 1
GO
PRINT 'CREATE PROCEDURE dbo.Delete_Comparison'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE PROCEDURE [dbo].[Delete_Comparison](
	@OID	INT
) AS
BEGIN

	DELETE	Comparison_Column
	FROM	Comparison_Column
	INNER JOIN Comparison_Object ON Comparison_Column.CObj_OID = Comparison_Object.OID
	WHERE	Comparison_Object.Comp_OID = @OID

	DELETE	Comparison_Object 
	WHERE	Comparison_Object.Comp_OID = @OID

	DELETE	Comparison
	WHERE	OID = @OID

END
GO
PRINT 'CREATE PROCEDURE dbo.Delete_Project'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE  PROCEDURE dbo.Delete_Project(
	@Proj_OID	INT
) AS

	DELETE	ScriptText
	WHERE	Proj_OID = @Proj_OID

	DELETE	DocGen
	WHERE	Proj_OID = @Proj_OID

	DELETE	Contact
	FROM	Customer
	INNER JOIN Contact ON Contact.Cust_OID = Customer.OID
	WHERE	Customer.Proj_OID = @Proj_OID

	DELETE	Installation
	FROM	Customer
	INNER JOIN Installation ON Installation.Cust_OID = Customer.OID
	WHERE	Customer.Proj_OID = @Proj_OID

	DELETE	Customer
	WHERE	Customer.Proj_OID = @Proj_OID

	DECLARE @OID INT

	DECLARE cur CURSOR FOR
	SELECT	Comparison.OID
	FROM	Comparison
	INNER JOIN ProjectVersion 
		ON ProjectVersion.OID IN (Comparison.PV_OID_Ref, Comparison.PV_OID_Diff)
	WHERE	ProjectVersion.Proj_OID = @Proj_OID

	OPEN cur
	FETCH cur INTO @OID

	WHILE @@FETCH_STATUS = 0 BEGIN
		EXEC Delete_Comparison @OID
		FETCH cur INTO @OID
	END

	CLOSE cur
	DEALLOCATE cur

	DECLARE cur CURSOR FOR
	SELECT	Comparison.OID
	FROM	Comparison
	INNER JOIN MultiComparison ON MultiComparison.OID = Comparison.MComp_OID
	WHERE	MultiComparison.Proj_OID = @Proj_OID

	OPEN cur
	FETCH cur INTO @OID

	WHILE @@FETCH_STATUS = 0 BEGIN
		EXEC Delete_Comparison @OID
		FETCH cur INTO @OID
	END

	CLOSE cur
	DEALLOCATE cur

	DELETE	MultiComparison_ProjectVersion
	FROM	MultiComparison
	INNER JOIN MultiComparison_ProjectVersion ON MultiComparison_ProjectVersion.MComp_OID = MultiComparison.OID
	WHERE	MultiComparison.Proj_OID = @Proj_OID

	DELETE	MultiComparison
	WHERE	MultiComparison.Proj_OID = @Proj_OID

	DELETE	ObjectSelection
	WHERE	ObjectSelection.Proj_OID = @Proj_OID

	DELETE	Script
	WHERE	Script.Proj_OID = @Proj_OID

	DECLARE cur CURSOR FOR
	SELECT	ProjectVersion.OID
	FROM	ProjectVersion
	WHERE	ProjectVersion.Proj_OID = @Proj_OID

	OPEN cur
	FETCH cur INTO @OID

	WHILE @@FETCH_STATUS = 0 BEGIN
		EXEC Delete_ProjectVersion @OID
		FETCH cur INTO @OID
	END

	CLOSE cur
	DEALLOCATE cur

	DELETE	Databases
	WHERE	Databases.Proj_OID = @Proj_OID

	UPDATE	Branch
	SET	Br_OID_Parent = NULL, Br_OID_Merge = NULL
	WHERE	Proj_OID = @Proj_OID

	DELETE	Branch
	WHERE	Branch.Proj_OID = @Proj_OID

	DELETE	Project
	WHERE	OID = @Proj_OID
GO
PRINT 'CREATE PROCEDURE dbo.Delete_ProjectVersion'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE   PROCEDURE [dbo].[Delete_ProjectVersion](
	@OID	INT
) AS

	DECLARE @Comp_OID INT

	DECLARE c CURSOR FOR
	SELECT	OID
	FROM	Comparison
	WHERE	PV_OID_Ref = @OID

	OPEN c
	FETCH c INTO @Comp_OID

	WHILE @@FETCH_STATUS = 0 BEGIN

		EXEC Delete_Comparison @Comp_OID

		FETCH c INTO @Comp_OID
	END

	CLOSE c
	DEALLOCATE c

	DECLARE c CURSOR FOR
	SELECT	OID
	FROM	Comparison
	WHERE	PV_OID_Diff = @OID

	OPEN c
	FETCH c INTO @Comp_OID

	WHILE @@FETCH_STATUS = 0 BEGIN

		EXEC Delete_Comparison @Comp_OID

		FETCH c INTO @Comp_OID
	END

	CLOSE c
	DEALLOCATE c

	DELETE	Dependency
	FROM	Dependency
	INNER JOIN Object ON Object.OID = Dependency.Obj_OID
	WHERE	Object.PV_OID = @OID

	DELETE	Object_Column
	FROM	Object_Column
	INNER JOIN Object 
		ON	Object.OID = Object_Column.Obj_OID
		OR	Object.OID = Object_Column.Obj_OID_Rel
		OR	Object.OID = Object_Column.Obj_OID_Ref
	WHERE	Object.PV_OID = @OID

	DELETE	Property
	FROM	Property
	INNER JOIN Columns ON Columns.OID = Property.Col_OID
	INNER JOIN Object ON Object.OID = Columns.Obj_OID
	WHERE	Object.PV_OID = @OID

	DELETE	Property
	FROM	Property
	INNER JOIN Object ON Object.OID = Property.Obj_OID
	WHERE	Object.PV_OID = @OID

	DELETE	Columns
	FROM	Columns
	INNER JOIN Object ON Object.OID = Columns.Obj_OID
	WHERE	Object.PV_OID = @OID

	DELETE	Object 
	WHERE	Object.PV_OID = @OID

	DELETE	ProjectVersion
	WHERE	OID = @OID
GO
PRINT 'CREATE PROCEDURE dbo.dev_CalcAllComparisons'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE PROCEDURE dbo.dev_CalcAllComparisons AS

declare @oid int
declare c cursor for select oid from comparison 
open c fetch c into @oid
while @@fetch_status=0 begin exec calc_comparison_difftext @oid fetch c into @oid end
close c deallocate c
GO
PRINT 'CREATE PROCEDURE dbo.dev_Generate_Consts'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE PROCEDURE [dbo].[dev_Generate_Consts] AS

	PRINT '//'
	PRINT '// dbscript2dev Value Script'
	PRINT '// automatically generated by dev_Generate_Consts'
	PRINT '// ' + CONVERT(VARCHAR, GETDATE(), 120)
	PRINT '// script generator by dbscript 1.02 18.03.2010 11:54:44'
	PRINT '//'

	PRINT ''
	PRINT 'public static partial class DBEngine'
	PRINT '{'
	DECLARE @DBEngine__ProgID	VARCHAR(50)
	DECLARE @DBEngine__OID	INT
	DECLARE @DBEngine__ID	NVARCHAR(50)

	DECLARE c CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR
	SELECT	ProgID, OID, ID
	FROM	dbo.DBEngine
	ORDER BY OID

	OPEN c
	FETCH c INTO @DBEngine__ProgID, @DBEngine__OID, @DBEngine__ID

	WHILE @@FETCH_STATUS = 0 BEGIN
		IF @DBEngine__ID IS NOT NULL BEGIN
			PRINT '	/// <summary>'
			PRINT '	/// ' + CONVERT(NVARCHAR(4000), @DBEngine__ID)
			PRINT '	/// </summary>'
		END
		PRINT '	public const int ' + REPLACE(REPLACE(@DBEngine__ProgID, ' ', '_'), '-', '_') + ' = ' + CONVERT(VARCHAR(4000), @DBEngine__OID) + ';'
		FETCH c INTO @DBEngine__ProgID, @DBEngine__OID, @DBEngine__ID
	END

	CLOSE c
	DEALLOCATE c

	PRINT '}'

	PRINT ''
	PRINT 'public static partial class DependencyType'
	PRINT '{'
	DECLARE @DependencyType__ProgID	VARCHAR(50)
	DECLARE @DependencyType__OID	INT
	DECLARE @DependencyType__ID	NVARCHAR(50)

	DECLARE c CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR
	SELECT	ProgID, OID, ID
	FROM	dbo.DependencyType
	ORDER BY OID

	OPEN c
	FETCH c INTO @DependencyType__ProgID, @DependencyType__OID, @DependencyType__ID

	WHILE @@FETCH_STATUS = 0 BEGIN
		IF @DependencyType__ID IS NOT NULL BEGIN
			PRINT '	/// <summary>'
			PRINT '	/// ' + CONVERT(NVARCHAR(4000), @DependencyType__ID)
			PRINT '	/// </summary>'
		END
		PRINT '	public const int ' + REPLACE(REPLACE(@DependencyType__ProgID, ' ', '_'), '-', '_') + ' = ' + CONVERT(VARCHAR(4000), @DependencyType__OID) + ';'
		FETCH c INTO @DependencyType__ProgID, @DependencyType__OID, @DependencyType__ID
	END

	CLOSE c
	DEALLOCATE c

	PRINT '}'

	PRINT ''
	PRINT 'public static partial class DiagramType'
	PRINT '{'
	DECLARE @DiagramType__ProgID	VARCHAR(50)
	DECLARE @DiagramType__OID	INT
	DECLARE @DiagramType__ID	NVARCHAR(50)

	DECLARE c CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR
	SELECT	ProgID, OID, ID
	FROM	dbo.DiagramType
	ORDER BY OID

	OPEN c
	FETCH c INTO @DiagramType__ProgID, @DiagramType__OID, @DiagramType__ID

	WHILE @@FETCH_STATUS = 0 BEGIN
		IF @DiagramType__ID IS NOT NULL BEGIN
			PRINT '	/// <summary>'
			PRINT '	/// ' + CONVERT(NVARCHAR(4000), @DiagramType__ID)
			PRINT '	/// </summary>'
		END
		PRINT '	public const int ' + REPLACE(REPLACE(@DiagramType__ProgID, ' ', '_'), '-', '_') + ' = ' + CONVERT(VARCHAR(4000), @DiagramType__OID) + ';'
		FETCH c INTO @DiagramType__ProgID, @DiagramType__OID, @DiagramType__ID
	END

	CLOSE c
	DEALLOCATE c

	PRINT '}'

	PRINT ''
	PRINT 'public static partial class DocGenType'
	PRINT '{'
	DECLARE @DocGenType__ProgID	VARCHAR(50)
	DECLARE @DocGenType__OID	INT
	DECLARE @DocGenType__ID	NVARCHAR(50)

	DECLARE c CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR
	SELECT	ProgID, OID, ID
	FROM	dbo.DocGenType
	ORDER BY OID

	OPEN c
	FETCH c INTO @DocGenType__ProgID, @DocGenType__OID, @DocGenType__ID

	WHILE @@FETCH_STATUS = 0 BEGIN
		IF @DocGenType__ID IS NOT NULL BEGIN
			PRINT '	/// <summary>'
			PRINT '	/// ' + CONVERT(NVARCHAR(4000), @DocGenType__ID)
			PRINT '	/// </summary>'
		END
		PRINT '	public const int ' + REPLACE(REPLACE(@DocGenType__ProgID, ' ', '_'), '-', '_') + ' = ' + CONVERT(VARCHAR(4000), @DocGenType__OID) + ';'
		FETCH c INTO @DocGenType__ProgID, @DocGenType__OID, @DocGenType__ID
	END

	CLOSE c
	DEALLOCATE c

	PRINT '}'

	PRINT ''
	PRINT 'public static partial class ObjectType'
	PRINT '{'
	DECLARE @ObjectType__ProgID	VARCHAR(50)
	DECLARE @ObjectType__OID	INT
	DECLARE @ObjectType__ID	NVARCHAR(50)

	DECLARE c CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR
	SELECT	ProgID, OID, ID
	FROM	dbo.ObjectType
	ORDER BY OID

	OPEN c
	FETCH c INTO @ObjectType__ProgID, @ObjectType__OID, @ObjectType__ID

	WHILE @@FETCH_STATUS = 0 BEGIN
		IF @ObjectType__ID IS NOT NULL BEGIN
			PRINT '	/// <summary>'
			PRINT '	/// ' + CONVERT(NVARCHAR(4000), @ObjectType__ID)
			PRINT '	/// </summary>'
		END
		PRINT '	public const int ' + REPLACE(REPLACE(@ObjectType__ProgID, ' ', '_'), '-', '_') + ' = ' + CONVERT(VARCHAR(4000), @ObjectType__OID) + ';'
		FETCH c INTO @ObjectType__ProgID, @ObjectType__OID, @ObjectType__ID
	END

	CLOSE c
	DEALLOCATE c

	PRINT '}'

	PRINT ''
	PRINT 'public static partial class ObjectTypeType'
	PRINT '{'
	DECLARE @ObjectTypeType__ProgID	VARCHAR(50)
	DECLARE @ObjectTypeType__OID	INT
	DECLARE @ObjectTypeType__ID	NVARCHAR(50)

	DECLARE c CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR
	SELECT	ProgID, OID, ID
	FROM	dbo.ObjectTypeType
	ORDER BY OID

	OPEN c
	FETCH c INTO @ObjectTypeType__ProgID, @ObjectTypeType__OID, @ObjectTypeType__ID

	WHILE @@FETCH_STATUS = 0 BEGIN
		IF @ObjectTypeType__ID IS NOT NULL BEGIN
			PRINT '	/// <summary>'
			PRINT '	/// ' + CONVERT(NVARCHAR(4000), @ObjectTypeType__ID)
			PRINT '	/// </summary>'
		END
		PRINT '	public const int ' + REPLACE(REPLACE(@ObjectTypeType__ProgID, ' ', '_'), '-', '_') + ' = ' + CONVERT(VARCHAR(4000), @ObjectTypeType__OID) + ';'
		FETCH c INTO @ObjectTypeType__ProgID, @ObjectTypeType__OID, @ObjectTypeType__ID
	END

	CLOSE c
	DEALLOCATE c

	PRINT '}'

	PRINT ''
	PRINT 'public static partial class PropertyType'
	PRINT '{'
	DECLARE @PropertyType__ProgID	VARCHAR(50)
	DECLARE @PropertyType__OID	INT
	DECLARE @PropertyType__ID	NVARCHAR(50)

	DECLARE c CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR
	SELECT	ProgID, OID, ID
	FROM	dbo.PropertyType
	ORDER BY OID

	OPEN c
	FETCH c INTO @PropertyType__ProgID, @PropertyType__OID, @PropertyType__ID

	WHILE @@FETCH_STATUS = 0 BEGIN
		IF @PropertyType__ID IS NOT NULL BEGIN
			PRINT '	/// <summary>'
			PRINT '	/// ' + CONVERT(NVARCHAR(4000), @PropertyType__ID)
			PRINT '	/// </summary>'
		END
		PRINT '	public const int ' + REPLACE(REPLACE(@PropertyType__ProgID, ' ', '_'), '-', '_') + ' = ' + CONVERT(VARCHAR(4000), @PropertyType__OID) + ';'
		FETCH c INTO @PropertyType__ProgID, @PropertyType__OID, @PropertyType__ID
	END

	CLOSE c
	DEALLOCATE c

	PRINT '}'

	PRINT ''
	PRINT 'public static partial class ScriptTableMode'
	PRINT '{'
	DECLARE @ScriptTableMode__ProgID	VARCHAR(50)
	DECLARE @ScriptTableMode__OID	INT
	DECLARE @ScriptTableMode__ID	NVARCHAR(50)

	DECLARE c CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR
	SELECT	ProgID, OID, ID
	FROM	dbo.ScriptTableMode
	ORDER BY OID

	OPEN c
	FETCH c INTO @ScriptTableMode__ProgID, @ScriptTableMode__OID, @ScriptTableMode__ID

	WHILE @@FETCH_STATUS = 0 BEGIN
		IF @ScriptTableMode__ID IS NOT NULL BEGIN
			PRINT '	/// <summary>'
			PRINT '	/// ' + CONVERT(NVARCHAR(4000), @ScriptTableMode__ID)
			PRINT '	/// </summary>'
		END
		PRINT '	public const int ' + REPLACE(REPLACE(@ScriptTableMode__ProgID, ' ', '_'), '-', '_') + ' = ' + CONVERT(VARCHAR(4000), @ScriptTableMode__OID) + ';'
		FETCH c INTO @ScriptTableMode__ProgID, @ScriptTableMode__OID, @ScriptTableMode__ID
	END

	CLOSE c
	DEALLOCATE c

	PRINT '}'

	PRINT ''
	PRINT 'public static partial class ScriptTextType'
	PRINT '{'
	DECLARE @ScriptTextType__ProgID	VARCHAR(50)
	DECLARE @ScriptTextType__OID	INT
	DECLARE @ScriptTextType__ID	NVARCHAR(50)

	DECLARE c CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR
	SELECT	ProgID, OID, ID
	FROM	dbo.ScriptTextType
	ORDER BY OID

	OPEN c
	FETCH c INTO @ScriptTextType__ProgID, @ScriptTextType__OID, @ScriptTextType__ID

	WHILE @@FETCH_STATUS = 0 BEGIN
		IF @ScriptTextType__ID IS NOT NULL BEGIN
			PRINT '	/// <summary>'
			PRINT '	/// ' + CONVERT(NVARCHAR(4000), @ScriptTextType__ID)
			PRINT '	/// </summary>'
		END
		PRINT '	public const int ' + REPLACE(REPLACE(@ScriptTextType__ProgID, ' ', '_'), '-', '_') + ' = ' + CONVERT(VARCHAR(4000), @ScriptTextType__OID) + ';'
		FETCH c INTO @ScriptTextType__ProgID, @ScriptTextType__OID, @ScriptTextType__ID
	END

	CLOSE c
	DEALLOCATE c

	PRINT '}'

	PRINT ''
	PRINT 'public static partial class ScriptType'
	PRINT '{'
	DECLARE @ScriptType__ProgID	VARCHAR(50)
	DECLARE @ScriptType__OID	INT
	DECLARE @ScriptType__ID	NVARCHAR(50)

	DECLARE c CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR
	SELECT	ProgID, OID, ID
	FROM	dbo.ScriptType
	ORDER BY OID

	OPEN c
	FETCH c INTO @ScriptType__ProgID, @ScriptType__OID, @ScriptType__ID

	WHILE @@FETCH_STATUS = 0 BEGIN
		IF @ScriptType__ID IS NOT NULL BEGIN
			PRINT '	/// <summary>'
			PRINT '	/// ' + CONVERT(NVARCHAR(4000), @ScriptType__ID)
			PRINT '	/// </summary>'
		END
		PRINT '	public const int ' + REPLACE(REPLACE(@ScriptType__ProgID, ' ', '_'), '-', '_') + ' = ' + CONVERT(VARCHAR(4000), @ScriptType__OID) + ';'
		FETCH c INTO @ScriptType__ProgID, @ScriptType__OID, @ScriptType__ID
	END

	CLOSE c
	DEALLOCATE c

	PRINT '}'

	PRINT ''
	PRINT 'public static partial class SqlVersion'
	PRINT '{'
	DECLARE @SqlVersion__ProgID	VARCHAR(50)
	DECLARE @SqlVersion__OID	INT
	DECLARE @SqlVersion__ID	NVARCHAR(50)

	DECLARE c CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR
	SELECT	ProgID, OID, ID
	FROM	dbo.SqlVersion
	ORDER BY OID

	OPEN c
	FETCH c INTO @SqlVersion__ProgID, @SqlVersion__OID, @SqlVersion__ID

	WHILE @@FETCH_STATUS = 0 BEGIN
		IF @SqlVersion__ID IS NOT NULL BEGIN
			PRINT '	/// <summary>'
			PRINT '	/// ' + CONVERT(NVARCHAR(4000), @SqlVersion__ID)
			PRINT '	/// </summary>'
		END
		PRINT '	public const int ' + REPLACE(REPLACE(@SqlVersion__ProgID, ' ', '_'), '-', '_') + ' = ' + CONVERT(VARCHAR(4000), @SqlVersion__OID) + ';'
		FETCH c INTO @SqlVersion__ProgID, @SqlVersion__OID, @SqlVersion__ID
	END

	CLOSE c
	DEALLOCATE c

	PRINT '}'

	PRINT ''
	PRINT 'public static partial class XslType'
	PRINT '{'
	DECLARE @XslType__ProgID	VARCHAR(50)
	DECLARE @XslType__OID	INT
	DECLARE @XslType__ID	NVARCHAR(50)

	DECLARE c CURSOR LOCAL FORWARD_ONLY READ_ONLY FOR
	SELECT	ProgID, OID, ID
	FROM	dbo.XslType
	ORDER BY OID

	OPEN c
	FETCH c INTO @XslType__ProgID, @XslType__OID, @XslType__ID

	WHILE @@FETCH_STATUS = 0 BEGIN
		IF @XslType__ID IS NOT NULL BEGIN
			PRINT '	/// <summary>'
			PRINT '	/// ' + CONVERT(NVARCHAR(4000), @XslType__ID)
			PRINT '	/// </summary>'
		END
		PRINT '	public const int ' + REPLACE(REPLACE(@XslType__ProgID, ' ', '_'), '-', '_') + ' = ' + CONVERT(VARCHAR(4000), @XslType__OID) + ';'
		FETCH c INTO @XslType__ProgID, @XslType__OID, @XslType__ID
	END

	CLOSE c
	DEALLOCATE c

	PRINT '}'
GO
PRINT 'CREATE PROCEDURE dbo.dev_Generate_DAL'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE     PROCEDURE dbo.dev_Generate_DAL
AS

	PRINT	
'using System;
using System.Data;
using System.Data.SqlClient;
using System.Collections.Generic;

/*
	Klassendefinition fr Data Access Layer 
	automatisch erzeugt durch dev_Generate_DAL
	' + CONVERT(VARCHAR, GETDATE(), 120) + '
*/

namespace dbscriptlib.DAL
{'

	DECLARE @OID INT, @ID VARCHAR(50)

	DECLARE cTable CURSOR LOCAL READ_ONLY FORWARD_ONLY FOR
	SELECT sysobjects.id, sysobjects.name
	FROM sysobjects 
	WHERE	xtype='U' AND name<>'dtproperties'
	AND	name in ('Object', 'Columns', 'Object_Column')
	--, 'ObjectName', 'ColumnName')
	ORDER BY name

	OPEN cTable
	FETCH cTable INTO @OID, @ID

	WHILE @@FETCH_STATUS=0 BEGIN

		IF UPPER(@ID) = 'COLUMNS' SET @ID = SUBSTRING(@ID, 1, LEN(@ID)-1)

		PRINT 
'	public partial class ' + @ID + ' : dbscriptlib.DAL.BaseTable
	{
		public ' + @ID + '()
		{
		}

		public ' + @ID + '(IDataReader dr)
			: base(dr)
		{
		}

		protected override string TableName { get { return "' + @ID + '"; } }'
		
		DECLARE @colID VARCHAR(50), @colDataType VARCHAR(50), @colLength INT
		DECLARE @colNullable BIT, @colIdentity BIT, @colComputed BIT
		DECLARE @colNetType VARCHAR(50)
		DECLARE @colIdentityName VARCHAR(50)

		SET @colIdentityName = NULL

		DECLARE cCol CURSOR LOCAL READ_ONLY FORWARD_ONLY FOR

SELECT     dbo.syscolumns.name AS ID, 
		dbo.systypes.name AS DataType, 
                      CASE WHEN systypes.status = 0 THEN NULL 
                      WHEN dbo.systypes.name = 'nvarchar' THEN dbo.syscolumns.length / 2 
			ELSE dbo.syscolumns.length END AS Length,
                      syscolumns.isnullable AS IsNullable,
COLUMNPROPERTY (syscolumns.id, syscolumns.name, 'IsIdentity') as IsIdentity,
COLUMNPROPERTY (syscolumns.id, syscolumns.name, 'IsComputed') as IsComputed
--dbo.syscolumns.id AS TBL_OID, 
FROM         dbo.syscolumns INNER JOIN
                      dbo.systypes ON dbo.syscolumns.xtype = dbo.systypes.xtype
WHERE     syscolumns.id = @OID AND systypes.name <> 'sysname'
ORDER BY syscolumns.colid

		OPEN cCol
		FETCH cCol INTO @colID, @colDataType, @colLength, @colNullable, @colIdentity, @colComputed

		WHILE @@FETCH_STATUS=0 BEGIN

			IF @colNullable = 1
				SELECT @colNetType = CASE @colDataType
					WHEN 'int' THEN 'int?'
					WHEN 'bigint' THEN 'long?'
					WHEN 'bit' THEN 'bool?'
					WHEN 'nvarchar' THEN 'string'
					WHEN 'varchar' THEN 'string'
					WHEN 'ntext' THEN 'string'
					WHEN 'text' THEN 'string'
					WHEN 'datetime' THEN 'DateTime?'
					ELSE @colDataType
				END
			ELSE
				SELECT @colNetType = CASE @colDataType
					WHEN 'int' THEN 'int'
					WHEN 'bigint' THEN 'long'
					WHEN 'bit' THEN 'bool'
					WHEN 'nvarchar' THEN 'string'
					WHEN 'varchar' THEN 'string'
					WHEN 'ntext' THEN 'string'
					WHEN 'text' THEN 'string'
					WHEN 'datetime' THEN 'DateTime'
					ELSE @colDataType
				END

			IF @colIdentity = 1
				SET @colIdentityName = @colID

			PRINT	
'		public ' + @colNetType + ' ' + @colID + '
		{
			get { return GetColumnValue<' + @colNetType + '>(Columns.' + @colID + '); }'
			IF @colIdentity = 0 AND @colComputed = 0
				PRINT	'			set { SetColumnValue(Columns.' + @colID + ', value); }'
			PRINT	'		}'

			FETCH cCol INTO @colID, @colDataType, @colLength, @colNullable, @colIdentity, @colComputed
		END

		CLOSE cCol

		IF @colIdentityName IS NOT NULL
			PRINT '		protected override string IdentityColumn { get { return "' + @colIdentityName + '"; } }'

		PRINT '		public static class Columns
		{'

		OPEN cCol
		FETCH cCol INTO @colID, @colDataType, @colLength, @colNullable, @colIdentity, @colComputed

		WHILE @@FETCH_STATUS=0 BEGIN

			PRINT	'			public static string ' + @colID + ' = "' + @colID + '";';

			FETCH cCol INTO @colID, @colDataType, @colLength, @colNullable, @colIdentity, @colComputed
		END

		CLOSE cCol
		DEALLOCATE cCol

	PRINT	'		}'

	PRINT	'		public static List<' + @ID + '> GetRecords(IDataReader dr)
		{
			return GetRecords<' + @ID + '>(dr);
		}
		public static List<' + @ID + '> GetRecords(SqlConnection conn, string sSelect)
		{
			return GetRecords<' + @ID + '>(conn, sSelect);
		}
	}'

		FETCH cTable INTO @OID, @ID
	END

	PRINT	'}'
GO
PRINT 'CREATE PROCEDURE dbo.dev_Generate_Model'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS OFF
GO

CREATE   PROCEDURE [dbo].[dev_Generate_Model]  AS

--	IF @NameSpace IS NOT NULL BEGIN
		PRINT	'namespace Model'
		PRINT	'{'
--	END

	DECLARE @OID INT, @ID VARCHAR(50), @HasLog BIT, @SysColID INT

	PRINT '/*'
	PRINT '	Klassendefinition fr Datenmodell '
	PRINT '	automatisch erzeugt durch dev_Generate_Model'
	PRINT '	' + CONVERT(VARCHAR, GETDATE(), 120)
	PRINT '*/'
	PRINT ''

	DECLARE cTable CURSOR LOCAL READ_ONLY FORWARD_ONLY FOR
	SELECT sysobjects.id, sysobjects.name
	FROM sysobjects 
	WHERE	xtype='U' AND name<>'dtproperties'
	ORDER BY name

	OPEN cTable
	FETCH cTable INTO @OID, @ID

	WHILE @@FETCH_STATUS=0 BEGIN

		PRINT '	public class ' + @ID + ': deviolib.DataModel.Table
	{'

		DECLARE @colID VARCHAR(50), @colDataType VARCHAR(50), @colLength INT
		DECLARE @bFirst BIT

		DECLARE cCol CURSOR LOCAL READ_ONLY FORWARD_ONLY FOR

SELECT     dbo.syscolumns.name AS ID, 
		dbo.systypes.name AS DataType, 
                      CASE WHEN systypes.status = 0 THEN NULL 
                      WHEN dbo.systypes.name = 'nvarchar' THEN dbo.syscolumns.length / 2 
			ELSE dbo.syscolumns.length END AS Length
--dbo.syscolumns.id AS TBL_OID, 
--                      syscolumns.isnullable AS IsNullable
FROM         dbo.syscolumns INNER JOIN
                      dbo.systypes ON dbo.syscolumns.xtype = dbo.systypes.xtype
WHERE     syscolumns.id = @OID AND systypes.name <> 'sysname'
ORDER BY syscolumns.colid
--(dbo.systypes.status IN (0, 2))


/*		SELECT	V_Meta_Column.ID, V_Meta_Column.DataType, V_Meta_Column.Length
		FROM  	V_Meta_Table 
		INNER JOIN V_Meta_Column ON V_Meta_Column.TBL_OID = V_Meta_Table.OID 
		--INNER JOIN EETableCol ON V_Meta_Column.ID = EETableCol.ID AND EETableCol.TBL_OID = @OID
		WHERE	V_Meta_Table.ID = @ID
		ORDER BY V_Meta_Column.OID*/

		/*OPEN cCol
		FETCH cCol INTO @colID, @colDataType, @colLength

		WHILE @@FETCH_STATUS=0 BEGIN

			PRINT	'		static private deviolib.DataModel.Column col' + @colID + 
				'	= new deviolib.DataModel.Column("' + @colID + '");'

			FETCH cCol INTO @colID, @colDataType, @colLength
		END

		CLOSE cCol*/

		PRINT '
		public ' + @ID + '() : base("' + @ID + '")	{}
		static public string TableName	{	get	{	return "' + @ID + '";	}	}

'

		OPEN cCol
		FETCH cCol INTO @colID, @colDataType, @colLength

		WHILE @@FETCH_STATUS=0 BEGIN

			IF @colID = @ID
				PRINT	'		static public deviolib.DataModel.Column ' + @colID + 
				'_	{	get	{	return new deviolib.DataModel.Column("' + @colID + '");	}	}'
			ELSE
				PRINT	'		static public deviolib.DataModel.Column ' + @colID + 
				'	{	get	{	return new deviolib.DataModel.Column("' + @colID + '");	}	}'

			FETCH cCol INTO @colID, @colDataType, @colLength
		END

		CLOSE cCol
		DEALLOCATE cCol

		PRINT '	}

'	
		FETCH cTable INTO @OID, @ID
	END

	CLOSE cTable
	DEALLOCATE cTable

	/*-- 060515

	--DECLARE @bFirst BIT
	SET @bFirst = 1

	DECLARE cFunc CURSOR LOCAL READ_ONLY FORWARD_ONLY FOR
	SELECT EEFunction.OID, EEFunction.ID
	FROM EEFunction
	ORDER BY EEFunction.ID

	OPEN cFunc 
	FETCH cFunc INTO @OID, @ID

	WHILE @@FETCH_STATUS=0 BEGIN

		IF @bFirst = 1 BEGIN
			PRINT '		public class Functions
	{'
			SET @bFirst = 0
		END

		PRINT '	static public string ' + @ID + '	{	get	{	return	"' + @ID + '";	}	}'

		FETCH cFunc INTO @OID, @ID
	END

	IF @bFirst = 0 BEGIN
			PRINT '	}'
	END*/

	/*IF @NameSpace IS NOT NULL 
		PRINT	'}'*/
	PRINT '}'
GO
PRINT 'CREATE PROCEDURE dbo.dev_Generate_SPWrapper'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE    PROCEDURE [dbo].[dev_Generate_SPWrapper](
	@Class		VARCHAR(50),
	@NameSpace	VARCHAR(50) = NULL
) AS

	DECLARE @sIndent VARCHAR(50)
	SET @sIndent = ''

	PRINT 'using System;
using System.Data;
using System.Data.SqlClient;

'

	IF @NameSpace IS NOT NULL BEGIN
		PRINT	'namespace ' + @NameSpace
		PRINT	'{'
		SET @sIndent = '	'
	END

	PRINT @sIndent + 'internal static class ' + @Class + '
' + @sIndent + '{'

	DECLARE @Proc VARCHAR(50), @Column VARCHAR(50), @Type VARCHAR(50), @Length INT
	--DECLARE @ProcOld VARCHAR(50)
	--SET @ProcOld = ''

	DECLARE cP CURSOR FOR
	SELECT  dbo.sysobjects.name
	FROM 	dbo.sysobjects 
	WHERE	(dbo.sysobjects.name NOT LIKE 'dt[_]%') 
	AND	(dbo.sysobjects.name NOT LIKE 'dev[_]%')
	AND	(dbo.sysobjects.name NOT LIKE 'sp[_]%')
	AND 	(dbo.sysobjects.xtype = 'P') 
	ORDER BY dbo.sysobjects.name

	OPEN cP
	FETCH cP INTO @Proc

	WHILE @@FETCH_STATUS = 0 BEGIN

		PRINT @sIndent + '	public static SqlCommand ' + @Proc + '(SqlConnection conn'

		DECLARE c CURSOR FOR
		SELECT  dbo.syscolumns.name, dbo.systypes.name,
			dbo.syscolumns.length	--, dbo.syscolumns.xprec, dbo.syscolumns.xscale
		FROM 	dbo.sysobjects 
		INNER JOIN dbo.syscolumns ON dbo.sysobjects.id = dbo.syscolumns.id 
		INNER JOIN dbo.systypes ON dbo.syscolumns.xtype = dbo.systypes.xtype
		WHERE	(dbo.sysobjects.name = @Proc) AND (dbo.systypes.name <> N'sysname')
		ORDER BY dbo.sysobjects.name, dbo.syscolumns.colid

		OPEN c
		FETCH c INTO @Column, @Type, @Length

		WHILE @@FETCH_STATUS = 0 BEGIN

			PRINT @sIndent + '		, ' +
				CASE @Type 
					WHEN 'int' THEN 'int?' 
					WHEN 'datetime' THEN 'DateTime?'
					WHEN 'nvarchar' THEN 'string'
					WHEN 'varchar' THEN 'string'
					WHEN 'bit' THEN 'bool?'
					ELSE @Type END +
				' ' + SUBSTRING(@Column, 2, LEN(@Column)-1)

			FETCH c INTO @Column, @Type, @Length
		END
		CLOSE c

		PRINT @sIndent + '	)'
		PRINT @sIndent + '	{'
		PRINT @sIndent + '		SqlCommand cmd = new SqlCommand("' + @Proc + '", conn);'
		PRINT @sIndent + '		cmd.CommandType = CommandType.StoredProcedure;'
		PRINT @sIndent + '		cmd.CommandTimeout = 0;'

		OPEN c
		FETCH c INTO @Column, @Type, @Length

		WHILE @@FETCH_STATUS = 0 BEGIN

			IF @Type='nvarchar' OR @Type='varchar' 
				PRINT @sIndent + '		cmd.Parameters.AddWithValue("' + @Column + '", ' + 
					SUBSTRING(@Column, 2, LEN(@Column)-1) + ' != null ? (object)' + 
					SUBSTRING(@Column, 2, LEN(@Column)-1) + ' : DBNull.Value);'
			ELSE
				PRINT @sIndent + '		cmd.Parameters.AddWithValue("' + @Column + '", ' + 
					SUBSTRING(@Column, 2, LEN(@Column)-1) + '.HasValue ? (object)' + 
					SUBSTRING(@Column, 2, LEN(@Column)-1) + '.Value : DBNull.Value);'
			FETCH c INTO @Column, @Type, @Length
		END
	
		CLOSE c
		DEALLOCATE c

		PRINT @sIndent + '		return cmd;'
		PRINT @sIndent + '	}'

		FETCH cP INTO @Proc
	END


	CLOSE cP
	DEALLOCATE cP

	PRINT @sIndent + '}'

	IF @NameSpace IS NOT NULL BEGIN
		PRINT	'}'
	END
GO
PRINT 'CREATE PROCEDURE dbo.List_Comp_SqlV'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE    PROCEDURE dbo.List_Comp_SqlV(
	@Comp_OID	INT
) AS

	CREATE TABLE #V (
		OID	INT,
		Seq	INT
	)

	INSERT INTO #V (OID, Seq)
	SELECT	ProjectVersion.SqlV_OID, 1
	FROM	Comparison
	INNER JOIN ProjectVersion ON Comparison.PV_OID_Ref = ProjectVersion.OID
	WHERE	Comparison.OID = @Comp_OID
	AND	ProjectVersion.SqlV_OID IS NOT NULL

	INSERT INTO #V (OID, Seq)
	SELECT	ProjectVersion.SqlV_OID, 2
	FROM	Comparison
	INNER JOIN ProjectVersion ON Comparison.PV_OID_Diff = ProjectVersion.OID
	LEFT OUTER JOIN #V ON ProjectVersion.SqlV_OID = #V.OID
	WHERE	Comparison.OID = @Comp_OID
	AND	ProjectVersion.SqlV_OID IS NOT NULL
	AND	#V.OID IS NULL

	/*INSERT INTO #V (OID, Seq)
	SELECT	Project.SqlV_OID, 3
	FROM	Comparison
	INNER JOIN ProjectVersion ON Comparison.PV_OID_Ref = ProjectVersion.OID
	INNER JOIN Project ON ProjectVersion.Proj_OID = Project.OID
	LEFT OUTER JOIN #V ON Project.SqlV_OID = #V.OID
	WHERE	Comparison.OID = @Comp_OID
	AND	Project.SqlV_OID IS NOT NULL
	AND	#V.OID IS NULL*/

	DECLARE @DBE_OID INT		-- 090331

	SELECT	@DBE_OID = Project.DBE_OID
	FROM	Comparison
	INNER JOIN ProjectVersion ON Comparison.PV_OID_Ref = ProjectVersion.OID
	INNER JOIN Project ON ProjectVersion.Proj_OID = Project.OID
	WHERE	Comparison.OID = @Comp_OID
	
	SELECT	SqlVersion.OID, SqlVersion.ID
	FROM	SqlVersion 
	LEFT OUTER JOIN #V ON #V.OID = SqlVersion.OID
	WHERE	SqlVersion.DBE_OID = @DBE_OID
	ORDER BY ISNULL(#V.Seq, 10), SqlVersion.OID
GO
PRINT 'CREATE PROCEDURE dbo.List_Compare_Result_Hier'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE            PROCEDURE [dbo].[List_Compare_Result_Hier](
	@Comp_OID	INT
) AS
BEGIN
	SET NOCOUNT ON;

	SELECT DISTINCT ObjT_OID, ObjT_ID
	FROM	V_Compare_Result
	INNER JOIN ObjectType ON V_Compare_Result.ObjT_OID = ObjectType.OID
	WHERE	Comp_OID = @Comp_OID
	AND	ObjectType.OTT_OID IN (1, 4)
	AND	V_Compare_Result.DiffMode IS NOT NULL
	ORDER BY ObjT_OID

	SELECT  V_Compare_Result.ObjT_OID, V_Compare_Result.ObjT_ID, V_Compare_Result.Obj_OID, 
		V_Compare_Result.OwnerName, V_Compare_Result.ID, 
		V_Compare_Result.DiffText,
		--CASE WHEN V_Compare_Result.Diffs = ':' THEN NULL ELSE V_Compare_Result.Diffs END AS Diffs,
		V_Compare_Result.DiffMode, V_Compare_Result.InScript, V_Compare_Result.CObj_OID,
		V_Compare_Result.ColumnsChanged, V_Compare_Result.ChildrenChanged,
		Comparison_Object.Scr_OID, Script.ID AS Scr_ID
	FROM	V_Compare_Result
	INNER JOIN ObjectType ON V_Compare_Result.ObjT_OID = ObjectType.OID
	LEFT OUTER JOIN Comparison_Object ON V_Compare_Result.CObj_OID = Comparison_Object.OID
	LEFT OUTER JOIN Script ON Comparison_Object.Scr_OID = Script.OID
	WHERE	V_Compare_Result.Comp_OID = @Comp_OID
	AND	V_Compare_Result.DiffMode IS NOT NULL
	AND	ObjectType.OTT_OID IN (1, 4)
	ORDER BY V_Compare_Result.ObjT_OID, V_Compare_Result.OwnerName, V_Compare_Result.ObjT_ID, V_Compare_Result.ID

	SELECT  V_Compare_Result.ObjT_OID AS ObjT_OID, V_Compare_Result.ObjT_ID AS ObjT_ID, Object.Obj_OID_Parent AS Tbl_OID,
		--V_Compare_Result.Obj_OID, 
		V_Compare_Result.OwnerName AS OwnerName, V_Compare_Result.ID AS ID, V_Compare_Result.DiffText, 
		V_Compare_Result.DiffMode, CONVERT(BIT, V_Compare_Result.InScript) AS InScript, V_Compare_Result.CObj_OID,
		NULL AS CCol_OID
	FROM	V_Compare_Result
	INNER JOIN Object ON V_Compare_Result.Obj_OID = Object.OID
	INNER JOIN ObjectType ON V_Compare_Result.ObjT_OID = ObjectType.OID
	--INNER JOIN V_Compare_Result AS TblRes ON TblRes.OID = Object.Obj_OID_Parent
	WHERE	V_Compare_Result.Comp_OID = @Comp_OID
	AND	ObjectType.OTT_OID = 0
	/*AND	V_Compare_Result.DiffMode IS NOT NULL
	AND	V_Compare_Result.DiffMode <> 2*/
	AND	ISNULL(V_Compare_Result.DiffMode, 2) IN (0, 1)
	--AND	TblRes.DiffMode <> 1
--	ORDER BY ObjT_OID, ObjT_ID, OwnerName, ID

	UNION ALL

	SELECT  ObjectType.OID AS ObjT_OID, ObjectType.ID AS ObjT_ID, V_CompCol_Result.Obj_OID AS Tbl_OID, 
			V_CompCol_Result.OwnerName, --V_CompCol_Result.ID, 
			V_CompCol_Result.Col_ID AS ID, 
			V_CompCol_Result.DiffText, V_CompCol_Result.DiffMode, V_CompCol_Result.InScript, 
			V_CompCol_Result.CObj_OID, V_CompCol_Result.CCol_OID
	FROM	V_CompCol_Result
	INNER JOIN V_Compare_Result ON V_CompCol_Result.CObj_OID = V_Compare_Result.CObj_OID
	CROSS JOIN ObjectType
	WHERE	V_CompCol_Result.Comp_OID = @Comp_OID
	AND	V_Compare_Result.DiffMode IS NOT NULL
	AND	V_CompCol_Result.DiffMode IS NOT NULL
	AND	V_CompCol_Result.Obj_OID IS NOT NULL
	AND	ObjectType.OID = 20		-- columns, was: OTT_OID = 2; adjust for edmx according to PV.DBE_OID
	AND	V_Compare_Result.DiffMode <> 1

	ORDER BY ObjT_OID DESC, ObjT_ID, OwnerName, Tbl_OID, ID

END
GO
PRINT 'CREATE PROCEDURE dbo.List_Diagram_Objects'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE        PROCEDURE [dbo].[List_Diagram_Objects](
	@PV_OID		INT,
	@DiaT_OID	INT,
	@OS_OID		INT
) AS

	CREATE TABLE #Object (
		OID		INT IDENTITY(1,1) NOT NULL PRIMARY KEY,
		objid		INT NOT NULL,
		schemaname	SYSNAME,
		name		SYSNAME NOT NULL,
		graphid 	INT NULL,
		levelid 	INT NULL,
		maxlevelid	INT NULL,
		temp		INT NULL
	)
	
	CREATE TABLE #FK (
		objid		INT,
		objid_parent	INT,
		objid_ref	INT,
		is_in_cycle	BIT DEFAULT (0)
	)
	
	IF @DiaT_OID = 1 BEGIN		-- DD

		INSERT INTO #FK (objid, objid_parent, objid_ref)
		SELECT DISTINCT Object.OID, Object_Column.Obj_OID, Object_Column.Obj_OID_Ref
		FROM	Object 
		INNER JOIN Object_Column ON Object.OID = Object_Column.Obj_OID_Rel 
		INNER JOIN Object AS O ON Object_Column.Obj_OID_Ref = O.OID
		INNER JOIN V_PV_OS_Obj OSO ON O.PV_OID = OSO.PV_OID AND O.OID = OSO.Obj_OID AND OSO.OS_OID = ISNULL(@OS_OID, 0)
		WHERE	Object.ObjT_OID = 10 AND Object.PV_OID = @PV_OID
		
		INSERT INTO #Object (objid, schemaname, name)
		SELECT O.OID, O.OwnerName, O.ID 
		FROM Object O 
		INNER JOIN V_PV_OS_Obj OSO ON O.PV_OID = OSO.PV_OID AND O.OID = OSO.Obj_OID AND OSO.OS_OID = ISNULL(@OS_OID, 0)
		where O.PV_OID = @PV_OID AND O.ObjT_OID = 1
	END

	-- 090920 calc cycles
	CREATE TABLE #cgraph(
		oid int identity(1,1) not null primary key,
		seq int,
		obj_oid int,
		fk_oid int,
		obj_oid_next int,
		obj_oid_root int,
		is_cycle bit default (0)
	)

	insert into #cgraph (seq, obj_oid, obj_oid_root, fk_oid, obj_oid_next) 
	select distinct 1, #object.objid, #object.objid, #fk.objid, #fk.objid_ref
	from #object
	inner join #fk on #object.objid = #fk.objid_parent

	declare @seq int, @rc int
	set @seq = 1
	set @rc = 1

	while @rc > 0 begin

		update #cgraph
		set	is_cycle = 1
		where obj_oid_root = obj_oid_next
		and	seq = @seq
	
		insert into #cgraph (seq, obj_oid, obj_oid_root, fk_oid, obj_oid_next) 
		select distinct @seq + 1, #fk.objid_parent, #cgraph.obj_oid_root, #fk.objid, #fk.objid_ref
		from #cgraph
		inner join #fk on #cgraph.obj_oid_next = #fk.objid_parent
		left outer join #cgraph ex on ex.obj_oid_root = #cgraph.obj_oid_root and ex.fk_oid = #fk.objid
		where #cgraph.is_cycle = 0
		and #cgraph.seq = @seq
		and ex.oid is null
	
		set @rc = @@rowcount
	
		--print convert(varchar, @seq) + ': ' + convert(varchar, @rc)
		set @seq = @seq + 1
	end

	--select * from #cgraph where #cgraph.is_cycle = 1

	update #fk
	set is_in_cycle = 1
	from	#fk
	inner join #cgraph on #cgraph.fk_oid = #fk.objid
	where #cgraph.is_cycle = 1
	-- 090920 end calc cycles


	-- graph base level
	UPDATE	#Object 
	SET	levelid = 0
	FROM	#Object
	LEFT OUTER JOIN #FK fk ON #Object.objid = fk.objid_parent
		AND fk.is_in_cycle = 0		-- 090922
	WHERE	fk.objid IS NULL 
	
	DECLARE @c INT
	
	WHILE 1=1 BEGIN
		SELECT @c = COUNT(OID) FROM #Object WHERE levelid IS NULL
	
		UPDATE #Object 
		SET levelid = (
			SELECT MAX(g.levelid)+1
			FROM	#Object o
			INNER JOIN #FK fk ON fk.objid_parent = o.objid
				AND fk.is_in_cycle = 0
			INNER JOIN #Object g ON fk.objid_ref = g.objid AND g.levelid IS NOT NULL
			WHERE	o.objid = #Object.objid
			AND NOT EXISTS (
				SELECT * 
				FROM	#FK fkother 
				LEFT OUTER JOIN #Object gother ON fkother.objid_ref = gother.objid AND gother.levelid IS NOT NULL
				WHERE	fkother.is_in_cycle = 0
				AND	fkother.objid_parent = fk.objid_parent 
				AND	gother.oid IS NULL
			)
			AND o.levelid IS NULL	
			GROUP BY fk.objid_parent, o.name
		)
		WHERE	levelid IS NULL
	
		IF @@ROWCOUNT=0 BREAK
	
		IF @c = (SELECT COUNT(OID) FROM #Object WHERE levelid IS NULL) BREAK
	END
	
	DECLARE @graphid INT, @oid INT, @rc1 INT, @rc2 INT
	SET @graphid = 0
	
	WHILE EXISTS(SELECT * FROM #Object WHERE graphid IS NULL) 
	BEGIN
		SET @graphid = @graphid + 1
	
		SELECT TOP 1 @oid = oid FROM #Object WHERE graphid IS NULL ORDER BY levelid DESC
	
		UPDATE	#Object
		SET	graphid = @graphid
		WHERE	oid = @oid
	
		SET @rc1 = 1 SET @rc2 = 0
	
		WHILE @rc1 > 0 OR @rc2 > 0
		BEGIN
			UPDATE	#Object	-- up
			SET	graphid = @graphid
			WHERE	objid IN (
				SELECT	objid_ref 
				FROM #FK fk
				INNER JOIN #Object g ON fk.objid_parent = g.objid
				WHERE g.graphid = @graphid
			)
			AND	graphid IS NULL
	
			SET @rc1 = @@ROWCOUNT
	
			UPDATE	#Object	-- down
			SET	graphid = @graphid
			WHERE	objid IN (
				SELECT fk.objid_parent 
				FROM	#FK fk
				INNER JOIN #Object g ON fk.objid_ref = g.objid
				WHERE g.graphid = @graphid
			)
			AND	graphid IS NULL
	
			SET @rc1 = @rc1 + @@ROWCOUNT
		END
	END
	
	UPDATE	#object
	SET	maxlevelid = levelid
	
	WHILE 1=1
	BEGIN
		UPDATE	#object 
		SET	temp = NULL
	
		UPDATE	#object
		SET	temp = (
			SELECT	MIN(obj2.maxlevelid-1)
			FROM	Object o 
			LEFT OUTER JOIN #FK fk
				INNER JOIN #object obj2 ON fk.objid_parent = obj2.objid
				ON fk.objid_ref = #object.objid
				AND fk.is_in_cycle = 0
			WHERE o.oid = #object.objid
			)
		FROM	#object
		INNER JOIN #FK fk ON fk.objid_ref = #object.objid
	
		UPDATE	#object 
		SET	maxlevelid = temp
		WHERE	ISNULL(temp, maxlevelid)<>maxlevelid
	
		IF @@ROWCOUNT=0 BREAK
	END
	
	SELECT	#object.objid, #object.graphid, #object.levelid, #object.maxlevelid, #object.temp, #object.schemaname, #object.name, min(obj2.maxlevelid-1), max(obj2.maxlevelid-1)
	FROM	#object
	LEFT OUTER JOIN #FK fk
		INNER JOIN #object obj2 ON fk.objid_parent = obj2.objid
		ON fk.objid_ref = #object.objid
	GROUP BY #object.objid, #object.graphid, #object.levelid, #object.maxlevelid, #object.temp, #object.schemaname, #object.name
	ORDER BY #object.graphid, #object.maxlevelid desc, #object.levelid desc, #object.schemaname, #object.name
GO
PRINT 'CREATE PROCEDURE dbo.List_Diagram_Relations'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE    PROCEDURE dbo.List_Diagram_Relations(
	@PV_OID		INT,
	@DiaT_OID	INT,
	@OS_OID		INT
) AS

	IF @DiaT_OID = 1 BEGIN		-- DD

		SELECT DISTINCT Object_Column.Obj_OID parent_object_id, Object_Column.Obj_OID_Ref referenced_object_id
		FROM	Object 
		INNER JOIN	Object_Column ON Object.OID = Object_Column.Obj_OID_Rel 
		INNER JOIN	Object AS Object_1 ON Object_Column.Obj_OID_Ref = Object_1.OID
		WHERE	Object.ObjT_OID = 10 AND Object.PV_OID = @PV_OID

	END
GO
PRINT 'CREATE PROCEDURE dbo.List_MultiComparison_Result'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE PROCEDURE dbo.List_MultiComparison_Result(
	@MComp_OID INT
) AS

	CREATE TABLE #PV (
		Seq	INT IDENTITY(1,1),
		PV_OID	INT,
		ID	NVARCHAR(50)
	)
	
	INSERT INTO #PV (PV_OID, ID)
	SELECT 	V_ProjectVersion.OID, V_ProjectVersion.PV_ID
	FROM MultiComparison_ProjectVersion
	INNER JOIN V_ProjectVersion ON MultiComparison_ProjectVersion.PV_OID = V_ProjectVersion.OID
	WHERE 	MultiComparison_ProjectVersion.MComp_OID = @MComp_OID
	ORDER BY V_ProjectVersion.SortDate 
	
	SELECT * FROM #PV
	ORDER BY Seq
	
	CREATE TABLE #Comp (
		Seq	INT,
		Comp_OID	INT,
		ID	NVARCHAR(50)
	)
	
	INSERT INTO #Comp (Seq, Comp_OID, ID)
	SELECT PVRef.Seq -1, Comparison.OID, Comparison.ID
	FROM Comparison
	INNER JOIN #PV PVRef ON Comparison.PV_OID_Ref = PVRef.PV_OID
	INNER JOIN #PV PVDiff ON Comparison.PV_OID_Diff = PVDiff.PV_OID
		AND PVRef.Seq - 1 = PVDiff.Seq
	WHERE Comparison.MComp_OID = @MComp_OID
	
	SELECT * FROM #Comp 
	ORDER BY Seq
	
	CREATE TABLE #Obj (
		ObjT_OID	INT,
		ObjN_OID	INT,
		ID	NVARCHAR(128),
		ObjN_OID_Parent	INT,
		PV_Seq_Min	INT,
		PV_Seq_Max	INT,
		Comp_Seq_Min	INT,
		Comp_Seq_Max	INT
	)
	
	SELECT	ISNULL(ORef.ObjT_OID, ODiff.ObjT_OID) AS ObjT_OID, 
		ISNULL(ORef.ObjN_OID, ODiff.ObjN_OID) AS ObjN_OID, 
		ISNULL(ORef.ID, ODiff.ID) AS ID,
		PVDiff.Seq AS PVDiffSeq, PVRef.Seq AS PVRefSeq, 
		#Comp.Seq AS CompSeq, 
		Comparison_Object.DiffMode, Comparison_Object.DiffText,
		Comparison_Object.ColumnsChanged AS ColChg, 
		Comparison_Object.ChildrenChanged AS ChiChg,
		ObjectType.ID AS ObjT_ID
	FROM Comparison
	INNER JOIN #Comp on Comparison.OID = #Comp.Comp_OID
	INNER JOIN Comparison_Object ON Comparison.OID = Comparison_Object.Comp_OID
	LEFT OUTER JOIN Object ORef 
		INNER JOIN #PV PVRef ON ORef.PV_OID = PVRef.PV_OID
		ON Comparison_Object.Obj_OID_REF = ORef.OID 
	LEFT OUTER JOIN Object ODiff 
		INNER JOIN #PV PVDiff ON ODiff.PV_OID = PVDiff.PV_OID
		ON Comparison_Object.Obj_OID_Diff = ODiff.OID
	INNER JOIN ObjectType ON ObjectType.OID = ISNULL(ORef.ObjT_OID, ODiff.ObjT_OID)
	WHERE 	Comparison.MComp_OID = @MComp_OID
	AND 	ObjectType.OTT_OID IN (1,4)
	ORDER BY 1, 3, 6	-- objt_oid, id, compseq

/*drop table #pv
drop table #Comp
drop table #obj*/
GO
PRINT 'CREATE PROCEDURE dbo.List_OS_OSOs'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE    PROCEDURE [dbo].[List_OS_OSOs](
	@OS_OID	INT,
	@PV_OID INT	-- 090102 bug 729
) AS

	SELECT	ObjectSelection_ObjectType.OID, ObjectType.ID, ObjectSelection_ObjectType.Include
	FROM	ObjectSelection_ObjectType
	INNER JOIN ObjectType ON ObjectSelection_ObjectType.ObjT_OID = ObjectType.OID
	WHERE	ObjectSelection_ObjectType.OS_OID = @OS_OID
	ORDER BY ObjectType.OID

	IF @PV_OID IS NULL

		SELECT	ObjectSelection_Object.OID, ObjectSelection_Object.OSOT_OID,
			Object.ID AS Obj_ID, ObjectName.ID AS ObjN_ID
		FROM	ObjectSelection_Object
		INNER JOIN ObjectSelection_ObjectType ON ObjectSelection_Object.OSOT_OID = ObjectSelection_ObjectType.OID
		LEFT OUTER JOIN V_Object Object ON ObjectSelection_Object.Obj_OID = Object.OID
		LEFT OUTER JOIN V_ObjectName ObjectName ON ObjectSelection_Object.ObjN_OID = ObjectName.OID
		WHERE	ObjectSelection_ObjectType.OS_OID = @OS_OID
		ORDER BY ObjectSelection_ObjectType.ObjT_OID, ObjectName.ID

	ELSE

		SELECT	ObjectSelection_Object.OID, ObjectSelection_Object.OSOT_OID,
			Object.ID AS Obj_ID, ObjectName.ID AS ObjN_ID
		FROM	ObjectSelection_Object
		INNER JOIN ObjectSelection_ObjectType ON ObjectSelection_Object.OSOT_OID = ObjectSelection_ObjectType.OID
		LEFT OUTER JOIN V_Object Object ON ObjectSelection_Object.Obj_OID = Object.OID
		LEFT OUTER JOIN V_ObjectName ObjectName ON ObjectSelection_Object.ObjN_OID = ObjectName.OID
		INNER JOIN Object PVObject 
			ON PVObject.PV_OID = @PV_OID
			AND (PVObject.OID = ObjectSelection_Object.Obj_OID OR PVObject.ObjN_OID = ObjectSelection_Object.ObjN_OID)
		WHERE	ObjectSelection_ObjectType.OS_OID = @OS_OID
	--	AND	PVObject.OID IS NOT NULL
		ORDER BY ObjectSelection_ObjectType.ObjT_OID, ObjectName.ID
GO
PRINT 'CREATE PROCEDURE dbo.List_Proj_Stat'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE            PROCEDURE dbo.List_Proj_Stat(
	@Proj_OID	INT,
	@User_OID	INT,
	@ListAll	INT
) AS

	DECLARE @DBE_OID INT
	SELECT	@DBE_OID = DBE_OID FROM Project WHERE OID = @Proj_OID

	CREATE TABLE #T (
		OID	INT,
		ID	NVARCHAR(50),
		CountIDs INT,
		Code	VARCHAR(50)
	)

	DECLARE @B BIT
	SET @B = 0
	IF @ListAll = 1 OR
	   (SELECT COUNT(OID) FROM Databases WHERE Proj_OID = @Proj_OID) > 0 
		SET @B = 1

	IF @DBE_OID NOT IN (4, 5)
		INSERT INTO #T (OID, ID, CountIDs, Code)
		SELECT	10, 'Databases', COUNT(OID), 'db'
		FROM	Databases
		WHERE	Proj_OID = @Proj_OID

	IF @B = 1 BEGIN
		INSERT INTO #T (OID, ID, CountIDs, Code)
		SELECT	10, 'Live Databases', COUNT(OID), 'db-live'
		FROM	Databases
		WHERE	Proj_OID = @Proj_OID
		AND	IsEnabled = 1
	END

	INSERT INTO #T (OID, ID, CountIDs, Code)
	SELECT	15, 'Branches', COUNT(OID), 'br'
	FROM	Branch
	WHERE	Proj_OID = @Proj_OID
	
	IF @B = 1 OR @DBE_OID IN (4, 5)
		INSERT INTO #T (OID, ID, CountIDs, Code)
		SELECT	20, 'Versions', COUNT(OID), 'pv'
		FROM	V_ProjectVersion_User 
		WHERE	Proj_OID = @Proj_OID
		AND	User_OID_Filter = @User_OID

	IF @B = 1 BEGIN
		--IF @DBE_OID = 1
			INSERT INTO #T (OID, ID, CountIDs, Code)
			SELECT	30, 'Comparisons', COUNT(OID), 'comp'
			FROM	V_Comparison_User_Standard
			WHERE	Proj_OID = @Proj_OID
			AND	User_OID_Filter = @User_OID

		--IF @DBE_OID = 1
			INSERT INTO #T (OID, ID, CountIDs, Code)
			SELECT	31, 'Multi-Comparisons', COUNT(OID), 'mcomp'
			FROM	MultiComparison
			WHERE	Proj_OID = @Proj_OID
			--AND	User_OID_Filter = @User_OID

		/*FROM	ProjectVersion
		INNER JOIN Comparison ON ProjectVersion.OID = Comparison.PV_OID_Ref
		WHERE	ProjectVersion.Proj_OID = @Proj_OID*/
		
		--IF @DBE_OID = 1
			INSERT INTO #T (OID, ID, CountIDs, Code)
			SELECT	50, 'Saved Scripts', COUNT(OID), 'st'
			FROM	ScriptText
			WHERE	Proj_OID = @Proj_OID

		INSERT INTO #T (OID, ID, CountIDs, Code)
		SELECT	70, 'Documentation Generators', COUNT(OID), 'dg'
		FROM	V_DocGen_User
		WHERE	Proj_OID = @Proj_OID
		AND	User_OID_Filter = @User_OID

		INSERT INTO #T (OID, ID, CountIDs, Code)
		SELECT	170, 'Table Names', COUNT(OID), 'tbln'
		FROM	ObjectName
		WHERE	Proj_OID = @Proj_OID
		AND	ObjT_OID = 1

		INSERT INTO #T (OID, ID, CountIDs, Code)
		SELECT	180, 'Object Names', COUNT(OID), 'objn'
		FROM	ObjectName
		WHERE	Proj_OID = @Proj_OID
	END

	IF @DBE_OID NOT IN (4, 5) BEGIN

		--IF @DBE_OID = 1
			INSERT INTO #T (OID, ID, CountIDs, Code)
			SELECT	40, 'Value Scripts', COUNT(OID), 'scr'
			FROM	Script
			WHERE	Proj_OID = @Proj_OID


		INSERT INTO #T (OID, ID, CountIDs, Code)
		SELECT	60, 'Object Selections', COUNT(OID), 'os'
		FROM	ObjectSelection
		WHERE	Proj_OID = @Proj_OID
	END

	INSERT INTO #T (OID, ID, CountIDs, Code)
	SELECT	200, 'Customers', COUNT(OID), 'cust'
	FROM	Customer
	WHERE	Proj_OID = @Proj_OID

	INSERT INTO #T (OID, ID, CountIDs, Code)
	SELECT	210, 'Installations', COUNT(Installation.OID), 'inst'
	FROM	Customer
	INNER JOIN Installation ON Customer.OID = Installation.Cust_OID
	WHERE	Customer.Proj_OID = @Proj_OID

	SELECT	OID, ID, CountIDs, Code
	FROM	#T
	ORDER BY OID

	DROP TABLE #T
GO
PRINT 'CREATE PROCEDURE dbo.List_Project_UpdateInfo'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE    PROCEDURE dbo.List_Project_UpdateInfo(
	@Proj_ID	NVARCHAR(50),
	@PV_UpdateID	NVARCHAR(50)
) AS

/*	CREATE TABLE #PV (
		OID	INT
	)

	DECLARE @Date DATETIME, @Br_OID INT, */

	DECLARE @PV_OID INT, @Proj_OID INT

	SELECT	TOP 1 @Proj_OID = Project.OID, @PV_OID = PV.OID	-- @Br_OID = PV.Br_OID, @Date = VPV.SortDate, 
	FROM	Project 
	LEFT OUTER JOIN ProjectVersion PV ON PV.Proj_OID = Project.OID AND PV.UpdateID = @PV_UpdateID
	LEFT OUTER JOIN V_ProjectVersion VPV ON PV.OID = VPV.OID
	WHERE	ISNULL(Project.UpdateID, Project.ID) = @Proj_ID
	

/*	--SELECT	@PV_OID, @Br_OID, @Date, @Proj_OID

	WHILE @PV_OID IS NOT NULL BEGIN

		SELECT TOP 1 @PV_OID = PV.OID, @Date = ISNULL(PV.SortDate, @Date)
		FROM	V_ProjectVersion PV
		WHERE	PV.Proj_OID = @Proj_OID
		AND	PV.Br_OID = @Br_OID
		AND	PV.SortDate > @Date
		ORDER BY PV.SortDate

		IF @@ROWCOUNT > 0 BEGIN		--@PV_OID IS NOT NULL BEGIN

			INSERT INTO #PV (OID) VALUES (@PV_OID)
		-- SELECT	@PV_OID, @Br_OID, @Date, @Proj_OID
		
		END ELSE BEGIN

			SELECT 	@Br_OID = Br_OID_Merge
			FROM	Branch
			WHERE	OID = @Br_OID

			IF @Br_OID IS NOT NULL BEGIN

				SELECT TOP 1 @PV_OID = PV.OID, @Date = ISNULL(PV.SortDate, @Date)
				FROM	V_ProjectVersion PV
				WHERE	PV.Proj_OID = @Proj_OID
				AND	PV.Br_OID = @Br_OID
				AND	PV.SortDate > @Date
				ORDER BY PV.SortDate

				IF @@ROWCOUNT = 0
					SET @PV_OID = NULL

			END ELSE
				SET @PV_OID = NULL

		-- SELECT	@PV_OID, @Br_OID, @Date, @Proj_OID
		END

	END

	SELECT	ProjectVersion.UpdateID, ProjectVersion.UpdateMessage,
		V_ProjectVersion.SortDate	--, ProjectVersion.*
	FROM	V_ProjectVersion
	INNER JOIN #PV ON V_ProjectVersion.OID = #PV.OID
	INNER JOIN ProjectVersion ON ProjectVersion.OID = #PV.OID
	WHERE	ProjectVersion.UpdateID IS NOT NULL
	ORDER BY V_ProjectVersion.SortDate DESC
*/

	EXEC	List_Project_Updates @Proj_OID, @PV_OID
GO
PRINT 'CREATE PROCEDURE dbo.List_Project_Updates'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE   PROCEDURE [dbo].[List_Project_Updates](
	@Proj_OID	INT,
	@PV_OID		INT
) AS

	IF @Proj_OID IS NOT NULL AND @PV_OID IS NULL BEGIN
		SELECT	TOP 5 ProjectVersion.OID, ProjectVersion.ID, ProjectVersion.UpdateID, ProjectVersion.UpdateMessage,
			V_ProjectVersion.SortDate	
		FROM	V_ProjectVersion
		INNER JOIN ProjectVersion ON V_ProjectVersion.OID = ProjectVersion.OID 
		WHERE	ProjectVersion.Proj_OID = @Proj_OID
		AND	ProjectVersion.UpdateID IS NOT NULL
		ORDER BY V_ProjectVersion.SortDate DESC

		RETURN
	END

	CREATE TABLE #PV (
		OID	INT
	)

	DECLARE @Br_OID INT, @Date DATETIME

	IF @Proj_OID IS NULL AND @PV_OID IS NOT NULL
		SELECT @Proj_OID = Proj_OID FROM ProjectVersion WHERE OID = @PV_OID

	SELECT	TOP 1 @PV_OID = PV.OID, @Br_OID = PV.Br_OID, @Date = VPV.SortDate, @Proj_OID = Project.OID
	FROM	Project 
	LEFT OUTER JOIN ProjectVersion PV ON PV.Proj_OID = Project.OID AND PV.OID = @PV_OID
	LEFT OUTER JOIN V_ProjectVersion VPV ON PV.OID = VPV.OID
	WHERE	Project.OID = @Proj_OID

	--SELECT	@PV_OID, @Br_OID, @Date, @Proj_OID

	WHILE @PV_OID IS NOT NULL BEGIN

		SELECT TOP 1 @PV_OID = PV.OID, @Date = ISNULL(PV.SortDate, @Date)
		FROM	V_ProjectVersion PV
		WHERE	PV.Proj_OID = @Proj_OID
		AND	PV.Br_OID = @Br_OID
		AND	PV.SortDate > @Date
		ORDER BY PV.SortDate

		IF @@ROWCOUNT > 0 BEGIN		--@PV_OID IS NOT NULL BEGIN

			INSERT INTO #PV (OID) VALUES (@PV_OID)
		-- SELECT	@PV_OID, @Br_OID, @Date, @Proj_OID
		
		END ELSE BEGIN

			SELECT 	@Br_OID = Br_OID_Merge
			FROM	Branch
			WHERE	OID = @Br_OID

			IF @Br_OID IS NOT NULL BEGIN

				SELECT TOP 1 @PV_OID = PV.OID, @Date = ISNULL(PV.SortDate, @Date)
				FROM	V_ProjectVersion PV
				WHERE	PV.Proj_OID = @Proj_OID
				AND	PV.Br_OID = @Br_OID
				AND	PV.SortDate > @Date
				ORDER BY PV.SortDate

				IF @@ROWCOUNT = 0
					SET @PV_OID = NULL

			END ELSE
				SET @PV_OID = NULL

		-- SELECT	@PV_OID, @Br_OID, @Date, @Proj_OID
		END

	END

	SELECT	ProjectVersion.OID, ProjectVersion.ID, ProjectVersion.UpdateID, ProjectVersion.UpdateMessage,
		V_ProjectVersion.SortDate	--, ProjectVersion.*
	FROM	V_ProjectVersion
	INNER JOIN #PV ON V_ProjectVersion.OID = #PV.OID
	INNER JOIN ProjectVersion ON ProjectVersion.OID = #PV.OID
	WHERE	ProjectVersion.UpdateID IS NOT NULL
	ORDER BY V_ProjectVersion.SortDate DESC
GO
PRINT 'CREATE PROCEDURE dbo.List_PV_SqlV'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE   PROCEDURE dbo.List_PV_SqlV(
	@PV_OID	INT
) AS 

	CREATE TABLE #V (
		OID	INT,
		Seq	INT
	)

	INSERT INTO #V (OID, Seq)
	SELECT	SqlV_OID, 1
	FROM	ProjectVersion
	WHERE	OID = @PV_OID
	AND	SqlV_OID IS NOT NULL

	/*INSERT INTO #V (OID, Seq)
	SELECT	Project.SqlV_OID, 2
	FROM	Project
	INNER JOIN ProjectVersion ON ProjectVersion.Proj_OID = Project.OID
	WHERE	ProjectVersion.OID = @PV_OID
	AND	Project.SqlV_OID IS NOT NULL*/

	/*INSERT INTO #V (OID, Seq)
	SELECT	OID, 3
	FROM	SqlVersion
	LEFT OUTER JOIN #V ON SqlVersion.OID = #V.OID
	WHERE	#V.OID IS NULL
	ORDER BY SqlVersion.OID*/

	DECLARE @DBE_OID INT		-- 090331

	SELECT	@DBE_OID = Project.DBE_OID
	FROM	ProjectVersion 
	INNER JOIN Project ON ProjectVersion.Proj_OID = Project.OID
	WHERE	ProjectVersion.OID = @PV_OID

	SELECT	SqlVersion.OID, SqlVersion.ID
	FROM	SqlVersion 
	LEFT OUTER JOIN #V ON #V.OID = SqlVersion.OID
	WHERE	SqlVersion.DBE_OID = @DBE_OID
	ORDER BY ISNULL(#V.Seq, 10), SqlVersion.OID
GO
PRINT 'CREATE PROCEDURE dbo.List_Scr_SqlV'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE    PROCEDURE dbo.List_Scr_SqlV(
	@Scr_OID	INT
) AS 

	CREATE TABLE #V (
		OID	INT,
		Seq	INT
	)

	/*INSERT INTO #V (OID, Seq)
	SELECT	SqlV_OID, 1
	FROM	ProjectVersion
	WHERE	OID = @PV_OID
	AND	SqlV_OID IS NOT NULL*/

	/*INSERT INTO #V (OID, Seq)
	SELECT	Project.SqlV_OID, 2
	FROM	Project
	INNER JOIN Script ON Script.Proj_OID = Project.OID
	WHERE	Script.OID = @Scr_OID
	AND	Project.SqlV_OID IS NOT NULL*/

	/*INSERT INTO #V (OID, Seq)
	SELECT	OID, 3
	FROM	SqlVersion
	LEFT OUTER JOIN #V ON SqlVersion.OID = #V.OID
	WHERE	#V.OID IS NULL
	ORDER BY SqlVersion.OID*/

	DECLARE @DBE_OID INT		-- 090331

	SELECT	@DBE_OID = Project.DBE_OID
	FROM	Project
	INNER JOIN Script ON Script.Proj_OID = Project.OID
	WHERE	Script.OID = @Scr_OID

	SELECT	SqlVersion.OID, SqlVersion.ID
	FROM	SqlVersion 
	LEFT OUTER JOIN #V ON #V.OID = SqlVersion.OID
	WHERE	SqlVersion.DBE_OID = @DBE_OID
	ORDER BY ISNULL(#V.Seq, 10), SqlVersion.OID
GO
PRINT 'CREATE PROCEDURE dbo.Search_Objects'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE    PROCEDURE [dbo].[Search_Objects](
	@PV_OID	INT,
	@ObjT_OID	INT,
	@Search	VARCHAR(100)
) AS
BEGIN
	CREATE TABLE #Result(
		OID		INT,
		Result		NVARCHAR(100),
		Expression	NVARCHAR(200)
	)

	IF @Search = '' 
		SET @Search = NULL
	ELSE
		SET @Search = '%' + @Search + '%'

	INSERT INTO #Result (OID, Result, Expression)
	SELECT	OID, 'Name', ID
	FROM	Object
	WHERE	PV_OID = @PV_OID
	AND		ID LIKE @Search

	INSERT INTO #Result (OID, Result, Expression)
	SELECT	OID, 'Description', SUBSTRING(Description, 1, 200)
	FROM	Object
	WHERE	PV_OID = @PV_OID
	AND		Description LIKE @Search

	INSERT INTO #Result (OID, Result, Expression)
	SELECT	OID, 'Code', SUBSTRING(SourceCode, 1, 200)
	FROM	Object
	WHERE	PV_OID = @PV_OID
	AND		SourceCode IS NOT NULL 
	AND		SourceCode LIKE @Search

	INSERT INTO #Result (OID, Result, Expression)
	SELECT	Object.OID, 'Column Name ' + Columns.ID, Columns.ID
	FROM	Object
	INNER JOIN Columns ON Object.OID = Columns.Obj_OID
	WHERE	Object.PV_OID = @PV_OID
	AND		Columns.ID LIKE @Search
	
	INSERT INTO #Result (OID, Result, Expression)
	SELECT	Object.OID, 'Column Data Type Schema ' + Columns.ID, Columns.DataTypeSchema
	FROM	Object
	INNER JOIN Columns ON Object.OID = Columns.Obj_OID
	WHERE	Object.PV_OID = @PV_OID
	AND		Columns.DataTypeSchema LIKE @Search

	INSERT INTO #Result (OID, Result, Expression)
	SELECT	Object.OID, 'Column Data Type ' + Columns.ID, Columns.DataType
	FROM	Object
	INNER JOIN Columns ON Object.OID = Columns.Obj_OID
	WHERE	Object.PV_OID = @PV_OID
	AND		Columns.DataType LIKE @Search

	INSERT INTO #Result (OID, Result, Expression)
	SELECT	Object.OID, 'Column Collation ' + Columns.ID, Columns.CollationName
	FROM	Object
	INNER JOIN Columns ON Object.OID = Columns.Obj_OID
	WHERE	Object.PV_OID = @PV_OID
	AND		Columns.CollationName LIKE @Search

	INSERT INTO #Result (OID, Result, Expression)
	SELECT	Object.OID, 'Column XML Schema Collection Schema ' + Columns.ID, Columns.XmlSchema
	FROM	Object
	INNER JOIN Columns ON Object.OID = Columns.Obj_OID
	WHERE	Object.PV_OID = @PV_OID
	AND		Columns.XmlSchema LIKE @Search

	INSERT INTO #Result (OID, Result, Expression)
	SELECT	Object.OID, 'Column XML Schema Collection ' + Columns.ID, Columns.XmlCollection
	FROM	Object
	INNER JOIN Columns ON Object.OID = Columns.Obj_OID
	WHERE	Object.PV_OID = @PV_OID
	AND		Columns.XmlCollection LIKE @Search

	INSERT INTO #Result (OID, Result, Expression)
	SELECT	Object.OID, 'Column Description ' + Columns.ID, SUBSTRING(Columns.Description, 1, 200)
	FROM	Object
	INNER JOIN Columns ON Object.OID = Columns.Obj_OID
	WHERE	Object.PV_OID = @PV_OID
	AND		Columns.Description LIKE @Search

	/*INSERT INTO #Result (OID, Result, Expression)
	SELECT	Object.OID, 'Column Default Name ' + Columns.ID, Columns.DF Name
	FROM	Object
	INNER JOIN Columns ON Object.OID = Columns.Obj_OID
	WHERE	Object.PV_OID = @PV_OID
	AND		Columns.DF Name LIKE @Search

	INSERT INTO #Result (OID, Result, Expression)
	SELECT	Object.OID, 'Column Default Expression ' + Columns.ID, SUBSTRING(Columns.DF Expr, 1, 200)
	FROM	Object
	INNER JOIN Columns ON Object.OID = Columns.Obj_OID
	WHERE	Object.PV_OID = @PV_OID
	AND		Columns.DF Expr LIKE @Search*/

	SELECT DISTINCT	res.OID, Object.ObjT_OID, ObjectType.ID AS ObjT_ID, res.Result, Object.OwnerName, Object.ID, res.Expression
	FROM	#Result res
	INNER JOIN Object ON res.OID = Object.OID
	INNER JOIN ObjectType ON Object.ObjT_OID = ObjectType.OID
	WHERE	Object.ObjT_OID = ISNULL(@ObjT_OID, Object.ObjT_OID)
	ORDER BY Object.ObjT_OID, Object.ID, res.Result
END
GO
PRINT 'CREATE PROCEDURE dbo.Unassign_CCol'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE  PROCEDURE dbo.Unassign_CCol(
	@CCol_OID	INT
) AS

	INSERT INTO Comparison_Column (CObj_OID, Col_OID_Diff)
	SELECT	CObj_OID, Col_OID_Diff
	FROM	Comparison_Column
	WHERE	OID = @CCol_OID

	UPDATE	Comparison_Column
	SET	Col_OID_Diff = NULL,
		IsUserAssigned = 0
	WHERE	OID = @CCol_OID

	DECLARE @Comp_OID INT

	SELECT	@Comp_OID = Comparison_Object.Comp_OID
	FROM	Comparison_Column
	INNER JOIN Comparison_Object ON Comparison_Column.CObj_OID = Comparison_Object.OID
	WHERE	Comparison_Column.OID = @CCol_OID

	EXEC Calc_Comparison_DiffText @Comp_OID
GO
PRINT 'CREATE PROCEDURE dbo.Unassign_CObj'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE  PROCEDURE dbo.Unassign_CObj(
	@CObj_OID	INT
) AS

	DECLARE @CObj_OID_Diff INT

	INSERT INTO Comparison_Object (Comp_OID, Obj_OID_Diff)
	SELECT	Comp_OID, Obj_OID_Diff
	FROM	Comparison_Object
	WHERE	OID = @CObj_OID

	SELECT	@CObj_OID_Diff = SCOPE_IDENTITY()

	UPDATE	Comparison_Object 
	SET	Obj_OID_Diff = NULL,
		IsUserAssigned = 0
	WHERE	OID = @CObj_OID	

	INSERT INTO Comparison_Column (CObj_OID, Col_OID_Diff)
	SELECT	CObj_OID, Col_OID_Diff
	FROM	Comparison_Column
	WHERE	CObj_OID = @CObj_OID
	AND	Col_OID_Diff IS NOT NULL

	UPDATE	Comparison_Column
	SET	Col_OID_Diff = NULL,
		IsUserAssigned = 0
	WHERE	CObj_OID = @CObj_OID

	DELETE	Comparison_Column
	WHERE	CObj_OID = @CObj_OID
	AND	Col_OID_Diff IS NULL
	AND	Col_OID_Ref IS NULL

	DECLARE @Comp_OID INT

	SELECT	@Comp_OID = Comp_OID
	FROM	Comparison_Object
	WHERE	OID = @CObj_OID

	EXEC Calc_Comparison_DiffText @Comp_OID
GO
PRINT 'CREATE TRIGGER dbo.del_Comparison'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE  TRIGGER del_Comparison ON dbo.Comparison
INSTEAD OF DELETE
AS
	SET NOCOUNT ON

	DELETE 	Comparison_Column
	FROM 	Comparison_Column 
	INNER JOIN Comparison_Object ON Comparison_Column.CObj_OID = Comparison_Object.OID
	INNER JOIN deleted ON Comparison_Object.Comp_OID = deleted.OID

	DELETE 	Comparison_Object
	FROM	Comparison_Object
	INNER JOIN deleted ON Comparison_Object.Comp_OID = deleted.OID

	DELETE 	ScriptText	-- 100123
	FROM	ScriptText
	INNER JOIN deleted ON ScriptText.Comp_OID = deleted.OID

	DELETE	Comparison
	FROM	Comparison
	INNER JOIN deleted ON Comparison.OID = deleted.OID
GO
PRINT 'CREATE TRIGGER dbo.upd_DocGen'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE TRIGGER upd_DocGen ON [dbo].[DocGen] 
FOR UPDATE
AS

	UPDATE DocGenPart
	SET	PVXML = NULL
	FROM	DocGenPart
	INNER JOIN inserted ON DocGenPart.DG_OID = inserted.OID
GO
PRINT 'CREATE TRIGGER dbo.del_MultiComparison'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE TRIGGER del_MultiComparison ON dbo.MultiComparison
INSTEAD OF DELETE
AS
	SET NOCOUNT ON

	DELETE 	Comparison
	FROM 	Comparison
	INNER JOIN deleted ON Comparison.MComp_OID = deleted.OID

	DELETE 	MultiComparison_ProjectVersion
	FROM	MultiComparison_ProjectVersion
	INNER JOIN deleted ON MultiComparison_ProjectVersion.MComp_OID = deleted.OID

	DELETE	MultiComparison
	FROM	MultiComparison
	INNER JOIN deleted ON MultiComparison.OID = deleted.OID
GO
PRINT 'CREATE TRIGGER dbo.del_Object'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE    TRIGGER [del_Object] ON dbo.Object 
INSTEAD OF DELETE 
AS	
	SET NOCOUNT ON 

	CREATE TABLE #Obj (
		OID	INT
	)

	INSERT INTO #Obj (OID)
	SELECT	OID
	FROM	deleted

	INSERT INTO #Obj (OID)
	SELECT	Object.OID
	FROM	Object INNER JOIN deleted ON Object.Obj_OID_Parent = deleted.OID

	DELETE	Object_Column
	FROM	Object_Column INNER JOIN #Obj ON Object_Column.Obj_OID = #Obj.OID

	DELETE	Object_Column
	FROM	Object_Column INNER JOIN #Obj ON Object_Column.Obj_OID_Rel = #Obj.OID

	DELETE	Object_Column
	FROM	Object_Column INNER JOIN #Obj ON Object_Column.Obj_OID_Ref = #Obj.OID

	DELETE	Dependency
	FROM	Dependency INNER JOIN #Obj ON Dependency.Obj_OID = #Obj.OID

	DELETE	Dependency
	FROM	Dependency INNER JOIN #Obj ON Dependency.Obj_OID_DependsOn = #Obj.OID

	DELETE	Property
	FROM	Property INNER JOIN #Obj ON Property.Obj_OID = #Obj.OID

	DELETE	Property
	FROM	Property 
	INNER JOIN Columns ON Property.Col_OID = Columns.OID
	INNER JOIN #Obj ON Columns.Obj_OID = #Obj.OID

	DELETE	Columns
	FROM	Columns INNER JOIN #Obj ON Columns.Obj_OID = #Obj.OID

	DELETE	Object 
	FROM	Object INNER JOIN #Obj ON Object.OID = #Obj.OID
GO
PRINT 'CREATE TRIGGER dbo.del_Project'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE TRIGGER del_Project ON dbo.Project
INSTEAD OF DELETE
AS
	SET NOCOUNT ON

	DELETE	ColumnName
	FROM	ColumnName
	INNER JOIN ObjectName ON ColumnName.ObjN_OID = ObjectName.OID
	INNER JOIN deleted ON ObjectName.Proj_OID = deleted.OID

	DELETE	ObjectName
	FROM 	ObjectName
	INNER JOIN deleted ON ObjectName.Proj_OID = deleted.OID

	DELETE	Project
	FROM	Project
	INNER JOIN deleted ON Project.OID = deleted.OID
GO
PRINT 'CREATE TRIGGER dbo.del_ProjectVersion'

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

CREATE    TRIGGER del_ProjectVersion ON dbo.ProjectVersion
INSTEAD OF DELETE
AS
	SET NOCOUNT ON

	/*DELETE	Columns
	FROM	Columns
	INNER JOIN Object ON Columns.Obj_OID = Object.OID
	INNER JOIN deleted ON Object.PV_OID = deleted.OID*/

	DELETE	Object
	FROM 	Object 
	INNER JOIN deleted ON Object.PV_OID = deleted.OID

	DELETE	ScriptText
	FROM 	ScriptText 
	INNER JOIN deleted ON ScriptText.PV_OID = deleted.OID

	DELETE	ProjectVersion
	FROM	ProjectVersion 
	INNER JOIN deleted ON ProjectVersion.OID = deleted.OID
GO

